	.ORG	0
	.ORG	40h

INT40h:	jp	VBlank
	RETI
	RETI
	RETI
	RETI
	RETI

	.ORG	100h	; Gameboy info area

	NOP		; Gameboy startup code
	JP	Start
	.BYTE	0CEh,0EDh,66h,66h,0CCh,0Dh,0,0Bh,03h,73h,0,83h,0,0Ch,0,0Dh
	.BYTE	0,08h,11h,1Fh,88h,89h,0,0Eh,0DCh,0CCh,6Eh,0E6h,0DDh,0DDh,0D9h,99h
	.BYTE	0BBh,0BBh,67h,63h,6Eh,0Eh,0ECh,0CCh,0DDh,0DCh,99h,9Fh,0BBh,0B9h,33h,3Eh
	.BYTE	"123456789012345"
	.BYTE	0	; CGB ja/nee
	.BYTE	0,0,0	; SGB info
	.BYTE	0h,0,0	; ROM, 32kB ROM, NO RAM
	.BYTE	0	; Non-japanese
	.BYTE	0	; Licensee number
	.BYTE	0	; Version number
	.BYTE	0	; Complement
	.BYTE	0,0	; Checksum ******* klopt niet!

Start:
;*****************************************************************************
;* NINTENDO GAMEBOY - AUDIO-DRIVER                                           *
;* (C) 1993-1999 MANIACS OF NOISE                                                 *
;*****************************************************************************
;* MUSIC & SFX BY        :JEROEN TEL                                         *
;* FORMAT                :NINTENDO GAMEBOY                                   *
;*****************************************************************************
;		*** SPECIFICATIONS ***
;
;
; INITIALISATION FOR ALL CHANNELS: CALL  MAININIT  (GAME-INITIALISATION)
;
; INITIALISATION OF INDIVIDUAL CHANNEL: LD	A,#XX (AUDIO-NUMBER)
;					CALL	AUDIOIN0-AUDIOIN3
;
; PLAY AN INDIVIDUAL CHANNEL:		CALL	AUDIOPL0-AUDIOPL3 (V-BLANK)
;
;
; THE MUSIC AND SOUNDEFFECTS ARE SPECIFIED IN THE 'AUDIOTAB'. THE FIRST NUMBER
; INDICATES THE AUDIO-NUMBER. THE SECOND NUMBER STANDS FOR THE CHANNEL-NUMBER
; TO INITIALISE THE AUDIO-PIECE ON.
;
; EXAMPLE:	LD	A,#35	 (THIS NUMBER IS SPECIFIED IN 'AUDIOTAB'
;		CALL	AUDIOIN2 (THE CHANNEL-NUMBER TO INITIALISE).
;
; BEST REGARDS,
;
; JEROEN TEL / MANIACS OF NOISE
;
; HARMONIESTRAAT 77
; 5702 JD HELMOND
; NL
;
; TEL: (+31) - (0)4290-521950
;----------------------------------------------------------------------------

#DEFINE	DUMPA	PUSH	AF
#DEFCONT	\	LD	BC,$0006
#DEFCONT	\	CALL	SETPOS
#DEFCONT	\	POP	AF
#DEFCONT	\	CALL	DUMP_HEX:


#DEFINE	DUMPAFREEZE	PUSH	AF
#DEFCONT	\	LD	BC,$0006
#DEFCONT	\	CALL	SETPOS
#DEFCONT	\	POP	AF
#DEFCONT	\	CALL	DUMP_HEX:
#DEFCONT	\	XOR	A
#DEFCONT	\	LD	[NR52],A
#DEFCONT	\	JP	$0153

;****************************************
;*          RAM ALLOCATION
;****************************************

MBASE	.equ	$DFC0

SCRADD	.equ	MBASE+2	;WORD


;****************************************
;*          CONTROL REGISTERS           *
;****************************************

STOP	.equ	0
AT	.equ	1

BANKSEL	.equ	$3FFF

P1	.equ	$FF00	;KEY PORT

SB	.equ	$FF01	;SERIAL DATA
SC	.equ	$FF02	;SERIAL CONTROL

DIV	.equ	$FF04	;DIVIDER
TIMA	.equ	$FF05	;TIMER
TMA	.equ	$FF06	;TIMER
TAC	.equ	$FF07	;TIMER CONTROLL

IF	.equ	$FF0F	;INTERRUPT FLAG
IE	.equ	$FFFF	;INTERRUPT ENABLE FLAG

NR10	.equ	$FF10	;SOUND REGISTERS FOR CHANNEL 1
NR11	.equ	$FF11
NR12	.equ	$FF12
NR13	.equ	$FF13
NR14	.equ	$FF14

NR21	.equ	$FF16	;SOUND REGISTERS FOR CHANNEL 2
NR22	.equ	$FF17
NR23	.equ	$FF18
NR24	.equ	$FF19

NR30	.equ	$FF1A	;SOUND REGISTERS FOR CHANNEL 3
NR31	.equ	$FF1B
NR32	.equ	$FF1C
NR33	.equ	$FF1D
NR34	.equ	$FF1E

NR41	.equ	$FF20	;SOUND REGISTERS FOR CHANNEL 4
NR42	.equ	$FF21
NR43	.equ	$FF22
NR44	.equ	$FF23

NR50	.equ	$FF24	;CHANNEL OUTPUT CONTROL
NR51	.equ	$FF25
NR52	.equ	$FF26

WAVERAM	.equ	$FF30

LCDC	.equ	$FF40	;LCD CONTROLL
STAT	.equ	$FF41	;LCDC STATUS

SCY	.equ	$FF42	;SCROLL X
SCX	.equ	$FF43	;SCROLL Y

LY	.equ	$FF44	;LCDC Y
LYC	.equ	$FF45	;LCDC Y COMPARE

DMA	.equ	$FF46	;DMA CONTROL

BGP	.equ	$FF47	;BAK PALET
OBP0	.equ	$FF48	;OBJ 0 PALET
OBP1	.equ	$FF49	;OBJ 1 PALET

WY	.equ	$FF4A	;WINDOW X
WX	.equ	$FF4B	;WINDOW Y

;****************************************
;*               VARIABLES              *
;****************************************

AUDIONR	.equ	$FF80	; AUDIO-PIECE SELECTION

IEB	.equ	$FF81


CNT1	.equ	$FF8A	; KEYS DEPRESSED
TRG1	.equ	$FF8B	; KEYS PRESSED THIS FRAME

;****************************************
;*               PLAY AUDIO             *
;****************************************

	CALL	CLS

;               LD      DE,$9C00
;               LD      HL,$9800
;_COPY_01       CALL    WAIT_STAT
;               LD      A,[DE]
;               SUB     $20
;               LD      [HLI],A
;
;		INC	DE
;		BIT	2,H
;               jp      Z,_COPY_01

	xor	a	; CLEAR KEY-BUFFER
	LD	[CNT1],A

	CALL	MAININIT

	LD	A,$01
	CALL	AUDIOIN1
	LD	A,$02
	CALL	AUDIOIN2
	LD	A,$03
	CALL	AUDIOIN3
	LD	A,$04
	CALL	AUDIOIN4

	LD	A,$08
	LD	[AUDIONR],A


MAINLOOP	CALL	VBLANK	; WAIT

	LD	BC,$0000
	CALL	SETPOS
	xor	a
	CALL	DUMP_HEX

	CALL	WAIT_STAT	; CHANGE COLOR
	LD	A,[BGP]
	AND	$FC
	OR	$02
	LD	[BGP],A

	CALL	AUDIOPL1	; PLAY CHANNEL 1
	CALL	AUDIOPL2
	CALL	AUDIOPL3
	CALL	AUDIOPL4

	CALL	WAIT_STAT	; RESTORE COLOR
	LD	A,[BGP]
	AND	$FC
	LD	[BGP],A

	LD	BC,$0910	; SET POS FOR PRTCHR
	CALL	SETPOS

	CALL	CONT	; READ KEYS
	LD	A,[TRG1]
	BIT	3,A	; CHECK "START"
	JP	NZ,DOWNLOAD
	LD	B,A

	LD	A,[AUDIONR]
	BIT	6,B	; CHECK "UP"
	JP	Z,_SKIP1
	INC	A
_SKIP1	BIT	7,B	; CHECK "DOWN"
	JP	Z,_SKIP2
	DEC	A
_SKIP2	LD	[AUDIONR],A

	CALL	DUMP_HEX

	BIT	2,B	; CHECK "SELECT"
	JP	NZ,RESTART

	BIT	1,B	; CHECK "B"
	JP	NZ,FASTPLAY

	BIT	0,B	; CHECK "A"
	JP	NZ,FASTPLAY

	JP	MAINLOOP

DOWNLOAD
 	XOR	A	; SET SOUND OFF
	LD	[NR52],A
	CALL	CLS	; DOWNLOAD MESSAGE		CALL	PRINT
	CALL	PRINT
	.DB	AT,$07
	.DB	"	HELP,	FEED	ME	!!!	",STOP
	JP	$0153	; GO TO DOWNLOADER

RESTART	LD	HL,SFXTAB0	; RESTART AUDIO
	LD	A,[AUDIONR]
	LD	E,A
	LD	D,$00
	ADD	HL,DE
	LD	A,[HL]
;	cp	0
;	jp	z,skiip1
	CALL	AUDIOIN1
skiip1
	LD	HL,SFXTAB1
	LD	A,[AUDIONR]
	LD	E,A
	LD	D,$00
	ADD	HL,DE
	LD	A,[HL]
;	cp	0
;	jp	z,skiip2
	CALL	AUDIOIN2
skiip2
	LD	HL,SFXTAB2
	LD	A,[AUDIONR]
	LD	E,A
	LD	D,$00
	ADD	HL,DE
	LD	A,[HL]
;	cp	0
;	jp	z,skiip3
	CALL	AUDIOIN3
skiip3
	LD	HL,SFXTAB3
	LD	A,[AUDIONR]
	LD	E,A
	LD	D,$00
	ADD	HL,DE
	LD	A,[HL]
;	cp	0
;	jp	z,skiip4
	CALL	AUDIOIN4
skiip4
	JP	MAINLOOP

FASTPLAY	CALL	WAIT_STAT	; CHANGE COLOR
	LD	A,[BGP]
	AND	$3C
	OR	$03
	LD	[BGP],A

_02
	CALL	AUDIOPL1	; FAST FORWARD
	CALL	AUDIOPL2
	CALL	AUDIOPL3
	CALL	AUDIOPL4

	CALL	CONT	; CHECK KEYS
	LD	A,[CNT1]
 		BIT	1,A
	jp	NZ,_02
	BIT	0,A
	jp	NZ,_02

	CALL	WAIT_STAT
	LD	A,[BGP]	; RESTORE COLOR
	AND	$3C
	OR	$C0
	LD	[BGP],A

	JP	MAINLOOP

;****************************************************************************
;*		SUBROUTINES
;****************************************************************************

DUMP_HEX	PUSH	AF
	SWAP	A
	CALL	_01
	POP	AF
_01	AND	$0F
	CP	$0A
	jp	C,_02b
	ADD	A,$07
_02b	ADD	A,$30
	JP	PRCHR

;LCDC_OFF       LD      A,[IE]
;               LD      [IEB],A                 ; SAVE INT ENABLE FLAG
;		RES	0,A			; DISABLE INTERUPT
;               LD      [IE],A
;LCDC_OF10
;               LD      A,[LY]                  ; WAIT V_BLANK [LY=145]
;		CP	145
;		jp	NZ,LCDC_OF10
;
;               LD      A,[LCDC]                ; STOP LCDC
;		AND	%01111111
;               LD      [LCDC],A
;
;               LD      A,[IEB]
;               LD      [IE],A                  ; ENABLE INTERUPT
;
;		RET


CONT	LD	C,$00	; KEY PORT ADDRESS

	LD	A,$20	; P14 LOW P15 HI
	LD	[C],A
	LD	A,[C]	; DUMMY WAIT
	LD	A,[C]	; DUMMY WAIT
	LD	A,[C]	; READ KEY DATA [L,R,U,D]

	LD	B,A
	LD	A,$10	; P15 LOW P14 HI
	LD	[C],A
	LD	A,B

	AND	$0F
	SWAP	A
	LD	B,A

	LD	A,[C]	; DUMMY WAIT
	LD	A,[C]	; DUMMY WAIT
	LD	A,[C]	; DUMMY WAIT
	LD	A,[C]	; DUMMY WAIT
	LD	A,[C]	; DUMMY WAIT
	LD	A,[C]	; DUMMY WAIT
	LD	A,[C]	; DUMMY WAIT
	LD	A,[C]	; DUMMY WAIT
	LD	A,[C]	; READ DATA [A,B,START,SELECT]

	AND	$0F
	OR	B
	CPL
	LD	B,A	; KEY DATA

	LD	A,$30	; P14 HI P15 HI
	LD	[C],A

	LD	A,[CNT1]
	XOR	B
	AND	B
	LD	[TRG1],A

	LD	A,B
	LD	[CNT1],A

	RET

VBLANK	LD	A,[LY]
	CP	$58	; Y-POS >90 [=VBLANK] ?         jp      CC,@LOOP
	jp	NZ,VBLANK
	RET

;****************************************
;*            CLEAR SCREEN
;****************************************

CLS	LD	HL,$9800
	LD	B,$00
	XOR	A

_LOOP	CALL	WAIT_STAT
	LD	[HLI],A
	LD	[HLI],A
	LD	[HLI],A
	LD	[HLI],A
	DJNZ	_LOOP
	RET

;****************************************
;*          LOCATE CHAR ON MAP
;*                IN BC
;****************************************

CHPOS	LD	L,B
	LD	H,$00
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	LD	B,$00
	ADD	HL,BC
	LD	BC,$9800
	ADD	HL,BC
	RET

;****************************************
;*            SET MAP POSITION
;****************************************

SETPOS	CALL	CHPOS
	LD	A,L
	LD	[SCRADD],A
	LD	A,H
	LD	[SCRADD+1],A
	RET

;****************************************
;*          PRINT A CHR ON MAP
;****************************************

PRCHR	SUB	32

PRCHAR	CALL	WAIT_STAT
	LD	HL,SCRADD
	LD	E,[HL]
	INC	HL
	LD	D,[HL]

	LD	[DE],A

CURR	INC	DE
	LD	[HL],D
	DEC	HL
	LD	[HL],E
	RET

;****************************************
;* WAIT FOR CORRECT TIME TO PUT ON CHRS
;****************************************

WAIT_STAT	PUSH	AF

_WAIT	LD	A,[STAT]
	AND	2
	JP	Z,_WAIT

_WAIT2	LD	A,[STAT]
	AND	2
	JP	NZ,_WAIT2

	POP	AF
	RET

;****************************************
;*       WAIT FOR FRAME FLYBACK
;****************************************

;WAIT_FLY	PUSH	AF
;
;_WAIT          LDZ     A,[LY]
;		CP	145
;               JP      NZ,_WAIT
;
;		POP	AF
;		RET

;****************************************
;*            PRINT A STRING
;****************************************

PRINT	POP	HL

_LOOP2	LD	A,[HL]
	CP	STOP
	JP	Z,_END

	CP	AT
	JP	Z,_AT

	PUSH	HL
	SUB	32
	CALL	PRCHAR
	POP	HL

	INC	HL
	JP	_LOOP2

_AT	INC	HL
	LD	B,[HL]
	INC	HL
	LD	C,[HL]
	INC	HL

	PUSH	HL
	CALL	SETPOS
	POP	HL

	JP	_LOOP

_END	INC	HL
	JP	[HL]

	.DB	00,01,02,03,04

;!!!!!!!!!!!!!!!!!!! EVERYTHING FROM HERE TO INSERT IN GAME !!!!!!!!!!!!!!!!!!
;!!!!!!!!!!!!!!!!!!! EVERYTHING FROM HERE TO INSERT IN GAME !!!!!!!!!!!!!!!!!!
;!!!!!!!!!!!!!!!!!!! EVERYTHING FROM HERE TO INSERT IN GAME !!!!!!!!!!!!!!!!!!
;!!!!!!!!!!!!!!!!!!! EVERYTHING FROM HERE TO INSERT IN GAME !!!!!!!!!!!!!!!!!!
;*****************************************************************************
;*               AUDIO ROUTINES
;*****************************************************************************


;		JP	MAININIT

;		JP	AUDIOIN1
;		JP	AUDIOIN2
;		JP	AUDIOIN3
;		JP	AUDIOIN4

;		JP	AUDIOPL1
;		JP	AUDIOPL2
;		JP	AUDIOPL3
;		JP	AUDIOPL4

;*****************************************************************************
;*                                                                           *
;*       MAIN INITIALISATION OF AUDIO-DRIVER                                 *
;*                                                                           *
;*****************************************************************************

MAININIT
	xor	a	; CHANNEL 1 TO 4 DISABLED
	OR	$80	; MASTER SOUND ENABLED
	LD	[NR52],A	; TRANSFER TO SOUNDCONTROL 52

	LD	A,%11111111	; CH 4&3 TO SO2,CH 2&1 TO SO1
	LD	[NR51],A	; TRANSFER TO SOUNDCONTROL 51

	LD	A,$07	; SO1 OUTPUT LEVEL
	OR	$70	; SO2 OUTPUT LEVEL
	OR	$08	; SOUND OUTPUT 1 ON
	OR	$80	; SOUND OUTPUT 2 ON
	LD	[NR50],A	; TRANSFER TO SOUNDCONTROL 50

	xor	a
	LD	[NR30],A

	LD	HL,DIGIWAVE
	LD	BC,WAVERAM
	LD	E,$10
_COPYWAVE	LD	A,[HLI]
	LD	[BC],A
	INC	BC
	DEC	E
	JP	NZ,_COPYWAVE
	RET

;*****************************************************************************
;*                                                                           *
;*       INITIALISATION OF INDIVIDUAL AUDIO-CHANNELS                         *
;*                                                                           *
;*****************************************************************************

		; ENTRY : A = SEQUENCE NO.



AUDIOIN1	add	A,a	;CHANNEL INIT 1
	LD	[AUDIONUM1],A
	LD	C,A
	LD	B,$00
	LD	HL,AUDIOTAB
	ADD	HL,BC

	LD	A,[HLI]
	LD	[SEQINDLO1],A
	LD	A,[HL]
	LD	[SEQINDHI1],A

	LD	HL,SEX
	LD	A,L
	LD	[STPINDLO1],A
	LD	A,H
	LD	[STPINDHI1],A

	XOR	A
	LD	[SFXTRANS1],A
	LD	[SPDCHECK1],A
	LD	[NOTEINIT1],A
	LD	[TRANBYTE1],A
	LD	[STEPNUMB1],A
	LD	[AMPINDEX1],A
	LD	[AMPLITUD1],A
	LD	A,$01
	LD	[SPDCOUNT1],A
	LD	[VOICTEST1],A
	LD	[LENGCOPY1],A
	LD	A,$FF
	LD	[AMPLSAME1],A

	LD	a,[NR52]
	or	$01
	ld	[nr52],a
	RET

AUDIOIN2	add	A,a	;CHANNEL INIT 2
	LD	[AUDIONUM2],A
	LD	C,A
	LD	B,$00
	LD	HL,AUDIOTAB
	ADD	HL,BC

	LD	A,[HLI]
	LD	[SEQINDLO2],A
	LD	A,[HL]
	LD	[SEQINDHI2],A

	LD	HL,SEX
	LD	A,L
	LD	[STPINDLO2],A
	LD	A,H
	LD	[STPINDHI2],A

	XOR	A
	LD	[SFXTRANS2],A
	LD	[SPDCHECK2],A
	LD	[NOTEINIT2],A
	LD	[TRANBYTE2],A
	LD	[STEPNUMB2],A
	LD	[AMPINDEX2],A
	LD	[AMPLITUD2],A
	LD	A,$01
	LD	[SPDCOUNT2],A
	LD	[VOICTEST2],A
	LD	[LENGCOPY2],A
	LD	A,$FF
	LD	[AMPLSAME2],A

	LD	a,[NR52]
	or	$02
	ld	[nr52],a
	RET

AUDIOIN3	add	A,a	;CHANNEL INIT 3
	LD	[AUDIONUM3],A
	LD	C,A
	LD	B,$00
	LD	HL,AUDIOTAB
	ADD	HL,BC

	LD	A,[HLI]
	LD	[SEQINDLO3],A
	LD	A,[HL]
	LD	[SEQINDHI3],A

	LD	HL,SEX
	LD	A,L
	LD	[STPINDLO3],A
	LD	A,H
	LD	[STPINDHI3],A

	XOR	A
	LD	[SFXTRANS3],A
	LD	[SPDCHECK3],A
	LD	[NOTEINIT3],A
	LD	[TRANBYTE3],A
	LD	[STEPNUMB3],A
	LD	[AMPINDEX3],A
	LD	[AMPLITUD3],A
	LD	A,$01
	LD	[SPDCOUNT3],A
	LD	[VOICTEST3],A
	LD	[LENGCOPY3],A
	LD	A,$FF
	LD	[AMPLSAME3],A

	LD	a,[NR52]
	or	$04
	ld	[nr52],a
	RET

AUDIOIN4	add	a,A	;CHANNEL INIT 4
	LD	[AUDIONUM4],A
	LD	C,A
	LD	B,$00
	LD	HL,AUDIOTAB
	ADD	HL,BC

	LD	A,[HLI]
	LD	[SEQINDLO4],A
	LD	A,[HL]
	LD	[SEQINDHI4],A

	LD	HL,SEX
	LD	A,L
	LD	[STPINDLO4],A
	LD	A,H
	LD	[STPINDHI4],A

	XOR	A
	LD	[SPDCHECK4],A
	LD	[NOTEINIT4],A
	LD	[STEPNUMB4],A
	LD	[AMPINDEX4],A
	LD	[AMPLITUD4],A
	LD	A,$01
	LD	[SPDCOUNT4],A
	LD	[VOICTEST4],A
	LD	[LENGCOPY4],A
	LD	A,$FF
	LD	[AMPLSAME4],A

	LD	a,[NR52]
	or	$08
	ld	[nr52],a

	RET

;*****************************************************************************
;*                                                                           *
;*       CHANNEL 01 AUDIO-PLAY                                               *
;*                                                                           *
;*****************************************************************************


AUDIOPL1	LD	A,[VOICTEST1]	; CHECK IF CHANNEL IS ON
	CP	$01
	JP	Z,_PLAYON1
	RET

	;*********************************
	;*   SOUND-CHIP UPDATE SECTION	 *
	;*********************************


_PLAYON1
	XOR	A	; SWEEP-DEPTH TO $00
	LD	[NR10],A	;

	LD	A,[PULSVALU1]	; PULSE-BITS <7-6> TO 25%
	LD	[NR11],A	; TRANSFER A TO NR11

	LD	A,[LOFRQWRD1]	; READ LOW-FREQUENCY
	LD	[NR13],A	; TRANSFER A TO NR13

	LD	A,[HIFRQWRD1]	; READ HF
	LD	[NR14],A	; TRANSFER A TO NR14


	LD	A,[AMPLSAME1]
	LD	E,A
	LD	A,[AMPLITUD1]	; READ AMPLITUDE
	CP	E
	jp	Z,_NOINITSN1
	LD	[AMPLSAME1],A
	LD	[NR12],A

	LD	[AMPLITUD1],A
	LD	A,[HIFRQWRD1]
	OR	$80
	LD	[NR14],A
_NOINITSN1

	;*********************************
        ;*   SPEED-ROUTINE [TWO BYTES]   *
	;*********************************

	XOR	A	; SET REALPLAY TO $00
	LD	[REALPLAY1],A	;

	LD	A,[SPDCOUNT1]	; DECREASE SPEEDCOUNT
	DEC	A	;
	LD	[SPDCOUNT1],A	;
	JP	NZ,_SPDHDX1	; NOT 0, EXIT SPEED-HANDLE

	LD	A,[SPDCHECK1]	; INVERT SPDCHECK
	XOR	255	;
	LD	[SPDCHECK1],A	;
	JP	NZ,_SECONS1	; IF SPDCHECK $FF, GOTO 2ND-SPD

	LD	A,[AUDIONUM1]	; READ SPEED 01
	LD	C,A
	LD	B,$00	;
	LD	HL,AUDIOSPDA	;
	ADD	HL,BC	;
	LD	A,[HL]	;
	JP	_SPDSET1	; JUMP TO SPDSET

_SECONS1	LD	A,[AUDIONUM1]	; READ SPEED 02
	LD	C,A
	LD	B,$00	;
	LD	HL,AUDIOSPDB	;
	ADD	HL,BC	;
	LD	A,[HL]	;

_SPDSET1	LD	[SPDCOUNT1],A	; SET A TO SPDCOUNT
	LD	A,$FF	; SET REALPLAY TO $FF
	LD	[REALPLAY1],A	;

_SPDHDX1
	LD	A,[REALPLAY1]	; LENGTH SUBTRACTION NECESSARY?
	OR	A	;
	JP	Z,_NOSTPH1	; NO, GOTO...

_AUDIPL1	LD	A,[LENGCOPY1]	; DECREASE LENGTH
	DEC	A	;
	LD	[LENGCOPY1],A	;
	JP	Z,_STPHDL1	; IF 0, THEN GOTO STEPHANDLE

_NOSTPH1	LD	A,[REALNOTE1]	; IF REALNOTE PAUSED, NO FX
	CP	$FF
	CALL	NZ,_FXPLAY1

_NOFXPL1	XOR	A	; CLEAR NOTEINIT
	LD	[NOTEINIT1],A	;
	RET		;

	;*********************************
	;*   STEP-HANDLE		 *
	;*********************************


_STPHDL1
	XOR	A	; GLIDE-RESET [!]
	LD	[GLDSPEED1],A

	LD	A,[STPINDLO1]	; TRANSFER STEPINDEX TO HL
	LD	L,A
	LD	A,[STPINDHI1]
	LD	H,A

	LD	A,[HLI]

	CP	$FF	; STEP-END-CHECK
	jp	Z,_SEQHDL1	; YO, GOTO SEQUENCE-HANDLE

	JP	_STPHD21	; NO, GOTO STEPHANDLE 02

	;*********************************
	;*   SEQUENCE-HANDLE		 *
	;*********************************

_SEQHDL1
	LD	A,[SEQINDLO1]	; TAKE SEQUENCE-INDEX
	LD	L,A
	LD	A,[SEQINDHI1]
	LD	H,A

	LD	A,[HLI]

	CP	$FF	; SEQ-END-REPEAT-CHECK
	jp	NZ,_SEQHD21

	LD	E,[HL]	; TAKE SEQ-REPEAT POINT
	LD	A,[AUDIONUM1]	; RESET SEQINDEX WITH
	LD	C,A	; SEQREPEAT OFFSET
	LD	B,$00
	LD	HL,AUDIOTAB
	ADD	HL,BC

	LD	A,[HLI]	; READ 'RESTART' SEQINDEX
	LD	[SEQINDLO1],A
	LD	A,[HL]
	LD	[SEQINDHI1],A

	LD	A,[SEQINDLO1]	; TRANSFER SEQ-INDEX TO HL
	LD	L,A
	LD	A,[SEQINDHI1]
	LD	H,A

	LD	C,E
	ADD	HL,BC

	LD	A,[HLI]	; FIRST SEQUENCE TO REPEAT
	JP	_SEQHD51	; GOTO NEXT SEQUENCE

_SEQHD21	CP	$FE	; SEQ-STOP-CHECK
	jp	NZ,_SEQHD31	;
	xor	a	; YES, DISABLE VOICE
	LD	[VOICTEST1],A	;

	LD	a,[NR52]
	and	$fe
	ld	[nr52],a

	RET

_SEQHD31			;CP      $FC                     ; !!! DO THE FADE! GODDAMNED !!!
               ;jp      NZ,_SEQHD51             ; !!! STILL TO BE PROGRAMMED !!!

_SEQHD51	CP	$80	; NOTE TRANSPOSE CHECK
	jp	C,_SEQHD61
	AND	$7F
	LD	[TRANBYTE1],A

	LD	A,[HLI]
_SEQHD61
	CP	$70	; SFIX-TRANSPOSE CHECK
	jp	C,_SEQHD91
	AND	$0F
	LD	[SFXTRANS1],A
	LD	A,[HLI]

_SEQHD91
	ADD	A,A
	LD	[STEPNUMB1],A	; SET STEP & CLEAR STEPINDEX

	LD	A,L
	LD	[SEQINDLO1],A
	LD	A,H
	LD	[SEQINDHI1],A

	LD	A,[STEPNUMB1]	; CALCULATE STEP-INDEX+POSIT
	LD	C,A
	LD	B,$00
	LD	HL,STEPTAB
	ADD	HL,BC

	LD	A,[HLI]
	LD	[STPINDLO1],A
	LD	A,[HL]
	LD	[STPINDHI1],A

	JP	_STPHDL1	; BACK TO STEP-HANDLE

	;*********************************
	;*   STEP-HANDLE 2		 *
	;*********************************


_STPHD21	CP	$FD	; GLIDE CHECK IN STEP
	jp	NZ,_STPHD41
_STPHDG1	LD	A,[HLI]
	LD	[GLDSPEED1],A
	LD	A,[HLI]
	LD	E,A
	LD	A,[TRANBYTE1]
	ADD	A,E
	LD	[REALNOTE1],A
	LD	A,[HLI]
	LD	E,A
	LD	A,[TRANBYTE1]
	ADD	A,E
	LD	[DESTNOTE1],A
	JP	_NONEWN1

_STPHD41	CP	$E0	; PAUSE CHECK
	jp	C,_STPHD51
	AND	$1F
	LD	[REALLENG1],A
	LD	A,$FF
	LD	[REALNOTE1],A
	xor	a
	LD	[AMPLITUD1],A

	LD	A,L
	LD	[STPINDLO1],A
	LD	A,H
	LD	[STPINDHI1],A
	JP	_PAUSEX1

_STPHD51	CP	$C0	; SOUND CHECK
	jp	C,_STPHD61
	AND	$1F
	LD	E,A
	LD	A,[SFXTRANS1]
	ADD	A,E
	ADD	A,A
	ADD	A,A
	LD	[REALSOUN1],A
	LD	A,[HLI]
	CP	$FD
	jp	Z,_STPHDG1
	CP	$C0
	jp	C,_STPHD61
	DEC	HL
	jp	_NONEWN1

_STPHD61	CP	$80	; LENGTH CHECK
	jp	C,_STPHD71
	AND	$7F
	LD	[REALLENG1],A
	LD	A,[HLI]
	CP	$FD
	jp	Z,_STPHDG1
	CP	$80
	jp	C,_STPHD71
	DEC	HL
	jp	_NONEWN1

_STPHD71	CP	$60	; ARP CHECK
	jp	C,_STPHD81
	AND	$1F
	LD	[ARPNUMBO1],A
	LD	A,[HLI]
	CP	$60
	jp	C,_STPHD81
	DEC	HL
	jp	_NONEWN1

_STPHD81
	LD	E,A	;SET NOTE + NOTE TRANSPOSE
	LD	A,[TRANBYTE1]
	ADD	A,E
	LD	[REALNOTE1],A

_NONEWN1
	LD	A,L
	LD	[STPINDLO1],A
	LD	A,H
	LD	[STPINDHI1],A

	LD	A,[NOTEINIT1]	;FIRST INIT HAS BEEN DONE
	INC	A	;
	LD	[NOTEINIT1],A	;

                ;CP     $02                     ; !!! NOT FOR CHAN 3&4 !!!
                ;JP     NC,_NONEWP1

	LD	A,[REALSOUN1]
	LD	C,A
	LD	B,$00
	LD	HL,SOUNDFIX
	ADD	HL,BC
	LD	A,[HLI]
	LD	E,A
	AND	$08
	JP	NZ,_NONEWP1
	LD	A,E
	AND	$C0
	LD	[PULSVALU1],A
	XOR	A
	LD	[PULINDEX1],A

_NONEWP1	LD	A,[HLI]
	LD	[FX01WORD1],A	; SET EFFECTS [ARP, ETC]
	LD	A,[HLI]
	LD	[FX02WORD1],A	; SET VIBRATO-DELAY + PULSTAB
	LD	A,[HL]
	LD	[FX03WORD1],A	; AMPLITUDE-TABLE-NR INTO FX03

;               CP      $03
;               JP      Z,_ITSFOR4

	LD	A,[REALNOTE1]	; READ REALNOTE AS INDEX
	LD	C,A
	LD	B,$00
	LD	HL,FRQTABLE
	ADD	HL,BC
	ADD	HL,BC
	LD	A,[HLI]	; HIGH-FREQUENCY <BIT 7-0>
	LD	[LOFRQWRD1],A	; HF SET
	LD	A,[HL]	; LOW-FREQUENCY <BIT 2-0>
	LD	[HIFRQWRD1],A	; LF SET
	JP	_PAUSEX1

;_ITSFOR4       LD      A,[REALNOTE1]
;               LD      [LOFRQWRD1],A

_PAUSEX1	LD	A,[REALLENG1]
	LD	[LENGCOPY1],A
	RET

	;*********************************
	;*   EFFECT-INIT TAKE 2		 *
	;*********************************


_FXPLAY1	LD	A,[NOTEINIT1]
	OR	A
	JP	Z,_PLYFXR1

_INTPLA1	LD	A,[GLDSPEED1]
	OR	A
	jp	Z,_FXPLA21
	LD	C,A
	SWAP	A
	AND	$0F
	LD	[GLDDELAY1],A
	LD	A,C
	AND	$0F
	LD	[GLDSPEED1],A

	LD	A,[GLDDELAY1]
	LD	E,A
	LD	A,[REALLENG1]
	SUB	E
	LD	[GLDDELAY1],A
	LD	A,[DESTNOTE1]
	LD	E,A
	LD	A,[REALNOTE1]
	SUB	E
	LD	[GLDDIREC1],A

_FXPLA21
	XOR	A
	LD	[AMPINDEX1],A
	LD	[VIBINDEX1],A
	LD	[ARPINDEX1],A
	LD	A,[FX02WORD1]
	SWAP	A
	AND	$0F
	LD	[VIBDELAY1],A
	LD	A,[VIBDELAY1]
	LD	E,A
	LD	A,[REALLENG1]
	SUB	E
	jp	NC,_REFIX01
	LD	A,[FX01WORD1]
	AND	$F0
	LD	[FX01WORD1],A
	LD	A,[REALLENG1]
_REFIX01	LD	[VIBDELAY1],A
_EXITIN1	JP	_NOVIB01


_PLYFXR1

	;*********************************
	;*   PULSE-WIDTH-ROUTINE	 *
	;*********************************


	LD	A,[FX02WORD1]
	AND	$0F
	JP	Z,_NOPULS1
	LD	C,A
	LD	B,$00
	LD	HL,PULTAB
	ADD	HL,BC
	ADD	HL,BC
	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	A,[PULINDEX1]
	LD	C,A
	ADD	HL,BC
	LD	A,[HLI]
	CP	$FE	; PULS-TABLE END?
	jp	Z,_NOPULS1
	CP	$FF	; PULS-TABLE REPEAT?
	jp	NZ,_PULSER1

	LD	A,[HL]	; SET PULSE-REPEAT-POINT
	LD	E,A
	LD	A,[FX02WORD1]
	AND	$0F
	LD	C,A
	LD	HL,PULTAB
	ADD	HL,BC
	ADD	HL,BC

	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	C,E
	ADD	HL,BC
	LD	A,[HL]
_PULSER1
	LD	[PULSVALU1],A

	INC	C
	LD	A,C
	LD	[PULINDEX1],A
_NOPULS1

	LD	A,[PULSVALU1]


	;*********************************
	;*   GLIDE-ROUTINE		 *
	;*********************************

_GLIDER1	LD	A,[GLDSPEED1]	;GLIDE ROUTINE
	OR	A
	JP	Z,_NOGLD21

	LD	A,[GLDDELAY1]
	LD	E,A
	LD	A,[LENGCOPY1]
	CP	E
	JP	NC,_NOGLD21

	LD	A,[GLDDIREC1]
	CP	$80
	JP	C,_DOWNGL1

	LD	A,[LOFRQWRD1]
	LD	E,A
	LD	A,[GLDSPEED1]
	ADD	A,E
	LD	[LOFRQWRD1],A
	jp	NC,_CHECV11
	LD	A,[HIFRQWRD1]
	INC	A
	LD	[HIFRQWRD1],A

_CHECV11
	LD	A,[LOFRQWRD1]
	LD	E,A
	LD	A,[HIFRQWRD1]
	LD	D,A

	LD	A,[DESTNOTE1]
	LD	C,A
	LD	B,$00
	LD	HL,FRQTABLE
	ADD	HL,BC
	ADD	HL,BC
	LD	A,[HLI]
	SUB	E
	LD	A,[HL]
	SBC	A,D
	jp	C,_FROTER1
	jp	_NOGLD01

_DOWNGL1
	LD	A,[GLDSPEED1]
	LD	E,A
	LD	A,[LOFRQWRD1]
	SUB	E
	LD	[LOFRQWRD1],A
	jp	NC,_CHECV21
	LD	A,[HIFRQWRD1]
	DEC	A
	LD	[HIFRQWRD1],A

_CHECV21
	LD	A,[DESTNOTE1]
	LD	C,A
	LD	B,$00
	LD	HL,FRQTABLE
	ADD	HL,BC
	ADD	HL,BC
	LD	A,[HLI]
	LD	E,A
	LD	A,[HL]
	LD	D,A

	LD	A,[LOFRQWRD1]
	SUB	E
	LD	A,[HIFRQWRD1]
	SBC	A,D

	jp	C,_FROTER1
	jp	_NOGLD01

_FROTER1	LD	A,C	; DESTINATION NOTE BECOMES
	LD	[REALNOTE1],A	; REAL NOTE
	LD	C,A
	LD	B,$00
	LD	HL,FRQTABLE
	ADD	HL,BC
	ADD	HL,BC
	LD	A,[HLI]	; READ NEW FREQUENCY
	LD	[LOFRQWRD1],A
	LD	A,[HL]
	LD	[HIFRQWRD1],A

	XOR	A
	LD	[GLDSPEED1],A
_NOGLD01	JP	_NOVIB01
_NOGLD21


	;*********************************
	;*   VIBRATO-ROUTINE		 *
	;*********************************

_VIBRA01	LD	A,[FX01WORD1]	;VIBRATO ROUTINE
	AND	$0F
	jp	Z,_NOVIB01
	LD	A,[LENGCOPY1]
	LD	E,A
	LD	A,[VIBDELAY1]
	CP	E
	jp	C,_NOVIB01

	LD	A,[FX01WORD1]
	AND	$0F
	LD	C,A
	LD	B,$00
	LD	HL,VIBTAB
	ADD	HL,BC
	ADD	HL,BC

	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	A,[VIBINDEX1]
	LD	C,A
	LD	B,$00
	ADD	HL,BC
	LD	A,[HL]
	CP	$80
	jp	NZ,_VIBER01

	LD	A,[FX01WORD1]
	AND	$0F
	LD	C,A
	LD	B,$00
	LD	HL,VIBTAB
	ADD	HL,BC
	ADD	HL,BC

	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	C,$00

_VIBER01	LD	A,[HL]
	CP	$80
	JP	C,_UPVIBO1
	XOR	$FF
	ADD	A,$01
	LD	E,A

	LD	A,[LOFRQWRD1]
	SUB	E
	LD	[LOFRQWRD1],A
	jp	NC,_NOHIG11
	LD	A,[HIFRQWRD1]
	DEC	A
	LD	[HIFRQWRD1],A
_NOHIG11	JP	_VIBNO01

_UPVIBO1	LD	E,A
	LD	A,[LOFRQWRD1]
	ADD	A,E
	LD	[LOFRQWRD1],A
	jp	NC,_NOHIG21
	LD	A,[HIFRQWRD1]
	INC	A
	LD	[HIFRQWRD1],A
_NOHIG21
_VIBNO01	LD	A,C
	INC	A
	LD	[VIBINDEX1],A
_NOVIB01


	;*********************************
	;*   AMPLITUDE-ROUTINE		 *
	;*********************************

;               LD      A,[REALLENG1]           ;CHECK IF THE REAL LENGCOPYTH IS 1
;               CP      $1
;               JP      Z,_AMPLIT1                      ;IF SO, DO NOT CUT NOTE OFF AT END
;
;               LD      A,[LENGCOPY1]
;               CP      $01
;               JP      NZ,_AMPLIT1
;               LD      A,[SPDCOUNT1]           ;!
;               CP      $1                      ;!
;               JP      NC,_AMPLIT1             ;!
;
;               LD      A,[AMPLITUD1]           ;+ THIS FADE THE VOLUME  BY FORMULA X/2
;		SRL	A			;+
;               LD      [AMPLITUD1],A           ;+
;               JP      _NOAMPL1                ;+

;               LD      [AMPLITUD1],$00         ; THIS WOULD CUT VOLUME TO 00!
;               JP      _NOAMPL1



_AMPLIT1	LD	A,[FX03WORD1]	;AMPLITUDE ROUTINE
	AND	$7F
	LD	C,A
	LD	B,$00
	LD	HL,AMPTAB
	ADD	HL,BC
	ADD	HL,BC
	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	A,[AMPINDEX1]
	LD	C,A
	ADD	HL,BC
	LD	A,[HL]
	CP	$FE
	jp	Z,_NOAMPL1
	SWAP	A
	LD	[AMPLITUD1],A

	LD	A,[AMPINDEX1]
	INC	A
	LD	[AMPINDEX1],A
_NOAMPL1


	;*********************************
	;*   ARPEGGIO-ROUTINE		 *
	;*********************************

_ARPEG01	LD	A,[FX01WORD1]	;ARPEGGIO ROUTINE
	AND	$40
	JP	Z,_NOARP01

	LD	A,[FX01WORD1]	; ONLY USE WHEN $20+ ARPS
	AND	$80	; REQUIRED
	JP	Z,_ARPBNK1	; OTHERWISE REMOVE !!!
	LD	A,[ARPNUMBO1]	;
	set	5,a	;
	JP	_ARPSET1

_ARPBNK1	LD	A,[ARPNUMBO1]
_ARPSET1	LD	C,A
	LD	B,$00
	LD	HL,ARPTAB
	ADD	HL,BC
	ADD	HL,BC

	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	A,[ARPINDEX1]
	LD	C,A
	LD	B,$00
	ADD	HL,BC

	LD	A,[HLI]
	CP	$FF	; REPEAT ARPEGGIO?
	jp	NZ,_ARPER01

	LD	A,[HL]
	LD	E,A

	LD	A,[FX01WORD1]	; ONLY USE WHEN $20+ ARPS
	AND	$80	; REQUIRED
	jp	Z,_ARPBN21	; OTHERWISE REMOVE !!!
	LD	A,[ARPNUMBO1]	;
	set	5,a	;
	JP	_ARPSE21	;
_ARPBN21	LD	A,[ARPNUMBO1]	;
_ARPSE21	LD	C,A
	LD	HL,ARPTAB
	ADD	HL,BC
	ADD	HL,BC

	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	C,E
	LD	B,$00
	ADD	HL,BC

	LD	A,[HLI]

_ARPER01	CP	$FE
	jp	Z,_NOARP01
	CP	$80
	JP	NC,_NORMA01
	LD	E,A
	LD	A,[REALNOTE1]
	ADD	A,E

_NORMA01	AND	$7F
	LD	[ARPONOTO1],A
	LD	A,C
	INC	A
	LD	[ARPINDEX1],A
_ARPNO01

;               CP      $03
;               JP      Z,_FOR4TOO

	LD	A,[ARPONOTO1]

	JP	_SETAN01
;_FOR4TOO
;               LD      A,[ARPONOTO1]
;               LD      [LOFRQWRD1],A
;		RET

_SETAN01	LD	C,A
	LD	B,$00
	LD	HL,FRQTABLE
	ADD	HL,BC
	ADD	HL,BC

	LD	A,[HLI]
	LD	[LOFRQWRD1],A
	LD	A,[HL]
	LD	[HIFRQWRD1],A
_NOARP01
	RET







;*****************************************************************************
;*                                                                           *
;*       CHANNEL 02 AUDIO-PLAY                                               *
;*                                                                           *
;*****************************************************************************


AUDIOPL2	LD	A,[VOICTEST2]	; CHECK IF CHANNEL IS ON
	CP	$01
	JP	Z,_PLAYON2
	RET

	;*********************************
	;*   SOUND-CHIP UPDATE SECTION	 *
	;*********************************


_PLAYON2
	LD	A,[PULSVALU2]	; PULSE-BITS <7-6> TO 25%
	LD	[NR21],A	; TRANSFER A TO NR21

	LD	A,[LOFRQWRD2]	; READ LOW-FREQUENCY
	LD	[NR23],A	; TRANSFER A TO NR23

	LD	A,[HIFRQWRD2]	; READ HF
	LD	[NR24],A	; TRANSFER A TO NR24


	LD	A,[AMPLSAME2]
	LD	E,A
	LD	A,[AMPLITUD2]	; READ AMPLITUDE
	CP	E
	jp	Z,_NOINITSN2
	LD	[AMPLSAME2],A
	LD	[NR22],A

	LD	[AMPLITUD2],A
	LD	A,[HIFRQWRD2]
	OR	$80
	LD	[NR24],A
_NOINITSN2

	;*********************************
        ;*   SPEED-ROUTINE [TWO BYTES]   *
	;*********************************

	XOR	A	; SET REALPLAY TO $00
	LD	[REALPLAY2],A	;

	LD	A,[SPDCOUNT2]	; DECREASE SPEEDCOUNT
	DEC	A	;
	LD	[SPDCOUNT2],A	;
	JP	NZ,_SPDHDX2	; NOT 0, EXIT SPEED-HANDLE

	LD	A,[SPDCHECK2]	; INVERT SPDCHECK
	XOR	255	;
	LD	[SPDCHECK2],A	;
	JP	NZ,_SECONS2	; IF SPDCHECK $FF, GOTO 2ND-SPD

	LD	A,[AUDIONUM2]	; READ SPEED 01
	LD	C,A
	LD	B,$00	;
	LD	HL,AUDIOSPDA	;
	ADD	HL,BC	;
	LD	A,[HL]	;
	JP	_SPDSET2	; JUMP TO SPDSET

_SECONS2	LD	A,[AUDIONUM2]	; READ SPEED 02
	LD	C,A
	LD	B,$00	;
	LD	HL,AUDIOSPDB	;
	ADD	HL,BC	;
	LD	A,[HL]	;

_SPDSET2	LD	[SPDCOUNT2],A	; SET A TO SPDCOUNT
	LD	A,$FF	; SET REALPLAY TO $FF
	LD	[REALPLAY2],A	;

_SPDHDX2
	LD	A,[REALPLAY2]	; LENGTH SUBTRACTION NECESSARY?
	OR	A	;
	JP	Z,_NOSTPH2	; NO, GOTO...

_AUDIPL2	LD	A,[LENGCOPY2]	; DECREASE LENGTH
	DEC	A	;
	LD	[LENGCOPY2],A	;
	JP	Z,_STPHDL2	; IF 0, THEN GOTO STEPHANDLE

_NOSTPH2	LD	A,[REALNOTE2]	; IF REALNOTE PAUSED, NO FX
	CP	$FF
	CALL	NZ,_FXPLAY2

_NOFXPL2	XOR	A	; CLEAR NOTEINIT
	LD	[NOTEINIT2],A	;
	RET		;

	;*********************************
	;*   STEP-HANDLE		 *
	;*********************************


_STPHDL2
	XOR	A	; GLIDE-RESET [!]
	LD	[GLDSPEED2],A

	LD	A,[STPINDLO2]	; TRANSFER STEPINDEX TO HL
	LD	L,A
	LD	A,[STPINDHI2]
	LD	H,A

	LD	A,[HLI]

	CP	$FF	; STEP-END-CHECK
	jp	Z,_SEQHDL2	; YO, GOTO SEQUENCE-HANDLE

	JP	_STPHD22	; NO, GOTO STEPHANDLE 02

	;*********************************
	;*   SEQUENCE-HANDLE		 *
	;*********************************

_SEQHDL2
	LD	A,[SEQINDLO2]	; TAKE SEQUENCE-INDEX
	LD	L,A
	LD	A,[SEQINDHI2]
	LD	H,A

	LD	A,[HLI]

	CP	$FF	; SEQ-END-REPEAT-CHECK
	jp	NZ,_SEQHD22

	LD	E,[HL]	; TAKE SEQ-REPEAT POINT
	LD	A,[AUDIONUM2]	; RESET SEQINDEX WITH
	LD	C,A	; SEQREPEAT OFFSET
	LD	B,$00
	LD	HL,AUDIOTAB
	ADD	HL,BC

	LD	A,[HLI]	; READ 'RESTART' SEQINDEX
	LD	[SEQINDLO2],A
	LD	A,[HL]
	LD	[SEQINDHI2],A

	LD	A,[SEQINDLO2]	; TRANSFER SEQ-INDEX TO HL
	LD	L,A
	LD	A,[SEQINDHI2]
	LD	H,A

	LD	C,E
	ADD	HL,BC

	LD	A,[HLI]	; FIRST SEQUENCE TO REPEAT
	JP	_SEQHD52	; GOTO NEXT SEQUENCE

_SEQHD22	CP	$FE	; SEQ-STOP-CHECK
	jp	NZ,_SEQHD32	;
	xor	a	; YES, DISABLE VOICE
	LD	[VOICTEST2],A	;

	LD	a,[NR52]
	and	$fd
	ld	[nr52],a

	RET

_SEQHD32			;CP      $FC                     ; !!! DO THE FADE! GODDAMNED !!!
               ;jp      NZ,_SEQHD52             ; !!! STILL TO BE PROGRAMMED !!!

_SEQHD52	CP	$80	; NOTE TRANSPOSE CHECK
	jp	C,_SEQHD62
	AND	$7F
	LD	[TRANBYTE2],A

	LD	A,[HLI]
_SEQHD62
	CP	$70	; SFIX-TRANSPOSE CHECK
	jp	C,_SEQHD92
	AND	$0F
	LD	[SFXTRANS2],A
	LD	A,[HLI]

_SEQHD92
	SLA	A
	LD	[STEPNUMB2],A	; SET STEP & CLEAR STEPINDEX

	LD	A,L
	LD	[SEQINDLO2],A
	LD	A,H
	LD	[SEQINDHI2],A

	LD	A,[STEPNUMB2]	; CALCULATE STEP-INDEX+POSIT
	LD	C,A
	LD	B,$00
	LD	HL,STEPTAB
	ADD	HL,BC

	LD	A,[HLI]
	LD	[STPINDLO2],A
	LD	A,[HL]
	LD	[STPINDHI2],A

	JP	_STPHDL2	; BACK TO STEP-HANDLE

	;*********************************
	;*   STEP-HANDLE 2		 *
	;*********************************


_STPHD22	CP	$FD	; GLIDE CHECK IN STEP
	jp	NZ,_STPHD42
_STPHDG2	LD	A,[HLI]
	LD	[GLDSPEED2],A
	LD	A,[HLI]
	LD	E,A
	LD	A,[TRANBYTE2]
	ADD	A,E
	LD	[REALNOTE2],A
	LD	A,[HLI]
	LD	E,A
	LD	A,[TRANBYTE2]
	ADD	A,E
	LD	[DESTNOTE2],A
	JP	_NONEWN2

_STPHD42	CP	$E0	; PAUSE CHECK
	jp	C,_STPHD52
	AND	$1F
	LD	[REALLENG2],A
	LD	A,$FF
	LD	[REALNOTE2],A
	xor	a
	LD	[AMPLITUD2],A

	LD	A,L
	LD	[STPINDLO2],A
	LD	A,H
	LD	[STPINDHI2],A
	JP	_PAUSEX2

_STPHD52	CP	$C0	; SOUND CHECK
	jp	C,_STPHD62
	AND	$1F
	LD	E,A
	LD	A,[SFXTRANS2]
	ADD	A,E
	ADD	A,A
	ADD	A,A
	LD	[REALSOUN2],A
	LD	A,[HLI]
	CP	$FD
	jp	Z,_STPHDG2
	CP	$C0
	jp	C,_STPHD62
	DEC	HL
	jp	_NONEWN2

_STPHD62	CP	$80	; LENGTH CHECK
	jp	C,_STPHD72
	AND	$7F
	LD	[REALLENG2],A
	LD	A,[HLI]
	CP	$FD
	jp	Z,_STPHDG2
	CP	$80
	jp	C,_STPHD72
	DEC	HL
	jp	_NONEWN2

_STPHD72	CP	$60	; ARP CHECK
	jp	C,_STPHD82
	AND	$1F
	LD	[ARPNUMBO2],A
	LD	A,[HLI]
	CP	$60
	jp	C,_STPHD82
	DEC	HL
	jp	_NONEWN2

_STPHD82
	LD	E,A	;SET NOTE + NOTE TRANSPOSE
	LD	A,[TRANBYTE2]
	ADD	A,E
	LD	[REALNOTE2],A

_NONEWN2
	LD	A,L
	LD	[STPINDLO2],A
	LD	A,H
	LD	[STPINDHI2],A

	LD	A,[NOTEINIT2]	;FIRST INIT HAS BEEN DONE
	INC	A	;
	LD	[NOTEINIT2],A	;

                ;CP     $02                     ; !!! NOT FOR CHAN 3&4 !!!
                ;JP     NC,_NONEWP2

	LD	A,[REALSOUN2]
	LD	C,A
	LD	B,$00
	LD	HL,SOUNDFIX
	ADD	HL,BC
	LD	A,[HLI]
	LD	E,A
	AND	$08
	JP	NZ,_NONEWP2
	LD	A,E
	AND	$C0
	LD	[PULSVALU2],A
	XOR	A
	LD	[PULINDEX2],A

_NONEWP2	LD	A,[HLI]
	LD	[FX01WORD2],A	; SET EFFECTS [ARP, ETC]
	LD	A,[HLI]
	LD	[FX02WORD2],A	; SET VIBRATO-DELAY + PULSTAB
	LD	A,[HL]
	LD	[FX03WORD2],A	; AMPLITUDE-TABLE-NR INTO FX03

;               CP      $03
;               JP      Z,_ITSFOR4

	LD	A,[REALNOTE2]	; READ REALNOTE AS INDEX
	LD	C,A
	LD	B,$00
	LD	HL,FRQTABLE
	ADD	HL,BC
	ADD	HL,BC
	LD	A,[HLI]	; HIGH-FREQUENCY <BIT 7-0>
	LD	[LOFRQWRD2],A	; HF SET
	LD	A,[HL]	; LOW-FREQUENCY <BIT 2-0>
	LD	[HIFRQWRD2],A	; LF SET
	JP	_PAUSEX2

;_ITSFOR4       LD      A,[REALNOTE2]
;               LD      [LOFRQWRD2],A

_PAUSEX2	LD	A,[REALLENG2]
	LD	[LENGCOPY2],A
	RET

	;*********************************
	;*   EFFECT-INIT TAKE 2		 *
	;*********************************


_FXPLAY2	LD	A,[NOTEINIT2]
	OR	A
	JP	Z,_PLYFXR2

_INTPLA2	LD	A,[GLDSPEED2]
	OR	A
	jp	Z,_FXPLA22
	LD	C,A
	SWAP	A
	AND	$0F
	LD	[GLDDELAY2],A
	LD	A,C
	AND	$0F
	LD	[GLDSPEED2],A

	LD	A,[GLDDELAY2]
	LD	E,A
	LD	A,[REALLENG2]
	SUB	E
	LD	[GLDDELAY2],A
	LD	A,[DESTNOTE2]
	LD	E,A
	LD	A,[REALNOTE2]
	SUB	E
	LD	[GLDDIREC2],A

_FXPLA22
	XOR	A
	LD	[AMPINDEX2],A
	LD	[VIBINDEX2],A
	LD	[ARPINDEX2],A

	LD	A,[FX02WORD2]
	SWAP	A
	AND	$0F
	LD	[VIBDELAY2],A
	LD	A,[VIBDELAY2]
	LD	E,A
	LD	A,[REALLENG2]
	SUB	E
	jp	NC,_REFIX02
	LD	A,[FX01WORD2]
	AND	$F0
	LD	[FX01WORD2],A
	LD	A,[REALLENG2]
_REFIX02	LD	[VIBDELAY2],A
_EXITIN2	JP	_NOVIB02


_PLYFXR2

	;*********************************
	;*   PULSE-WIDTH-ROUTINE	 *
	;*********************************


	LD	A,[FX02WORD2]
	AND	$0F
	JP	Z,_NOPULS2
	LD	C,A
	LD	B,$00
	LD	HL,PULTAB
	ADD	HL,BC
	ADD	HL,BC
	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	A,[PULINDEX2]
	LD	C,A
	ADD	HL,BC
	LD	A,[HLI]
	CP	$FE	; PULS-TABLE END?
	jp	Z,_NOPULS2
	CP	$FF	; PULS-TABLE REPEAT?
	jp	NZ,_PULSER2

	LD	A,[HL]	; SET PULSE-REPEAT-POINT
	LD	E,A
	LD	A,[FX02WORD2]
	AND	$0F
	LD	C,A
	LD	HL,PULTAB
	ADD	HL,BC
	ADD	HL,BC

	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	C,E
	ADD	HL,BC
	LD	A,[HL]
_PULSER2
	LD	[PULSVALU2],A

	INC	C
	LD	A,C
	LD	[PULINDEX2],A
_NOPULS2

	LD	A,[PULSVALU2]


	;*********************************
	;*   GLIDE-ROUTINE		 *
	;*********************************

_GLIDER2	LD	A,[GLDSPEED2]	;GLIDE ROUTINE
	OR	A
	JP	Z,_NOGLD22

	LD	A,[GLDDELAY2]
	LD	E,A
	LD	A,[LENGCOPY2]
	CP	E
	JP	NC,_NOGLD22

	LD	A,[GLDDIREC2]
	CP	$80
	JP	C,_DOWNGL2

	LD	A,[LOFRQWRD2]
	LD	E,A
	LD	A,[GLDSPEED2]
	ADD	A,E
	LD	[LOFRQWRD2],A
	jp	NC,_CHECV12
	LD	A,[HIFRQWRD2]
	INC	A
	LD	[HIFRQWRD2],A

_CHECV12
	LD	A,[LOFRQWRD2]
	LD	E,A
	LD	A,[HIFRQWRD2]
	LD	D,A

	LD	A,[DESTNOTE2]
	LD	C,A
	LD	B,$00
	LD	HL,FRQTABLE
	ADD	HL,BC
	ADD	HL,BC
	LD	A,[HLI]
	SUB	E
	LD	A,[HL]
	SBC	A,D
	jp	C,_FROTER2
	jp	_NOGLD02

_DOWNGL2
	LD	A,[GLDSPEED2]
	LD	E,A
	LD	A,[LOFRQWRD2]
	SUB	E
	LD	[LOFRQWRD2],A
	jp	NC,_CHECV22
	LD	A,[HIFRQWRD2]
	DEC	A
	LD	[HIFRQWRD2],A

_CHECV22
	LD	A,[DESTNOTE2]
	LD	C,A
	LD	B,$00
	LD	HL,FRQTABLE
	ADD	HL,BC
	ADD	HL,BC
	LD	A,[HLI]
	LD	E,A
	LD	A,[HL]
	LD	D,A

	LD	A,[LOFRQWRD2]
	SUB	E
	LD	A,[HIFRQWRD2]
	SBC	A,D

	jp	C,_FROTER2
	jp	_NOGLD02

_FROTER2	LD	A,C	; DESTINATION NOTE BECOMES
	LD	[REALNOTE2],A	; REAL NOTE
	LD	C,A
	LD	B,$00
	LD	HL,FRQTABLE
	ADD	HL,BC
	ADD	HL,BC
	LD	A,[HLI]	; READ NEW FREQUENCY
	LD	[LOFRQWRD2],A
	LD	A,[HL]
	LD	[HIFRQWRD2],A

	XOR	A
	LD	[GLDSPEED2],A
_NOGLD02	JP	_NOVIB02
_NOGLD22


	;*********************************
	;*   VIBRATO-ROUTINE		 *
	;*********************************

_VIBRA02	LD	A,[FX01WORD2]	;VIBRATO ROUTINE
	AND	$0F
	jp	Z,_NOVIB02
	LD	A,[LENGCOPY2]
	LD	E,A
	LD	A,[VIBDELAY2]
	CP	E
	jp	C,_NOVIB02

	LD	A,[FX01WORD2]
	AND	$0F
	LD	C,A
	LD	B,$00
	LD	HL,VIBTAB
	ADD	HL,BC
	ADD	HL,BC

	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	A,[VIBINDEX2]
	LD	C,A
	LD	B,$00
	ADD	HL,BC
	LD	A,[HL]
	CP	$80
	jp	NZ,_VIBER02

	LD	A,[FX01WORD2]
	AND	$0F
	LD	C,A
	LD	B,$00
	LD	HL,VIBTAB
	ADD	HL,BC
	ADD	HL,BC

	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	C,$00

_VIBER02	LD	A,[HL]
	CP	$80
	JP	C,_UPVIBO2
	XOR	$FF
	ADD	A,$01
	LD	E,A

	LD	A,[LOFRQWRD2]
	SUB	E
	LD	[LOFRQWRD2],A
	jp	NC,_NOHIG12
	LD	A,[HIFRQWRD2]
	DEC	A
	LD	[HIFRQWRD2],A
_NOHIG12	JP	_VIBNO02

_UPVIBO2	LD	E,A
	LD	A,[LOFRQWRD2]
	ADD	A,E
	LD	[LOFRQWRD2],A
	jp	NC,_NOHIG22
	LD	A,[HIFRQWRD2]
	INC	A
	LD	[HIFRQWRD2],A
_NOHIG22
_VIBNO02	LD	A,C
	INC	A
	LD	[VIBINDEX2],A
_NOVIB02


	;*********************************
	;*   AMPLITUDE-ROUTINE		 *
	;*********************************

;               LD      A,[REALLENG2]           ;CHECK IF THE REAL LENGCOPYTH IS 1
;               CP      $1
;               JP      Z,_AMPLIT2                      ;IF SO, DO NOT CUT NOTE OFF AT END
;
;               LD      A,[LENGCOPY2]
;               CP      $01
;               JP      NZ,_AMPLIT2
;               LD      A,[SPDCOUNT2]           ;!
;               CP      $1                      ;!
;               JP      NC,_AMPLIT2             ;!
;
;               LD      A,[AMPLITUD2]           ;+ THIS FADE THE VOLUME  BY FORMULA X/2
;		SRL	A			;+
;               LD      [AMPLITUD2],A           ;+
;               JP      _NOAMPL2                ;+

;               LD      [AMPLITUD2],$00         ; THIS WOULD CUT VOLUME TO 00!
;               JP      _NOAMPL2



_AMPLIT2	LD	A,[FX03WORD2]	;AMPLITUDE ROUTINE
	AND	$7F
	LD	C,A
	LD	B,$00
	LD	HL,AMPTAB
	ADD	HL,BC
	ADD	HL,BC
	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	A,[AMPINDEX2]
	LD	C,A
	ADD	HL,BC
	LD	A,[HL]
	CP	$FE
	jp	Z,_NOAMPL2
	SWAP	A
	LD	[AMPLITUD2],A

	LD	A,[AMPINDEX2]
	INC	A
	LD	[AMPINDEX2],A
_NOAMPL2


	;*********************************
	;*   ARPEGGIO-ROUTINE		 *
	;*********************************

_ARPEG02	LD	A,[FX01WORD2]	;ARPEGGIO ROUTINE
	AND	$40
	JP	Z,_NOARP02

	LD	A,[FX01WORD2]	; ONLY USE WHEN $20+ ARPS
	AND	$80	; REQUIRED
	JP	Z,_ARPBNK2	; OTHERWISE REMOVE !!!
	LD	A,[ARPNUMBO2]	;
	set	5,a	;
	JP	_ARPSET2
_ARPBNK2	LD	A,[ARPNUMBO2]
_ARPSET2	LD	C,A
	LD	HL,ARPTAB
	LD	B,$00
	ADD	HL,BC
	ADD	HL,BC

	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	A,[ARPINDEX2]
	LD	C,A
	LD	B,$00
	ADD	HL,BC

	LD	A,[HLI]
	CP	$FF	; REPEAT ARPEGGIO?
	jp	NZ,_ARPER02

	LD	A,[HL]
	LD	E,A

	LD	A,[FX01WORD2]	; ONLY USE WHEN $20+ ARPS
	AND	$80	; REQUIRED
	jp	Z,_ARPBN22	; OTHERWISE REMOVE !!!
	LD	A,[ARPNUMBO2]	;
	set	5,a	;
	JP	_ARPSE22	;
_ARPBN22	LD	A,[ARPNUMBO2]	;
_ARPSE22	LD	C,A

	LD	HL,ARPTAB
	ADD	HL,BC
	ADD	HL,BC

	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	C,E
	LD	B,$00
	ADD	HL,BC

	LD	A,[HLI]

_ARPER02	CP	$FE
	jp	Z,_NOARP02
	CP	$80
	JP	NC,_NORMA02
	LD	E,A
	LD	A,[REALNOTE2]
	ADD	A,E

_NORMA02	AND	$7F
	LD	[ARPONOTO2],A
	LD	A,C
	INC	A
	LD	[ARPINDEX2],A
_ARPNO02

;               CP      $03
;               JP      Z,_FOR4TOO

	LD	A,[ARPONOTO2]

	JP	_SETAN02
;_FOR4TOO
;               LD      A,[ARPONOTO2]
;               LD      [LOFRQWRD2],A
;		RET

_SETAN02	LD	C,A
	LD	B,$00
	LD	HL,FRQTABLE
	ADD	HL,BC
	ADD	HL,BC

	LD	A,[HLI]
	LD	[LOFRQWRD2],A
	LD	A,[HL]
	LD	[HIFRQWRD2],A
_NOARP02
	RET




;*****************************************************************************
;*                                                                           *
;*       CHANNEL 03 AUDIO-PLAY                                               *
;*                                                                           *
;*****************************************************************************


AUDIOPL3	LD	A,[VOICTEST3]	; CHECK IF CHANNEL IS ON
	CP	$01
	JP	Z,_PLAYON3
	RET

	;*********************************
	;*   SOUND-CHIP UPDATE SECTION	 *
	;*********************************


_PLAYON3
	LD	A,$80	; SOUND ON BIT <7>
	LD	[NR30],A	; TRANSFER A TO NR30

	xor	a	; HARDWARE-LENGTH 00
	LD	[NR31],A	; TRANSFER A TO NR31

	LD	A,[LOFRQWRD3]	; READ LOW-FREQUENCY
	LD	[NR33],A	; TRANSFER A TO NR33

	LD	A,[AMPLSAME3]
	LD	E,A
	LD	A,[AMPLITUD3]	; READ AMPLITUDE
	CP	E
	jp	Z,_NOINITSN3
	LD	[AMPLSAME3],A
	LD	[NR32],A

	LD	[AMPLITUD3],A	;!!!!!!!!!!!!!19aug99 ;
	LD	A,[HIFRQWRD3]
	OR	$80
	JP	_SETNR34

_NOINITSN3	LD	A,[HIFRQWRD3]	; READ HF
_SETNR34	LD	[NR34],A	; TRANSFER A TO NR34


	;*********************************
        ;*   SPEED-ROUTINE [TWO BYTES]   *
	;*********************************

	XOR	A	; SET REALPLAY TO $00
	LD	[REALPLAY3],A	;

	LD	A,[SPDCOUNT3]	; DECREASE SPEEDCOUNT
	DEC	A	;
	LD	[SPDCOUNT3],A	;
	JP	NZ,_SPDHDX3	; NOT 0, EXIT SPEED-HANDLE

	LD	A,[SPDCHECK3]	; INVERT SPDCHECK
	XOR	255	;
	LD	[SPDCHECK3],A	;
	JP	NZ,_SECONS3	; IF SPDCHECK $FF, GOTO 2ND-SPD

	LD	A,[AUDIONUM3]	; READ SPEED 01
	LD	C,A
	LD	B,$00	;
	LD	HL,AUDIOSPDA	;
	ADD	HL,BC	;
	LD	A,[HL]	;
	JP	_SPDSET3	; JUMP TO SPDSET

_SECONS3	LD	A,[AUDIONUM3]	; READ SPEED 02
	LD	C,A
	LD	B,$00	;
	LD	HL,AUDIOSPDB	;
	ADD	HL,BC	;
	LD	A,[HL]	;

_SPDSET3	LD	[SPDCOUNT3],A	; SET A TO SPDCOUNT
	LD	A,$FF	; SET REALPLAY TO $FF
	LD	[REALPLAY3],A	;

_SPDHDX3
	LD	A,[REALPLAY3]	; LENGTH SUBTRACTION NECESSARY?
	OR	A	;
	JP	Z,_NOSTPH3	; NO, GOTO...

_AUDIPL3	LD	A,[LENGCOPY3]	; DECREASE LENGTH
	DEC	A	;
	LD	[LENGCOPY3],A	;
	JP	Z,_STPHDL3	; IF 0, THEN GOTO STEPHANDLE

_NOSTPH3	LD	A,[REALNOTE3]	; IF REALNOTE PAUSED, NO FX
	CP	$FF
	CALL	NZ,_FXPLAY3

_NOFXPL3	XOR	A	; CLEAR NOTEINIT
	LD	[NOTEINIT3],A	;
	RET		;

	;*********************************
	;*   STEP-HANDLE		 *
	;*********************************


_STPHDL3
	XOR	A	; GLIDE-RESET [!]
	LD	[GLDSPEED3],A

	LD	A,[STPINDLO3]	; TRANSFER STEPINDEX TO HL
	LD	L,A
	LD	A,[STPINDHI3]
	LD	H,A

	LD	A,[HLI]

	CP	$FF	; STEP-END-CHECK
	jp	Z,_SEQHDL3	; YO, GOTO SEQUENCE-HANDLE

	JP	_STPHD23	; NO, GOTO STEPHANDLE 02

	;*********************************
	;*   SEQUENCE-HANDLE		 *
	;*********************************

_SEQHDL3
	LD	A,[SEQINDLO3]	; TAKE SEQUENCE-INDEX
	LD	L,A
	LD	A,[SEQINDHI3]
	LD	H,A

	LD	A,[HLI]

	CP	$FF	; SEQ-END-REPEAT-CHECK
	jp	NZ,_SEQHD23

	LD	E,[HL]	; TAKE SEQ-REPEAT POINT
	LD	A,[AUDIONUM3]	; RESET SEQINDEX WITH
	LD	C,A	; SEQREPEAT OFFSET
	LD	B,$00
	LD	HL,AUDIOTAB
	ADD	HL,BC

	LD	A,[HLI]	; READ 'RESTART' SEQINDEX
	LD	[SEQINDLO3],A
	LD	A,[HL]
	LD	[SEQINDHI3],A

	LD	A,[SEQINDLO3]	; TRANSFER SEQ-INDEX TO HL
	LD	L,A
	LD	A,[SEQINDHI3]
	LD	H,A

	LD	C,E
	ADD	HL,BC

	LD	A,[HLI]	; FIRST SEQUENCE TO REPEAT
	JP	_SEQHD53	; GOTO NEXT SEQUENCE

_SEQHD23	CP	$FE	; SEQ-STOP-CHECK
	jp	NZ,_SEQHD33	;
	xor	a	; YES, DISABLE VOICE
	LD	[VOICTEST3],A	;

	LD	a,[NR52]
	and	$fb
	ld	[nr52],a

	RET

_SEQHD33			;CP      $FC                     ; !!! DO THE FADE! GODDAMNED !!!
               ;jp      NZ,_SEQHD53             ; !!! STILL TO BE PROGRAMMED !!!

_SEQHD53	CP	$80	; NOTE TRANSPOSE CHECK
	jp	C,_SEQHD63
	AND	$7F
	LD	[TRANBYTE3],A

	LD	A,[HLI]
_SEQHD63
	CP	$70	; SFIX-TRANSPOSE CHECK
	jp	C,_SEQHD93
	AND	$0F
	LD	[SFXTRANS3],A
	LD	A,[HLI]

_SEQHD93
	ADD	A,A
	LD	[STEPNUMB3],A	; SET STEP & CLEAR STEPINDEX

	LD	A,L
	LD	[SEQINDLO3],A
	LD	A,H
	LD	[SEQINDHI3],A

	LD	A,[STEPNUMB3]	; CALCULATE STEP-INDEX+POSIT
	LD	C,A
	LD	B,$00
	LD	HL,STEPTAB
	ADD	HL,BC

	LD	A,[HLI]
	LD	[STPINDLO3],A
	LD	A,[HL]
	LD	[STPINDHI3],A

	JP	_STPHDL3	; BACK TO STEP-HANDLE

	;*********************************
	;*   STEP-HANDLE 2		 *
	;*********************************


_STPHD23	CP	$FD	; GLIDE CHECK IN STEP
	jp	NZ,_STPHD43
_STPHDG3	LD	A,[HLI]
	LD	[GLDSPEED3],A
	LD	A,[HLI]
	LD	E,A
	LD	A,[TRANBYTE3]
	ADD	A,E
	LD	[REALNOTE3],A
	LD	A,[HLI]
	LD	E,A
	LD	A,[TRANBYTE3]
	ADD	A,E
	LD	[DESTNOTE3],A
	JP	_NONEWN3

_STPHD43	CP	$E0	; PAUSE CHECK
	jp	C,_STPHD53
	AND	$1F
	LD	[REALLENG3],A
	LD	A,$FF
	LD	[REALNOTE3],A
	xor	a
	LD	[AMPLITUD3],A

	LD	A,L
	LD	[STPINDLO3],A
	LD	A,H
	LD	[STPINDHI3],A
	JP	_PAUSEX3

_STPHD53	CP	$C0	; SOUND CHECK
	jp	C,_STPHD63
	AND	$1F	;was $0F ???????????????
	LD	E,A
	LD	A,[SFXTRANS3]
	ADD	A,E
	ADD	A,A
	ADD	A,A
	LD	[REALSOUN3],A
	LD	A,[HLI]
	CP	$FD
	jp	Z,_STPHDG3
	CP	$C0
	jp	C,_STPHD63
	DEC	HL
	jp	_NONEWN3

_STPHD63	CP	$80	; LENGTH CHECK
	jp	C,_STPHD73
	AND	$7F
	LD	[REALLENG3],A
	LD	A,[HLI]
	CP	$FD
	jp	Z,_STPHDG3
	CP	$80
	jp	C,_STPHD73
	DEC	HL
	jp	_NONEWN3

_STPHD73	CP	$60	; ARP CHECK
	jp	C,_STPHD83
	AND	$1F
	LD	[ARPNUMBO3],A
	LD	A,[HLI]
	CP	$60
	jp	C,_STPHD83
	DEC	HL
	jp	_NONEWN3

_STPHD83
	LD	E,A	;SET NOTE + NOTE TRANSPOSE
	LD	A,[TRANBYTE3]
	ADD	A,E
	LD	[REALNOTE3],A

_NONEWN3
	LD	A,L
	LD	[STPINDLO3],A
	LD	A,H
	LD	[STPINDHI3],A

	LD	A,[NOTEINIT3]	;FIRST INIT HAS BEEN DONE
	INC	A	;
	LD	[NOTEINIT3],A	;

	LD	A,[REALSOUN3]	;!!!!!!!!!!!BUG FOUND!!!AUG99
	LD	C,A
	LD	B,$00
	LD	HL,SOUNDFIX
	ADD	HL,BC
	INC	HL	; TO SKIP PULS-INIT-VALUE

	LD	A,[HLI]
	LD	[FX01WORD3],A	; SET EFFECTS [ARP, ETC]
	LD	A,[HLI]
	LD	[FX02WORD3],A	; SET VIBRATO-DELAY + PULSTAB
	LD	A,[HL]
	LD	[FX03WORD3],A	; AMPLITUDE-TABLE-NR INTO FX03

;               CP      $03
;               JP      Z,_ITSFOR4

	LD	A,[REALNOTE3]	; READ REALNOTE AS INDEX
	LD	C,A
	LD	B,$00
	LD	HL,FRQTABLE
	ADD	HL,BC
	ADD	HL,BC
	LD	A,[HLI]	; HIGH-FREQUENCY <BIT 7-0>
	LD	[LOFRQWRD3],A	; HF SET
	LD	A,[HL]	; LOW-FREQUENCY <BIT 2-0>
	LD	[HIFRQWRD3],A	; LF SET
	JP	_PAUSEX3

;_ITSFOR4       LD      A,[REALNOTE3]
;               LD      [LOFRQWRD3],A

_PAUSEX3	LD	A,[REALLENG3]
	LD	[LENGCOPY3],A
	RET

	;*********************************
	;*   EFFECT-INIT TAKE 2		 *
	;*********************************


_FXPLAY3	LD	A,[NOTEINIT3]
	OR	A
	JP	Z,_PLYFXR3

_INTPLA3	LD	A,[GLDSPEED3]
	OR	A
	jp	Z,_FXPLA23
	LD	C,A
	SWAP	A
	AND	$0F
	LD	[GLDDELAY3],A
	LD	A,C
	AND	$0F
	LD	[GLDSPEED3],A

	LD	A,[GLDDELAY3]
	LD	E,A
	LD	A,[REALLENG3]
	SUB	E
	LD	[GLDDELAY3],A
	LD	A,[DESTNOTE3]
	LD	E,A
	LD	A,[REALNOTE3]
	SUB	E
	LD	[GLDDIREC3],A

_FXPLA23
	XOR	A
	LD	[AMPINDEX3],A
	LD	[VIBINDEX3],A
	LD	[ARPINDEX3],A

	LD	A,[FX02WORD3]
	SWAP	A
	AND	$0F
	LD	[VIBDELAY3],A
	LD	A,[VIBDELAY3]
	LD	E,A
	LD	A,[REALLENG3]
	SUB	E
	jp	NC,_REFIX03
	LD	A,[FX01WORD3]
	AND	$F0
	LD	[FX01WORD3],A
	LD	A,[REALLENG3]
_REFIX03	LD	[VIBDELAY3],A
_EXITIN3	JP	_NOVIB03


_PLYFXR3

	;*********************************
	;*   GLIDE-ROUTINE		 *
	;*********************************

_GLIDER3	LD	A,[GLDSPEED3]	;GLIDE ROUTINE
	OR	A
	JP	Z,_NOGLD23

	LD	A,[GLDDELAY3]
	LD	E,A
	LD	A,[LENGCOPY3]
	CP	E
	JP	NC,_NOGLD23

	LD	A,[GLDDIREC3]
	CP	$80
	JP	C,_DOWNGL3

	LD	A,[LOFRQWRD3]
	LD	E,A
	LD	A,[GLDSPEED3]
	ADD	A,E
	LD	[LOFRQWRD3],A
	jp	NC,_CHECV13
	LD	A,[HIFRQWRD3]
	INC	A
	LD	[HIFRQWRD3],A

_CHECV13
	LD	A,[LOFRQWRD3]
	LD	E,A
	LD	A,[HIFRQWRD3]
	LD	D,A

	LD	A,[DESTNOTE3]
	LD	C,A
	LD	B,$00
	LD	HL,FRQTABLE
	ADD	HL,BC
	ADD	HL,BC
	LD	A,[HLI]
	SUB	E
	LD	A,[HL]
	SBC	A,D
	jp	C,_FROTER3
	jp	_NOGLD03

_DOWNGL3
	LD	A,[GLDSPEED3]
	LD	E,A
	LD	A,[LOFRQWRD3]
	SUB	E
	LD	[LOFRQWRD3],A
	jp	NC,_CHECV23
	LD	A,[HIFRQWRD3]
	DEC	A
	LD	[HIFRQWRD3],A

_CHECV23
	LD	A,[DESTNOTE3]
	LD	C,A
	LD	B,$00
	LD	HL,FRQTABLE
	ADD	HL,BC
	ADD	HL,BC
	LD	A,[HLI]
	LD	E,A
	LD	A,[HL]
	LD	D,A

	LD	A,[LOFRQWRD3]
	SUB	E
	LD	A,[HIFRQWRD3]
	SBC	A,D

	jp	C,_FROTER3
	jp	_NOGLD03

_FROTER3	LD	A,C	; DESTINATION NOTE BECOMES
	LD	[REALNOTE3],A	; REAL NOTE
	LD	C,A
	LD	B,$00
	LD	HL,FRQTABLE
	ADD	HL,BC
	ADD	HL,BC
	LD	A,[HLI]	; READ NEW FREQUENCY
	LD	[LOFRQWRD3],A
	LD	A,[HL]
	LD	[HIFRQWRD3],A

	XOR	A
	LD	[GLDSPEED3],A
_NOGLD03	JP	_NOVIB03
_NOGLD23


	;*********************************
	;*   VIBRATO-ROUTINE		 *
	;*********************************

_VIBRA03	LD	A,[FX01WORD3]	;VIBRATO ROUTINE
	AND	$0F
	jp	Z,_NOVIB03
	LD	A,[LENGCOPY3]
	LD	E,A
	LD	A,[VIBDELAY3]
	CP	E
	jp	C,_NOVIB03

	LD	A,[FX01WORD3]
	AND	$0F
	LD	C,A
	LD	B,$00
	LD	HL,VIBTAB
	ADD	HL,BC
	ADD	HL,BC

	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	A,[VIBINDEX3]
	LD	C,A
	LD	B,$00
	ADD	HL,BC
	LD	A,[HL]
	CP	$80
	jp	NZ,_VIBER03

	LD	A,[FX01WORD3]
	AND	$0F
	LD	C,A
	LD	B,$00
	LD	HL,VIBTAB
	ADD	HL,BC
	ADD	HL,BC

	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	C,$00

_VIBER03	LD	A,[HL]
	CP	$80
	JP	C,_UPVIBO3
	XOR	$FF
	ADD	A,$01
	LD	E,A

	LD	A,[LOFRQWRD3]
	SUB	E
	LD	[LOFRQWRD3],A
	jp	NC,_NOHIG13
	LD	A,[HIFRQWRD3]
	DEC	A
	LD	[HIFRQWRD3],A
_NOHIG13	JP	_VIBNO03

_UPVIBO3	LD	E,A
	LD	A,[LOFRQWRD3]
	ADD	A,E
	LD	[LOFRQWRD3],A
	jp	NC,_NOHIG23
	LD	A,[HIFRQWRD3]
	INC	A
	LD	[HIFRQWRD3],A
_NOHIG23
_VIBNO03	LD	A,C
	INC	A
	LD	[VIBINDEX3],A
_NOVIB03


	;*********************************
	;*   AMPLITUDE-ROUTINE		 *
	;*********************************

;               LD      A,[REALLENG3]           ;CHECK IF THE REAL LENGCOPYTH IS 1
;               CP      $1
;               JP      Z,_AMPLIT3                      ;IF SO, DO NOT CUT NOTE OFF AT END
;
;               LD      A,[LENGCOPY3]
;               CP      $01
;               JP      NZ,_AMPLIT3
;               LD      A,[SPDCOUNT3]           ;!
;               CP      $1                      ;!
;               JP      NC,_AMPLIT3             ;!
;
;               LD      A,[AMPLITUD3]           ;+ THIS FADE THE VOLUME  BY FORMULA X/2
;		SRL	A			;+
;               LD      [AMPLITUD3],A           ;+
;               JP      _NOAMPL3                ;+

;               LD      [AMPLITUD3],$00         ; THIS WOULD CUT VOLUME TO 00!
;               JP      _NOAMPL3



_AMPLIT3	LD	A,[FX03WORD3]	;AMPLITUDE ROUTINE
	AND	$7F
	LD	C,A
	LD	B,$00
	LD	HL,AMPTAB
	ADD	HL,BC
	ADD	HL,BC
	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	A,[AMPINDEX3]
	LD	C,A
	ADD	HL,BC
	LD	A,[HL]
	CP	$FE
	jp	Z,_NOAMPL3

;               ld      a,$20                    ; !!!!!!!! GEWOON HARD MAN!
;               SWAP    A                       ; !!!!!!!!!!!!! WEGGEHAALD AUG99
;               SRA     A                       ; SHIFT AMPLITUDE TO BIT <6-3>
;               AND     $60                     ; KEEP BIT <6-5>
	LD	[AMPLITUD3],A

	LD	A,[AMPINDEX3]
	INC	A
	LD	[AMPINDEX3],A
_NOAMPL3


	;*********************************
	;*   ARPEGGIO-ROUTINE		 *
	;*********************************

_ARPEG03	LD	A,[FX01WORD3]	;ARPEGGIO ROUTINE
	AND	$40
	JP	Z,_NOARP03

	LD	A,[FX01WORD3]	; ONLY USE WHEN $20+ ARPS
	AND	$80	; REQUIRED
	JP	Z,_ARPBNK3	; OTHERWISE REMOVE !!!
	LD	A,[ARPNUMBO3]	;
	set	5,a	;
	JP	_ARPSET3
_ARPBNK3	LD	A,[ARPNUMBO3]
_ARPSET3	LD	C,A
	LD	B,$00
	LD	HL,ARPTAB
	ADD	HL,BC
	ADD	HL,BC

	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	A,[ARPINDEX3]
	LD	C,A
	LD	B,$00
	ADD	HL,BC

	LD	A,[HLI]
	CP	$FF	; REPEAT ARPEGGIO?
	jp	NZ,_ARPER03

	LD	A,[HL]
	LD	E,A

	LD	A,[FX01WORD3]	; ONLY USE WHEN $20+ ARPS
	AND	$80	; REQUIRED
	jp	Z,_ARPBN23	; OTHERWISE REMOVE !!!
	LD	A,[ARPNUMBO3]	;
	set	5,a	;
	JP	_ARPSE23	;
_ARPBN23	LD	A,[ARPNUMBO3]	;
_ARPSE23	LD	C,A
	LD	HL,ARPTAB
	ADD	HL,BC
	ADD	HL,BC

	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	C,E
	LD	B,$00
	ADD	HL,BC

	LD	A,[HLI]

_ARPER03	CP	$FE
	jp	Z,_NOARP03
	CP	$80
	JP	NC,_NORMA03
	LD	E,A
	LD	A,[REALNOTE3]
	ADD	A,E

_NORMA03	AND	$7F
	LD	[ARPONOTO3],A
	LD	A,C
	INC	A
	LD	[ARPINDEX3],A
_ARPNO03

;               CP      $03
;               JP      Z,_FOR4TOO

	LD	A,[ARPONOTO3]

	LD	C,A
	LD	B,$00
	LD	HL,FRQTABLE
	ADD	HL,BC
	ADD	HL,BC

	LD	A,[HLI]
	LD	[LOFRQWRD3],A
	LD	A,[HL]
	LD	[HIFRQWRD3],A
_NOARP03
	RET

;*****************************************************************************
;*                                                                           *
;*       CHANNEL 04 AUDIO-PLAY                                               *
;*                                                                           *
;*****************************************************************************


AUDIOPL4	LD	A,[VOICTEST4]	; CHECK IF CHANNEL IS ON
	CP	$01
	JP	Z,_PLAYON4
	RET

	;*********************************
	;*   SOUND-CHIP UPDATE SECTION	 *
	;*********************************


_PLAYON4
	xor	a	; HARDWARE-LENGTH 00
	LD	[NR41],A	; TRANSFER A TO NR41

	LD	A,[ARPONOTO4]	; READ REALNOTE AS INDEX
;               LD      A,[REALNOTE4]
	LD	C,A
	LD	B,$00
	LD	HL,FRQNOISE
	ADD	HL,BC
	LD	A,[HLI]	; HIGH-FREQUENCY <BIT 7-0>
	LD	[NR43],A	; TRANSFER A TO NR43

	LD	A,[AMPLSAME4]
	LD	E,A
	LD	A,[AMPLITUD4]	; READ AMPLITUDE
	CP	E
	jp	Z,_NOINITSN4
	LD	[AMPLSAME4],A
	LD	[NR42],A

	LD	A,$80
	LD	[NR44],A
_NOINITSN4

	;*********************************
        ;*   SPEED-ROUTINE [TWO BYTES]   *
	;*********************************

	XOR	A	; SET REALPLAY TO $00
	LD	[REALPLAY4],A	;

	LD	A,[SPDCOUNT4]	; DECREASE SPEEDCOUNT
	DEC	A	;
	LD	[SPDCOUNT4],A	;
	JP	NZ,_SPDHDX4	; NOT 0, EXIT SPEED-HANDLE

	LD	A,[SPDCHECK4]	; INVERT SPDCHECK
	XOR	255	;
	LD	[SPDCHECK4],A	;
	JP	NZ,_SECONS4	; IF SPDCHECK $FF, GOTO 2ND-SPD

	LD	A,[AUDIONUM4]	; READ SPEED 01
	LD	C,A
	LD	B,$00	;
	LD	HL,AUDIOSPDA	;
	ADD	HL,BC	;
	LD	A,[HL]	;
	JP	_SPDSET4	; JUMP TO SPDSET

_SECONS4	LD	A,[AUDIONUM4]	; READ SPEED 02
	LD	C,A
	LD	B,$00	;
	LD	HL,AUDIOSPDB	;
	ADD	HL,BC	;
	LD	A,[HL]	;

_SPDSET4	LD	[SPDCOUNT4],A	; SET A TO SPDCOUNT
	LD	A,$FF	; SET REALPLAY TO $FF
	LD	[REALPLAY4],A	;

_SPDHDX4
	LD	A,[REALPLAY4]	; LENGTH SUBTRACTION NECESSARY?
	OR	A	;
	JP	Z,_NOSTPH4	; NO, GOTO...

_AUDIPL4	LD	A,[LENGCOPY4]	; DECREASE LENGTH
	DEC	A	;
	LD	[LENGCOPY4],A	;
	JP	Z,_STPHDL4	; IF 0, THEN GOTO STEPHANDLE

_NOSTPH4	LD	A,[REALNOTE4]	; IF REALNOTE PAUSED, NO FX
	CP	$FF
	CALL	NZ,_FXPLAY4

_NOFXPL4	XOR	A	; CLEAR NOTEINIT
	LD	[NOTEINIT4],A	;
	RET		;

	;*********************************
	;*   STEP-HANDLE		 *
	;*********************************


_STPHDL4
	LD	A,[STPINDLO4]	; TRANSFER STEPINDEX TO HL
	LD	L,A
	LD	A,[STPINDHI4]
	LD	H,A

	LD	A,[HLI]

	CP	$FF	; STEP-END-CHECK
	jp	Z,_SEQHDL4	; YO, GOTO SEQUENCE-HANDLE

	JP	_STPHD24	; NO, GOTO STEPHANDLE 02

	;*********************************
	;*   SEQUENCE-HANDLE		 *
	;*********************************

_SEQHDL4
	LD	A,[SEQINDLO4]	; TAKE SEQUENCE-INDEX
	LD	L,A
	LD	A,[SEQINDHI4]
	LD	H,A

	LD	A,[HLI]

	CP	$FF	; SEQ-END-REPEAT-CHECK
	jp	NZ,_SEQHD24

	LD	E,[HL]	; TAKE SEQ-REPEAT POINT
	LD	A,[AUDIONUM4]	; RESET SEQINDEX WITH
	LD	C,A	; SEQREPEAT OFFSET
	LD	B,$00
	LD	HL,AUDIOTAB
	ADD	HL,BC

	LD	A,[HLI]	; READ 'RESTART' SEQINDEX
	LD	[SEQINDLO4],A
	LD	A,[HL]
	LD	[SEQINDHI4],A

	LD	A,[SEQINDLO4]	; TRANSFER SEQ-INDEX TO HL
	LD	L,A
	LD	A,[SEQINDHI4]
	LD	H,A

	LD	C,E
	ADD	HL,BC

	LD	A,[HLI]	; FIRST SEQUENCE TO REPEAT
	JP	_SEQHD54	; GOTO NEXT SEQUENCE

_SEQHD24	CP	$FE	; SEQ-STOP-CHECK
	jp	NZ,_SEQHD34	;
	xor	a	; YES, DISABLE VOICE
	LD	[VOICTEST4],A	;

	LD	a,[NR52]
	and	$f7
	ld	[nr52],a

	RET

_SEQHD34			;CP      $FC                     ; !!! DO THE FADE! GODDAMNED !!!
               ;jp      NZ,_SEQHD54             ; !!! STILL TO BE PROGRAMMED !!!

_SEQHD54
_SEQHD64
_SEQHD94
	ADD	A,A
	LD	[STEPNUMB4],A	; SET STEP & CLEAR STEPINDEX

	LD	A,L
	LD	[SEQINDLO4],A
	LD	A,H
	LD	[SEQINDHI4],A

	LD	A,[STEPNUMB4]	; CALCULATE STEP-INDEX+POSIT
	LD	C,A
	LD	B,$00
	LD	HL,STEPTAB
	ADD	HL,BC

	LD	A,[HLI]
	LD	[STPINDLO4],A
	LD	A,[HL]
	LD	[STPINDHI4],A

	JP	_STPHDL4	; BACK TO STEP-HANDLE

	;*********************************
	;*   STEP-HANDLE 2		 *
	;*********************************


_STPHD24
_STPHD44	CP	$E0	; PAUSE CHECK
	jp	C,_STPHD54
	AND	$1F
	LD	[REALLENG4],A
	LD	A,$FF
	LD	[REALNOTE4],A
	xor	a
	LD	[AMPLITUD4],A

	LD	A,L
	LD	[STPINDLO4],A
	LD	A,H
	LD	[STPINDHI4],A
	JP	_PAUSEX4

_STPHD54	CP	$C0	; SOUND CHECK
	jp	C,_STPHD64
	AND	$1F
	ADD	A,A
	ADD	A,A
	LD	[REALSOUN4],A
	LD	A,[HLI]
	CP	$C0
	jp	C,_STPHD64
	DEC	HL
	jp	_NONEWN4

_STPHD64	CP	$80	; LENGTH CHECK
	jp	C,_STPHD74
	AND	$7F
	LD	[REALLENG4],A
	LD	A,[HLI]
	CP	$80
	jp	C,_STPHD74
	DEC	HL
	jp	_NONEWN4

_STPHD74
	CP	$60	; ARP CHECK
	jp	C,_STPHD84
	AND	$1F
	LD	[ARPNUMBO4],A
	LD	A,[HLI]
	CP	$60
	jp	C,_STPHD84
	DEC	HL
	jp	_NONEWN4

_STPHD84
	LD	[REALNOTE4],A
	LD	[ARPONOTO4],A
_NONEWN4
	LD	A,L
	LD	[STPINDLO4],A
	LD	A,H
	LD	[STPINDHI4],A

	LD	A,[NOTEINIT4]	;FIRST INIT HAS BEEN DONE
	INC	A	;
	LD	[NOTEINIT4],A	;

	xor	a
	LD	[AMPINDEX4],A
	LD	[ARPINDEX4],A

	LD	A,[REALSOUN4]	; FOUND BUG !!!! AUG99!!!!
	LD	C,A
	LD	B,$00
	LD	HL,SOUNDFIX
	ADD	HL,BC
	INC	HL	; TO SKIP PULS-INIT-VALUE

	LD	A,[HLI]
	LD	[FX01WORD4],A	; SET EFFECTS [ARP, ETC]
	INC	HL	; TO SKIP VIBDEL&PULTABIDX
	LD	A,[HLI]
	LD	[FX03WORD4],A	; AMPLITUDE-TABLE-NR INTO FX03

_PAUSEX4	LD	A,[REALLENG4]
	LD	[LENGCOPY4],A
	RET

	;*********************************
	;*   EFFECT-INIT TAKE 2		 *
	;*********************************


_FXPLAY4
_INTPLA4
_FXPLA24
_PLYFXR4


	;*********************************
	;*   AMPLITUDE-ROUTINE		 *
	;*********************************

;               LD      A,[REALLENG4]           ;CHECK IF THE REAL LENGCOPYTH IS 1
;               CP      $01
;               JP      Z,_AMPLIT4              ;IF SO, DO NOT CUT NOTE OFF AT END
;
;               LD      A,[LENGCOPY4]
;               CP      $01
;               JP      NZ,_AMPLIT4
;               LD      A,[SPDCOUNT4]           ;!
;               CP      $1                      ;!
;               JP      NC,_AMPLIT4             ;!
;
;               LD      A,[AMPLITUD4]           ;+ THIS FADE THE VOLUME  BY FORMULA X/2
;		SRL	A			;+
;               LD      [AMPLITUD4],A           ;+
;               JP      _NOAMPL4                ;+

;               LD      [AMPLITUD4],$00         ; THIS WOULD CUT VOLUME TO 00!
;               JP      _NOAMPL4



_AMPLIT4
	LD	A,[FX03WORD4]	;AMPLITUDE ROUTINE
	AND	$7F
	LD	C,A
	LD	B,$00
	LD	HL,AMPTAB
	ADD	HL,BC
	ADD	HL,BC
	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	A,[AMPINDEX4]
	LD	C,A
	ADD	HL,BC
	LD	A,[HL]
	CP	$FE
	jp	Z,_NOAMPL4
	SWAP	A
	LD	[AMPLITUD4],A

	LD	A,[AMPINDEX4]
	INC	A
	LD	[AMPINDEX4],A
_NOAMPL4

	;*********************************
	;*   ARPEGGIO-ROUTINE		 *
	;*********************************

_ARPEG04	LD	A,[FX01WORD4]	;ARPEGGIO ROUTINE
	AND	$40
	JP	Z,_NOARP04

	LD	A,[FX01WORD4]	; ONLY USE WHEN $20+ ARPS
	AND	$80	; REQUIRED
	JP	Z,_ARPBNK4	; OTHERWISE REMOVE !!!
	LD	A,[ARPNUMBO4]	;
	set	5,A	;
	JP	_ARPSET4
_ARPBNK4	LD	A,[ARPNUMBO4]
_ARPSET4	LD	C,A
	LD	B,$00
	LD	HL,ARPTAB
	ADD	HL,BC
	ADD	HL,BC

	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	A,[ARPINDEX4]
	LD	C,A
	LD	B,$00
	ADD	HL,BC

	LD	A,[HLI]
	CP	$FF	; REPEAT ARPEGGIO?
	jp	NZ,_ARPER04

	LD	A,[HL]
	LD	E,A

	LD	A,[FX01WORD4]	; ONLY USE WHEN $20+ ARPS
	AND	$80	; REQUIRED
	jp	Z,_ARPBN24	; OTHERWISE REMOVE !!!
	LD	A,[ARPNUMBO4]	;
	set	5,a	;
	JP	_ARPSE24	;
_ARPBN24	LD	A,[ARPNUMBO4]	;
_ARPSE24	LD	C,A
	LD	HL,ARPTAB
	ADD	HL,BC
	ADD	HL,BC

	LD	A,[HLI]
	LD	C,A
	LD	A,[HL]
	LD	H,A
	LD	L,C

	LD	C,E
	LD	B,$00
	ADD	HL,BC

	LD	A,[HLI]

_ARPER04	CP	$FE
	jp	Z,_NOARP04
	CP	$80
	JP	NC,_NORMA04

	LD	E,A
	LD	A,[REALNOTE4]
	ADD	A,E
_NORMA04
	AND	$7F

	LD	[ARPONOTO4],A
	LD	A,C
	INC	A
	LD	[ARPINDEX4],A
;_ARPNO04
_NOARP04
	RET

;----------------------------------------------------------------------------------------------------------------------
FRQTABLE
	.DW	$0010,$0082,$00EE,$0153,$01B3,$020E,$0263,$02B4,$0300,$0348,$038C,$03CC	;1
	.DW	$0408,$0441,$0477,$04AA,$04DA,$0507,$0532,$055A,$0580,$05A4,$05C6,$05E6	;2
	.DW	$0604,$0621,$063B,$0655,$066D,$0683,$0699,$06AD,$06C0,$06D2,$06E3,$06F3	;3
	.DW	$0702,$0710,$071E,$072A,$0736,$0742,$074C,$0756,$0760,$0769,$0771,$0779	;4
	.DW	$0781,$0788,$078F,$0795,$079B,$07A1,$07A6,$07AB,$07B0,$07B4,$07B9,$07BD	;5
	.DW	$07C1,$07C4,$07C7,$07CB,$07CE,$07D0,$07D3,$07D6,$07D8,$07DA,$07DC,$07DE	;6
	.DW	$07E0,$07E2,$07E4,$07E5,$07E7,$07E8,$07EA,$07EB,$07EC,$07ED,$07EE,$07EF	;7
	.DW	$07F0,$07F1,$07F2,$07F3,$07F4,$07F5,$07F6,$07F7,$07F8,$07F9,$07FA,$07FB	;+/-8
FRQNOISE
	.DB	$D7,$D6,$D5,$D4,$C7,$C6,$C5,$C4	;50=$32 different
	.DB	$B7,$B6,$B5,$B4,$A7,$A6,$A5,$A4	;HEIGHTS
	.DB	$97,$96,$95,$94,$87,$86,$85,$84
	.DB	$77,$76,$75,$74,$67,$66,$65,$64
	.DB	$57,$56,$55,$54,$47,$46,$45,$44
	.DB	$37,$36,$35,$34,$27,$26,$25,$24
	.DB	$17,$16

;----------------------------------------------------------------------------------------------------------------------
; Note range Channel 1,2,3   = $00-$5F
; Note range Channel 4 NOISE = $00-$31
; NO TRANSPOSE for channel 4 in the SEQUENCE HANDLING!
; CHANNEL 3 envelopes are $20=100%, $40=50%, $60=25% and $00=OFF
;
;----------------------------------------------------------------------------------------------------------------------




;****************************************
;*       MUSIC DATA
;****************************************

STEPTAB
	.DW	S00,S01,S02,S03,S04,S05,S06,S07,S08,S09,S0A,S0B,S0C,S0D,S0E,S0F
	.DW	S10,S11,S12,S13,S14,S15,S16,S17,S18,S19,S1A,S1B,S1C,S1D,S1E,S1F
	.DW	S20,S21,S22,S23,S24,S25,S26,S27,S28,S29,S2A,S2B,S2C,S2D,S2E,S2F
	.DW	S30,S31,S32,S33,S34,S35,S36,S37,S38,S39,S3A,S3B,S3C,S3D,S3E,S3F
	.DW	S40,S41,S42,S43,S44,S45,S46,S47,S48,S49,S4A,S4B,S4C,S4D,S4E,S4F
	.DW	S50,S51,S52,S53,S54,S55,S56,S57,S58,S59,S5A,S5B,S5C,S5D,S5E,S5F
;               .DW      S60,S61,S62,S63,S64,S65,S66,S67,S68,S69,S6A,S6B,S6C,S6D,S6E,S6F
;               .DW      S70,S71,S72,S73,S74,S75,S76,S77,S78,S79,S7A,S7B,S7C,S7D,S7E,S7F

AMPTAB
	.DW	AM00,AM01,AM02,AM03,AM04,AM05,AM06,AM07
	.DW	AM08,AM09,AM0A,AM0B,AM0C,AM0D,AM0E,AM0F
	.DW	AM10,AM11,AM12,AM13,AM14,AM15,AM16,AM17
	.DW	AM18,AM19,AM1A,AM1B
VIBTAB	.DW	AM1C
	.DW	V01,V02,V03

PULTAB	.DW	V04
	.DW	P01,P02,P03,P04,P05,P06,P07

ARPTAB	.DW	A00,A01,A02,A03,A04,A05,A06,A07
	.DW	A08,A09,A0A,A0B,A0C,A0D,A0E,A0F
	.DW	A10,A11,A12,A13,A14,A15,A16,A17
	.DW	A18,A19,A1A,A1B,A1C,A1D,A1E,A1F
	.DW	A20,A21,A22,A23,A24,A25,A26,A27
	.DW	A28,A29,A2A,A2B,A2C,A2D,A2E,A2F
	.DW	A30,A31,A32,A33,A34,A35,A36,A37
	.DW	A38,A39,A3A,A3B,A3C,A3D,A3E,A3F
;---------------------------------------------------------------------------

SFXTAB0	.DB	$01,$05,$08,$0b,$0e,$12,$16,$19
	.DB	$00,$00,$00,$00,$00,$00,$00,$00
	.DB	$00,$00,$00,$00,$00,$00,$00,$00
	.DB	$00,$2e,$00,$00,$00,$00,$00,$00
	.DB	$00,$00,$00,$00,$00,$00,$00,$00
	.DB	$00,$00,$00,$00,$00,$00,$00,$00
	.DB	$00,$00,$00

SFXTAB1	.DB	$02,$00,$00,$00,$0f,$13,$00,$1a
	.DB	$1d,$1e,$1f,$20,$21,$22,$23,$24
	.DB	$25,$26,$27,$28,$29,$2a,$2b,$2c
	.DB	$2d,$00,$00,$00,$00,$00,$00,$00
	.DB	$00,$00,$00,$00,$00,$00,$00,$00
	.DB	$00,$00,$00,$00,$00,$00,$00,$00

SFXTAB2	.DB	$03,$06,$09,$0c,$10,$14,$17,$1b
	.DB	$00,$00,$00,$00,$00,$00,$00,$00
	.DB	$00,$00,$00,$00,$00,$00,$00,$00
	.DB	$00,$2f,$00,$00,$00,$00,$00,$00
	.DB	$00,$00,$00,$00,$00,$00,$00,$00
	.DB	$00,$00,$00,$00,$00,$00,$00,$00

SFXTAB3	.DB	$04,$07,$0a,$0d,$11,$15,$18,$1c
	.DB	$00,$00,$00,$00,$00,$00,$00,$00
	.DB	$00,$00,$00,$00,$00,$00,$00,$00
	.DB	$00,$30,$00,$00,$00,$00,$00,$00
	.DB	$00,$00,$00,$00,$00,$00,$00,$00
	.DB	$00,$00,$00,$00,$00,$00,$00,$00

                                         ; LD A
AUDIOTAB
	.DW	CLEARAUD	; $00 $XX
	.DW	TITLE1A	; $01 $00
	.DW	TITLE1B	; $02 $02
	.DW	TITLE1C	; $03,$03
	.DW	TITLE1D	; $04 $00
	.DW	LEVEL1A	; $05 $00
	.DW	LEVEL1C	; $06 $02
	.DW	LEVEL1D	; $07,$03
	.DW	LEVEL2A	; $08 $00
	.DW	LEVEL2C	; $09 $02
	.DW	LEVEL2D	; $0a,$03
	.DW	LEVEL3A	; $0b $00
	.DW	LEVEL3C	; $0c $02
	.DW	LEVEL3D	; $0d,$03
	.DW	COMPLETEDA	; $0e,$00
	.DW	COMPLETEDB	; $0f,$01
	.DW	COMPLETEDC	; $10,$02
	.DW	COMPLETEDD	; $11,$03
	.DW	VICTORYA	; $12,$00
	.DW	VICTORYB	; $13,$01
	.DW	VICTORYC	; $14,$02
	.DW	VICTORYD	; $15,$03
	.DW	LEVEL4A	; $16 $00
	.DW	LEVEL4C	; $17 $02
	.DW	LEVEL4D	; $18,$03
	.DW	GAMEOVERA	; $19 $00
	.DW	GAMEOVERB	; $1a $01
	.DW	GAMEOVERC	; $1b,$02
	.DW	GAMEOVERD	; $1c,$03
	.DW	FXSHOOT1	; $1d,$01
	.DW	FXSHOOT2	; $1e,$01
	.DW	FXSHOOT3	; $1f,$01
	.DW	FXSHOOT4	; $20,$01
	.DW	FXSHOOT5	; $21,$01
	.DW	FXSHOOT6	; $22,$01
	.DW	FXSHOOT7	; $23,$01
	.DW	FXSHOOT8	; $24,$01
	.DW	EXPLOSION	; $25,$01
	.DW	EXPLOSIONMID	; $26,$01
	.DW	EXPLOSIONBIG	; $27,$01
	.DW	PICKUP1	; $28,$01
	.DW	PICKUP2	; $29,$01
	.DW	PICKUP3	; $2a,$01
	.DW	PICKUP4	; $2b,$01
	.DW	PICKUP5	; $2c,$01
	.DW	PICKUP6	; $2d,$01
	.DW	LEVEL5A	; $2e $00
	.DW	LEVEL5C	; $2f $02
	.DW	LEVEL5D	; $30,$03

AUDIOSPDA	.DB	$01
AUDIOSPDB	.DB	$01	; $00 $XX
	.DB	$03,$03	; $01 $00
	.DB	$03,$03	; $02 $01
	.DB	$03,$03	; $03 $02
	.DB	$03,$03	; $04 $02
	.DB	$06,$05	; $05 $00
	.DB	$06,$05	; $06 $02
	.DB	$06,$05	; $07 $03
	.DB	$03,$03	; $08 $00
	.DB	$03,$03	; $09 $02
	.DB	$03,$03	; $0a $03
	.DB	$04,$04	; $0b $00
	.DB	$04,$04	; $0c $02
	.DB	$04,$04	; $0d $03
	.DB	$03,$03	; $0e $00
	.DB	$03,$03	; $0f $01
	.DB	$03,$03	; $10 $02
	.DB	$03,$03	; $11 $03
	.DB	$04,$04	; $12 $00
	.DB	$04,$04	; $13 $01
	.DB	$04,$04	; $14 $02
	.DB	$04,$04	; $15 $03
	.DB	$04,$04	; $16 $00
	.DB	$04,$04	; $17 $02
	.DB	$04,$04	; $18 $03
	.DB	$04,$03	; $19 $00
	.DB	$04,$03	; $1a $01
	.DB	$04,$03	; $1b $02
	.DB	$04,$03	; $1c $03
	.DB	$03,$03	; $1d $01
	.DB	$03,$03	; $1e $01
	.DB	$01,$01	; $1f $01
	.DB	$03,$03	; $20 $01
	.DB	$03,$03	; $21 $01
	.DB	$03,$03	; $22 $01
	.DB	$03,$03	; $23 $01
	.DB	$03,$03	; $24 $01
	.DB	$03,$03	; $25 $01
	.DB	$03,$03	; $26 $01
	.DB	$03,$03	; $27 $01
	.DB	$03,$03	; $28 $01
	.DB	$03,$03	; $29 $01
	.DB	$03,$03	; $2a $01
	.DB	$03,$03	; $2b $01
	.DB	$03,$03	; $2c $01
	.DB	$03,$03	; $2d $01
	.DB	$04,$03	; $2e $00
	.DB	$04,$03	; $2f $02
	.DB	$04,$03	; $30 $03
;---------------------------------------------------------------------------
AM00
	.DB	$20,$20,$20,$20,$20,$20,$40,$FE
AM01
	.DB	$20,$20,$20,$20,$00,$FE
AM02
	.DB	$0e,$08,$FE
AM03
	.db	9,8,7,6,6,6,5,5,5,4,5,4,4,4,4,3,4,3,4
	.db	3,3,3,3,2,3,2,3,2,2,2,2,1,2,1,2,1,1,1,1,0,1,0,1,0,$fe
AM04
	.db	8,6,3,1,0,$fe
AM05
	.db	10,7,6,5,5,4,4,3,3,2,2,1,1,0,$fe
AM06
	.db	8,7,6,5,4,3,2,1,0,$fe
AM07
	.db	8,8,8,7,7,7,6,6,6,5,5,5,4,$fe
AM08
	.DB	$0a,$09,$08,$FE
AM09
	.db	$07,$04,$FE
AM0A
	.db	10,6,6,0,$fe
AM0B
	.db	10,6,6,6,6,6,6,6,6,6,4,2,0,$fe
AM0C
	.db	$05,$05,$04,$fe
AM0D
	.db	10,6,$fe
AM0E
	.db	13,8,8,8,8,1,$fe
AM0F
	.db	10,6,6,6,6,1,$fe
AM10
	.db	8,4,4,4,4,1,$fe
AM11
	.db	6,2,2,2,2,1,$fe
AM12
	.db	12,12,8,8,7,7,7,6,6,6,5,5,5,4,4,4,3,3,3,2,2,2,1,$fe
AM13
	.db	$0b,$0a,$0a,$0a,$0a,$0a
	.db	4,4,4,4,3,3,3,3,2,$fe
AM14
	.db	$0b,$0a,$0a,$0a,$0a,$0a,$0a,$0a,$0a,$0a,$0a,$0a
	.db	4,4,4,4,3,3,3,3,2,$fe
AM15
	.db	$09,$07,$07,$07,$07,$07
	.db	3,3,3,3,2,$fe
AM16
	.db	14,13,12,11,10,9,,8,7,6,5,4,3,3,2,2,2,1,1,1,0,$fe
AM17
	.db	14,13,12,10,8,6,5,4,3,2,1,1,1,0,$fe
AM18
	.db	14,13,12,12,11,11,10,9,8,7,6,5,4,4,3,3,2,2,2,1,1,1,0,$fe
AM19
	.db	13,13,12,11,9,8,7,6,5,4,3,2,2,1,1,0,$fe
AM1A
	.db	15,15,15,14,13,12,11,11,10,10,9,9,9
	.db	8,8,8,7,7,7,6,6,6,5,5,5,5,4,4,4,4,3,3,3,3,2,2,2,2,1,1,1,1,0,$fe
AM1B
	.db	15,15,15,15,15,14,14,14,14,13,13,13,13,12,12,12,12
	.db	11,11,11,11,10,10,10,10,9,9,9,9,8,8,8,8,7,7,7,7
	.db	6,6,6,6,5,5,5,5,4,4,4,4,4,3,3,3,3,3,3,2,2,2,2,2
	.db	2,2,2,1,1,1,1,1,1,1,1,0,$fe
AM1C
	.db	13,12,11,10,9,9,8,8,7,7,7,6,6,6,6
	.db	5,5,5,5,5,5,4,5,4,4,4,4,4,4,4,3,4,3,3,3,3,3,3,3,3,2,3,2
	.db	2,2,2,2,2,2,2,2,1,2,1,1,1,1,1,1,1,1,1,1,0,$fe
;-----------------------------------------------------------------------------
V01
	.DB	$01,$01,$01,$FF,$FF,$FF
	.DB	$FF,$FF,$FF,$01,$01,$01
	.DB	$80
V02
	.db	$50,$50,$b0,$b0,$60,$60,$a0,$a0
	.db	$70,$70,$90,$90,$60,$60,$a0,$a0
	.db	$80
V03
	.db	$02,$02,$02,$fe,$fe,$fe
	.db	$fe,$fe,$fe,$02,$02,$02
	.db	$80
V04
V05
V06
V07
V08
;-----------------------------------------------------------------------------
P01	.DB	$00,$00,$00,$40,$40,$40,$80,$80,$80,$80,$80,$80
	.DB	$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80
	.DB	$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40
	.DB	$ff,$0c
P02
	.DB	$40,$40,$40,$40,$40,$40,$80,$80,$80,$80,$80,$80
	.DB	$40,$40,$40,$40,$40,$40,$00,$00,$00,$00,$00,$00
	.DB	$FF,$00
P03
	.DB	$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80
	.DB	$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40
	.DB	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.DB	$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40
	.db	$ff,$00
P04
	.db	$80,$00
	.db	$ff,$00
P05
	.db	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db	$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40
	.db	$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40
	.db	$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80
	.db	$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80
	.db	$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80
	.db	$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80
	.db	$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40
	.db	$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40
	.db	$ff,$00
P06
	.db	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.db	$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40
	.db	$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40
	.db	$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80
	.db	$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80,$80
	.db	$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40
	.db	$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40
	.db	$ff,$00
P07
	.db	$80,$40,$00,$40,$80,$80,$00,$00,$ff,$00
P08
	.db	$00,$40,$ff,$00
;-----------------------------------------------------------------------------
A00	.DB	7,3,0,7,7,3,3,0,0,$FF,$03
A01	.DB	7,4,0,7,7,4,4,0,0,$FF,$03
A02	.DB	8,5,0,8,8,5,5,0,0,$FF,$03
A03	.DB	9,5,0,9,9,5,5,0,0,$FF,$03
A04	.DB	8,3,0,8,8,3,3,0,0,$FF,$03
A05	.DB	9,4,0,9,9,4,4,0,0,$FF,$03
A06	.DB	7,2,0,7,7,2,2,0,0,$FF,$03
A07	.DB	7,5,0,7,7,5,5,0,0,$FF,$03
A08	.DB	10,5,0,10,10,5,5,0,0,$FF,$03
A09	.DB	10,4,0,10,10,4,4,0,0,$FF,$03
A0A	.DB	8,4,0,8,8,4,4,0,0,$FF,$03
A0B	.DB	11,5,0,11,11,5,5,0,0,$FF,$03
A0C	.DB	12,12,12,0,0,0,$FF,$00
A0D             .DB	6,3,0,6,6,3,3,0,0,$FF,$03
A0E             .DB	6,4,0,6,6,4,4,0,0,$FF,$03
A0F             .DB	9,3,0,9,9,3,3,0,0,$FF,$03
A10	.DB	$a0,$98,$90,$00,$fe
A11	.DB	$a8,$a4,$a1,$9e,$00,$fe
A12	.DB	$00,$fe
A13	.DB	$a0,$98,$92,$8c,$8a,$ff,$03
A14	.DB	$a8,$a4,$a1,$9e,$9c,$ff,$03
A15             .DB	10,3,0,10,10,3,3,0,0,$FF,$03
A16             .DB	11,4,0,11,11,4,4,0,0,$ff,$03
A17             .DB	10,2,0,10,10,2,2,0,0,$ff,$03
A18             .DB	$b1,$af,$ac,$a8,$ff,$02
A19	.db	24,12,0,24,12,0,24,24,12,12,0,0
	.db	24,24,24,24,12,12,12,12,0,0,0,0,$ff,$00
A1A             .db	18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1,0,$ff,$0f
A1B             .db	12,12,12,12,12,12,12,12,0,0,0,0,0,0,0,0,$ff,$00
A1C             .db	19,15,16,12,14,10,12,8,10,6,8,4,7,3,6,2,5,1,4,0,$ff,$08
A1D             .db	18,16,12,10,8,6,5,4,3,$ff,$00
A1E             .db	25,18,22,15,19,12,16,9,13,6,10,3,7,0,$ff,$00
A1F             .db	20,25,22,28,17,12,24,15,20,7,17,9
	.db	13,4,13,0,8,4,0,12,2,8,1,9,4,0,3,0,1,4,3,0,1,2,0,1,0,$ff,$09
A20	.db	0,$fe
A21	.db	1,1,1,0,0,0,$ff,$00
A22             .db	2,2,2,0,0,0,$ff,$00
A23             .db	3,3,3,0,0,0,$ff,$00
A24             .db	4,4,4,0,0,0,$ff,$00
A25             .db	5,5,5,0,0,0,$ff,$00
A26             .db	6,6,6,0,0,0,$ff,$00
A27             .db	7,7,7,0,0,0,$ff,$00
A28             .db	8,8,8,0,0,0,$ff,$00
A29             .db	9,9,9,0,0,0,$ff,$00
A2A             .db	10,10,10,0,0,0,$ff,$00
A2B             .db	11,11,11,0,0,0,$ff,$00
A2C             .db	12,12,12,0,0,0,$ff,$00
A2D             .db	12,12,12,12,12,12,12,12,11,11,12,12,10,10,12,12,9,9
	.db	12,12,8,8,12,12,7,7,12,12,6,6,12,12,5,5,12,12,4,4,12,12,3,3
	.db	12,12,2,2,12,12,1,1,12,12,0,$fe
A2E             .db	9,7,3,0,9,9,7,7,3,3,0,0,$ff,$04
A2F             .db	10,7,3,0,10,10,7,7,3,3,0,0,$ff,$04
A30             .db	12,7,3,0,12,12,7,7,3,3,0,0,$ff,$04
A31             .db	8,6,3,0,8,8,6,6,3,3,0,0,$ff,$04
A32             .db	10,6,3,0,10,10,6,6,3,3,0,0,$ff,$04
A33             .db	12,6,3,0,12,12,6,6,3,3,0,0,$ff,$04
A34             .db	8,5,3,0,8,8,5,5,3,3,0,0,$ff,$04
A35             .db     12,8,5,0,12,12,8,8,5,5,0,0,$ff,$04
A36             .db	9,5,2,0,9,9,5,5,2,2,0,0,$ff,$04
A37             .db     9,7,5,0,9,9,7,7,5,5,0,0,$ff,$04
A38             .db	7,4,2,0,7,7,4,4,2,2,0,0,$ff,$04
A39             .db	12,12,0,0,0,0,$ff,$00
A3A             .db	7,1,0,7,7,1,1,0,0,$ff,$00
A3B             .db	8,1,0,8,8,1,1,0,0,$ff,$00
A3C             .db	6,2,0,6,6,2,2,0,0,$ff,$00
A3D             .db	7,2,0,7,7,2,2,0,0,$ff,$00
A3E	.db	24,20,16,12,8,4,0,4,8,12,16,20,$ff,$00
A3F	.db     0,5,7,10,0,0,5,0,5,5,7,5,7,7,10,7,10,10,0,10,$ff,$04
;-----------------------------------------------------------------------------
SOUNDFIX


;GAMEBOY       PULSINIT/PULSRUN(8),ARP/VIBTAB,VIBDEL/PULTAB,AMPTAB


;DRUM+BAS-CH3
	.DB	$00,$43,$40,$00	;C0
;DRUMLOS-CH3
	.DB	$00,$40,$00,$01	;C1
;BASLOS-CH3
	.DB	$00,$43,$40,$00	;C2
;LEAD-VIBAFTER4
	.DB	$40,$01,$41,$02	;C3
;CRASHCHAN4
	.DB	$00,$00,$00,$03	;C4
;HHCCHAN4
	.DB	$00,$00,$00,$04	;C5
;HHCCHAN4OPEN
	.DB	$00,$00,$00,$06	;C6
;SNARECHAN4
	.DB	$00,$40,$00,$05	;C7
;LEAD-VIBAFTER4-1
	.DB	$40,$01,$41,$09	;C8
;LEADARP1
	.DB	$40,$40,$01,$08	;C9
;LEADARP+$20
	.DB	$40,$c0,$01,$08	;CA
;GUITAR
	.DB	$00,$01,$43,$02	;CB
;GUITARPULLOOP
	.DB	$08,$01,$43,$02	;CC
;ARPEGGIO2
	.DB	$80,$40,$02,$07	;CD
;LEADARP1-1
	.DB	$40,$40,$01,$0c	;CE
;TECHNOSTART1
	.DB	$00,$00,$05,$0a	;CF
;TECHNOLOOP1
	.DB	$08,$00,$05,$0a	;D0
;TECHNOLOOPLONG
	.DB	$08,$00,$05,$0b	;D1
;TECHNOSTARTLONG1
	.DB	$00,$00,$05,$0a	;D2
;TECHKEEP1
	.DB	$00,$03,$85,$0d	;D3
;TECHKEEP1LOOP
	.DB	$08,$03,$85,$0d	;D4
;BEEP
	.DB	$80,$00,$00,$0e	;D5
;BEEP-1
	.DB	$80,$00,$00,$0f	;D6
;BEEP-2
	.DB	$80,$00,$00,$10	;D7
;BEEP-3
	.DB	$80,$00,$00,$11	;D8
;LEADARP+$20-1
	.DB	$40,$c0,$01,$0c	;D9
;TOMTOM1
	.DB	$80,$40,$00,$12	;DA
;LEADARPMEAN+$20
	.DB	$80,$c0,$06,$13	;DB
;LEADARPMEANLOOP+$20short
	.DB	$88,$c0,$06,$13	;DC
;LEADARPMEANLOOP+$20long
	.DB	$88,$c0,$06,$14	;DD
;LEADARPMEAN2+$20
	.DB	$80,$c0,$06,$15	;DE
;LEADARPMEAN2LOOP+$20short
	.DB	$88,$c0,$06,$15	;DF
;HARDATTACKFASTFADEARP
	.DB	$80,$40,$07,$16	;E0
;HARDATTACKVERYFASTFADEARP
	.DB	$80,$40,$00,$17	;E1
;HARDATTACKVERYFASTFADEARP
	.DB	$80,$40,$07,$18	;E2
;PULSLOOPFX00-80
	.DB	$80,$40,$08,$19	;E3
;EXPLOSION
	.DB	$80,$40,$07,$1a	;E4
;EXPLOSIONBIG
	.DB	$80,$40,$07,$1b	;E5
;PICKUP
	.DB	$80,$c0,$00,$1c	;E6
;PICKUP2
	.DB	$80,$c0,$03,$1c	;E7
;PICKUP2
	.DB	$40,$c0,$01,$1c	;E8


LEVEL5A
	.db	$81,$5c,$5c,$8d,$5c,$5c
	.db	$8d,$5f,$5f
	.db	$81,$5c,$5c,$8d,$5c,$5c
	.db	$91,$5f,$5f
	.db	$85,$5c,$5c
	.db	$85,$5c,$5c
	.db	$ff,$00
LEVEL5C
	.db	$8d,$5d,$5d,$5d,$5d
	.db	$8d,$5d,$5d,$5d,$5d
	.db	$8d,$5d,$5d,$90,$5d,$5d
	.db	$89,$5d,$5d,$86,$5d,$88,$5d
	.db	$8d,$5d,$5d,$90,$5d,$5d
	.db	$89,$5d,$5d,$86,$5d,$88,$5d
	.db	$8d,$5d,$5d,$5d,$5d
	.db	$8d,$5d,$5d,$5d,$5d
	.db	$91,$5d,$5d,$94,$5d,$5d
	.db	$8d,$5d,$5d,$8a,$5d,$8c,$5d
	.db	$91,$5d,$5d,$94,$5d,$5d
	.db	$8d,$5d,$5d,$8a,$5d,$8c,$5d
	.db	$85,$5d,$5d,$5d,$5d
	.db	$85,$5d,$5d,$5d,$5d
	.db	$ff,$00
LEVEL5D
	.db	$5e
	.db	$ff,$00

S5C
	.db	$cb,$b8,$00
	.db     $cc,$82,$0c,$00,$18,$0c
	.db	$ff
S5D
	.db	$c0,$84,$70,$00
	.db	$c2,$81,$79,$18,$e1
	.db	$c0,$82,$70,$0c
	.db	$c0,$83,$71,$00,$e1
	.db	$c0,$83,$70,$0c,$e1
	.db	$c0,$82,$70,$00
	.db	$c0,$82,$70,$0c
	.db	$c2,$81,$79,$18,$e3
	.db	$c0,$83,$71,$00,$e1
	.db	$c0,$82,$70,$00
	.db	$c0,$82,$70,$0c
	.db	$ff
S5E
	.db     $c5,$84,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db     $c5,$84,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db     $c5,$84,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db     $c5,$84,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db	$ff
S5F
	.db	$cb,$8c,$13
	.db     $cc,$88,$0c
	.db	$84,$0e,$0f,$11,$81,$12,$87,$13
	.db	$88,$0c
	.db	$84,$0e
	.db	$84,$0f
	.db	$84,$11
	.db	$84,$13
	.db	$81,$11,$87,$13
	.db	$84,$0a
	.db	$88,$0f
	.db	$84,$11
	.db	$84,$13
	.db	$82,$14,$81,$13,$14
	.db	$98,$16

	.db	$81,$07,$0a,$0f,$13,$0a,$0f,$13,$16
	.db	$8c,$18
	.db     $88,$0f
	.db	$84,$14,$16,$18
	.db	$8c,$1a
	.db	$88,$11
	.db	$84,$16
	.db	$18,$1a
	.db	$84,$1b,$1d,$1f
	.db	$88,$20
	.db	$82,$1f,$81,$20,$1f
	.db	$84,$1d
	.db	$84,$1b
	.db	$81,$1e,$8b,$1f
	.db	$82,$1d,$1b
	.db	$88,$1a
	.db	$81,$26,$1f,$1a,$13,$0e,$07,$13,$1f
	.db	$ff



FXSHOOT1
	.db	$84,$72,$52,$00
	.db	$fe
S52
	.db	$df,$86,$7d,$04
	.db	$ff
FXSHOOT2
	.db	$88,$71,$52,$00
	.db	$fe
FXSHOOT3
	.db	$8c,$74,$53,$00
	.db	$fe
S53
	.db	$df,$96,$7c,$04
	.db	$ff
FXSHOOT4
	.db	$8a,$71,$54,$00
	.db	$fe
S54
	.db	$df,$87,$7c,$04
	.db	$ff
FXSHOOT5
	.db	$8c,$72,$55,$00
	.db	$fe
S55
	.db	$df,$8a,$7e,$00
	.db	$ff
FXSHOOT6
	.db	$8f,$73,$55,$00
	.db	$fe
S56
	.db	$df,$88,$7e,$00
	.db	$ff
FXSHOOT7
	.db	$85,$72,$55,$00
	.db	$fe
FXSHOOT8
	.db	$87,$71,$55,$00
	.db	$fe
EXPLOSION
	.db	$80,$75,$57,$00
	.db	$fe
S57
	.db	$df,$a0,$7f,$00
	.db	$ff
EXPLOSIONMID
	.db	$83,$76,$57,$00
	.db	$fe
EXPLOSIONBIG
	.db	$89,$76,$58
	.db	$fe
S58
	.db	$df,$a0,$7f,$00
	.db	$ff
PICKUP1
	.db	$97,$77,$59,$00
	.db	$fe
S59
	.db	$df,$9c,$7e,$00
	.db	$ff
PICKUP2
	.db	$9b,$77,$59,$00
	.db	$fe
PICKUP3
	.db	$a1,$78,$59,$00
	.db	$fe
PICKUP4
	.db	$a7,$77,$5a,$00
	.db	$fe
S5A
	.db	$df,$9c,$7f,$00
	.db	$ff
PICKUP5
	.db	$ad,$78,$5a,$00
	.db	$fe
PICKUP6
	.db	$b2,$79,$5a,$00
	.db	$fe
GAMEOVERA
	.db	$8f,$4f
	.db	$fe
GAMEOVERB
	.db	$87,$4f
	.db	$fe
GAMEOVERC
	.db	$83,$50
	.db	$fe
GAMEOVERD
	.db	$51
	.db	$fe

S4F
	.db	$c9,$84,$6a,$1c,$ce
	.db	$c9,$84,$6a,$1b,$ce
	.db	$c9,$84,$6a,$1a,$ce
	.db	$c9,$84,$6a,$19,$ce
	.db	$c9,$98,$6a,$18,$ce,$84
	.db	$c9,$84,$6a,$20,$ce,$e1
	.db	$ff
S50
	.db	$c0,$88,$70,$0c
	.db	$c0,$88,$70,$0b
	.db	$c0,$88,$70,$0a
	.db	$c0,$88,$70,$09
	.db	$c0,$9c,$70,$08
	.db	$c0,$86,$70,$10,$e1
	.db	$ff
S51
	.db     $c4,$88,$31
	.db	$c6,$88,$31
	.db     $c4,$88,$31
	.db	$c6,$88,$31
	.db     $c4,$9c,$31
	.db     $c4,$88,$31,$e1
	.db	$ff
LEVEL4A
	.db	$92,$4c,$4c,$95,$4c,$4c,$98,$4c,$4c,$9a,$4c,$4c

	.db	$86,$5b

	.db	$9e,$4c,$4c
	.db	$ff,$00
LEVEL4C
	.db	$86,$4d,$89,$4d,$8c,$4d,$8f,$4d
	.db	$86,$4d,$89,$4d,$8c,$4d,$8f,$4d
	.db	$86,$4d
	.db	$ff,$00
LEVEL4D
	.db	$4e
	.db	$ff,$00

S5B
	.db	$cb,$81,$12,$8b,$13
	.db	$cc
	.db	$8c,$18
	.db	$81,$19,$9b,$1a
	.db	$84,$1b,$82,$1a,$81,$1b,$1a,$84,$18
	.db	$8c,$13
	.db	$86,$18
	.db	$86,$1b
	.db	$81,$1e,$9b,$1f
	.db	$84,$18
	.db	$84,$1f
	.db	$84,$22
	.db	$8c,$21
	.db	$84,$22
	.db	$81,$23,$85,$24
	.db	$81,$22,$21
	.db	$8c,$1f
	.db	$84,$1b
	.db	$84,$16
	.db	$84,$15
	.db	$84,$13
	.db	$84,$11
	.db	$84,$16
	.db	$82,$15,$81,$16,$15
	.db	$86,$13
	.db	$86,$16
	.db	$86,$1a
	.db	$86,$1b
	.db	$84,$1f
	.db	$84,$22
	.db	$82,$26
	.db	$82,$27
	.db	$94,$2b,$81,$29,$27,$22,$1f,$1d,$1b,$16,$13

	.db	$86,$2a
	.db	$86,$27
	.db	$86,$24
	.db	$86,$21
	.db	$84,$24
	.db	$84,$27
	.db	$81,$29,$85,$2a
	.db	$86,$27
	.db	$8c,$24,$81,$36,$30,$2a,$24,$1e,$18,$12,$0c

	.db	$81,$29,$85,$2a
	.db	$86,$27
	.db	$86,$24
	.db	$86,$21
	.db	$84,$24
	.db	$84,$27
	.db	$81,$29,$85,$2a
	.db	$86,$2d
	.db	$81,$2f,$87,$30
	.db	$84,$30,$82,$32,$30,$32,$33

	.db	$81,$33,$85,$34
	.db	$86,$30
	.db	$94,$2d
	.db	$82,$2b,$2d,$2b,$28,$2b,$28,$26,$28,$26,$24,$26,$24
	.db	$21,$24,$21,$1f,$21,$1f,$1c,$1f,$1c,$1a,$1c,$1a,$18
	.db	$1a,$18,$15,$18,$15,$13,$14
	.db	$86,$15,$10,$09,$10,$88,$15
	.db	$ff
S4C
	.db	$de,$82,$7a,$0c
	.db	$df
	.db	$81,$7a,$0c,$e1
	.db	$82,$7b,$0c
	.db	$81,$7a,$0c,$e1
	.db	$81,$7a,$0c,$e1
	.db	$82,$7b,$0c
	.db	$81,$7a,$0c,$e1
	.db	$81,$7a,$0c,$e1
	.db	$82,$7b,$0c
	.db	$81,$7a,$0c,$e1
	.db	$81,$7a,$0c,$e1
	.db	$82,$7b,$0c
	.db	$81,$7a,$0c,$e1
	.db	$81,$7a,$0c,$e1
	.db	$82,$7b,$0c
	.db	$81,$7a,$0c,$e1

	.db	$82,$7c,$0c
	.db	$81,$7c,$0c,$e1
	.db	$82,$7d,$0c
	.db	$81,$7c,$0c,$e1
	.db	$81,$7c,$0c,$e1
	.db	$82,$7d,$0c
	.db	$81,$7c,$0c,$e1
	.db	$81,$7c,$0c,$e1
	.db	$82,$7d,$0c
	.db	$81,$7c,$0c,$e1
	.db	$81,$7c,$0c,$e1
	.db	$82,$7d,$0c
	.db	$81,$7c,$0c,$e1
	.db	$81,$7c,$0c,$e1
	.db	$82,$7d,$0c
	.db	$81,$7c,$0c,$e1
	.db	$ff
S4D
	.db	$c0,$84,$70,$00
	.db	$c2,$81,$79,$18,$e1
	.db	$c0,$82,$70,$0c
	.db	$c0,$83,$71,$00,$e1
	.db	$c0,$83,$70,$0c,$e1
	.db	$c0,$82,$70,$00
	.db	$c0,$82,$70,$0c
	.db	$c2,$81,$79,$18,$e3
	.db	$c0,$83,$71,$00,$e1
	.db	$c0,$82,$70,$00
	.db	$c0,$86,$70,$0c

	.db	$c2,$81,$79,$18,$e1
	.db	$c0,$82,$70,$00
	.db	$c0,$85,$71,$00,$e1
	.db	$c0,$83,$70,$00,$e1
	.db	$c0,$82,$70,$0c
	.db	$c0,$83,$70,$00,$e1
	.db	$c0,$84,$71,$00
	.db	$c2,$82,$72,$0c
	.db	$c2,$82,$72,$00

	.db	$c0,$84,$70,$00
	.db	$c2,$81,$79,$18,$e1
	.db	$c0,$82,$70,$0c
	.db	$c0,$83,$71,$00,$e1
	.db	$c0,$84,$70,$0c
	.db	$c0,$82,$70,$00
	.db	$c0,$82,$70,$0c
	.db	$c2,$81,$79,$18,$e3
	.db	$c0,$83,$71,$00,$e1
	.db	$c0,$82,$70,$00
	.db	$c0,$86,$70,$0c

	.db	$c2,$81,$79,$18,$e1
	.db	$c0,$82,$70,$00
	.db	$c0,$85,$71,$00,$e1
	.db	$c0,$84,$70,$00
	.db	$c0,$82,$70,$0c
	.db	$c0,$82,$70,$00
	.db	$c0,$82,$71,$00
	.db	$c0,$82,$71,$0c
	.db	$c0,$82,$71,$00
	.db	$c0,$82,$71,$0c
	.db	$c0,$82,$71,$00
	.db	$ff
S4E
	.db     $c6,$84,$31
	.db     $c5,$82,$31,$31
	.db     $c7,$84,$78,$5f
	.db     $c5,$82,$31,$31
	.db     $c6,$84,$31
	.db     $c5,$82,$31,$31
	.db     $c7,$84,$78,$5f
	.db     $c5,$82,$31,$31
	.db     $c6,$84,$31
	.db     $c5,$82,$31,$31
	.db     $c7,$84,$78,$5f
	.db     $c5,$82,$31,$31
	.db     $c6,$84,$31
	.db     $c5,$82,$31,$31
	.db     $c7,$84,$78,$5f
	.db     $c5,$82,$31,$31
	.db     $c6,$84,$31
	.db     $c5,$82,$31,$31
	.db     $c7,$84,$78,$5f
	.db     $c5,$82,$31,$31
	.db     $c6,$84,$31
	.db     $c5,$82,$31,$31
	.db     $c7,$84,$78,$5f
	.db     $c5,$82,$31,$31
	.db     $c6,$84,$31
	.db     $c5,$82,$31,$31
	.db     $c7,$84,$78,$5f
	.db     $c5,$82,$31,$31
	.db     $c6,$84,$31
	.db     $c5,$82,$31
	.db     $c7,$82,$78,$5f,$5f,$5f,$5f,$5f
	.db	$ff
LEVEL3A
	.db	$8c,$32,$80,$32
	.db	$8c,$32,$80,$32
	.db	$85,$38,$3a,$3c,$3a,$3d
	.db	$85,$38,$3a,$3c,$3a,$3d

	.db	$85,$32,$32

	.db	$8c,$03,$06,$8f,$06,$06
	.db	$91,$03,$06,$06,$06

	.db	$8c,$4b,$8f,$4b
	.db	$91,$4b,$4b
	.db	$ff,$00
LEVEL3C
	.db	$80,$33,$33
	.db	$80,$35,$35,$37
	.db	$80,$35,$35,$37
	.db	$85,$39,$3b,$3e,$3b,$3f
	.db	$85,$39,$3b,$3e,$3b,$3f

	.db	$85,$35,$35,$37
	.db	$85,$35,$35,$37

	.db	$85,$35,$80,$35
	.db	$8a,$35,$85,$35
	.db	$85,$35,$80,$35
	.db	$8a,$35,$85,$35
	.db	$ff,$00
LEVEL3D
	.db	$34,$36,$36,$36,$36
	.db	$36,$36,$36,$36
	.db	$36,$36,$36,$36
	.db	$36,$36,$36,$36,$36,$36
	.db	$36,$36,$36,$36,$36,$36

	.db	$36,$36,$36,$36
	.db	$36,$36,$36,$36

	.db	$36,$36,$36,$36
	.db	$36,$36,$36,$36
	.db	$ff,$00
S32
	.db	$de,$82,$6c,$24
	.db	$df,$82
	.db	$18,$1f,$18,$24,$18,$1f,$18
	.db	$20,$18,$1d,$18,$20,$18,$1d,$18
	.db	$24,$18,$1f,$18,$24,$18,$1f,$18
	.db	$20,$18,$1d,$18,$20,$18,$23,$18

	.db	$24,$18,$1f,$18,$24,$18,$1f,$18
	.db	$20,$18,$1d,$18,$20,$18,$1d,$18
	.db	$24,$18,$1f,$18,$24,$18,$1f,$18
	.db	$20,$18,$1d,$18,$23,$18,$20,$18

	.db	$1f,$14,$1b,$14,$1f,$14,$1b,$14
	.db	$1d,$13,$1a,$13,$1d,$13,$1a,$13
	.db	$1b,$11,$18,$11,$1b,$11,$18,$11
	.db	$1a,$13,$17,$13,$1a,$13,$17,$13

	.db	$18,$11,$14,$11,$18,$11,$14,$11
	.db	$17,$0e,$13,$0e,$17,$0e,$13,$0e
	.db	$14,$0c,$11,$0c,$14,$0c,$11,$0c
	.db	$13,$0b,$0e,$0b,$13,$0b,$17,$0e
	.db	$ff
S33
	.db	$c2,$9e,$7b,$0c,$82,$00,$9c,$82,$0c,$00
	.db	$9c,$0c,$82,$00,$00,$a0,$00
	.db	$c2,$90,$7b,$14,$13,$11,$13,$11,$0e,$0c,$0b
	.db	$ff
S34
	.db	$c4,$90,$31
	.db	$c5,$90,$31,$31,$31
	.db	$c4,$90,$31
	.db	$c5,$90,$31,$31,$31
	.db	$c4,$90,$31
	.db	$c5,$90,$31
	.db	$c4,$90,$31
	.db	$c5,$90,$31
	.db	$c4,$90,$31
	.db	$c5,$90,$31
	.db	$c4,$90,$31
	.db	$c5,$90,$31
	.db	$ff
S35
	.db	$c0,$84,$70,$0c
	.db	$c0,$84,$70,$0c
	.db	$c1,$86,$74,0
	.db	$c0,$84,$70,$0c
	.db	$c0,$82,$70,$0c
	.db	$c0,$84,$70,$0c
	.db	$c1,$84,$74,0
	.db	$c2,$82,$72,$0a
	.db	$c0,$82,$70,$0c
	.db	$c0,$84,$70,$0c
	.db	$c0,$84,$70,$0c
	.db	$c1,$86,$74,0
	.db	$c0,$84,$70,$0c
	.db	$c0,$82,$70,$0c
	.db	$c0,$84,$70,$0c
	.db	$c1,$84,$74,0
	.db	$c2,$84,$70,$0a
	.db	$ff
S37
	.db	$c0,$84,$70,$14
	.db	$c0,$84,$70,$14
	.db	$c1,$86,$74,0
	.db	$c0,$84,$70,$13
	.db	$c0,$82,$70,$07
	.db	$c0,$84,$70,$13
	.db	$c1,$84,$74,0
	.db	$c2,$82,$72,$0f
	.db	$c0,$82,$70,$10
	.db	$c0,$84,$70,$11
	.db	$c0,$84,$70,$11
	.db	$c1,$86,$74,0
	.db	$c0,$84,$70,$13
	.db	$c0,$82,$70,$07
	.db	$c0,$84,$70,$13
	.db	$c1,$84,$74,0
	.db	$c0,$82,$70,$0f
	.db	$c2,$82,$72,$10
	.db	$c0,$84,$70,$11
	.db	$c0,$84,$70,$11
	.db	$c1,$86,$74,0
	.db	$c0,$84,$70,$13
	.db	$c0,$82,$70,$07
	.db	$c0,$84,$70,$13
	.db	$c1,$84,$74,0
	.db	$c2,$82,$72,$0f
	.db	$c0,$82,$70,$10
	.db	$c0,$84,$70,$11
	.db	$c0,$84,$70,$11
	.db	$c1,$86,$74,0
	.db	$c0,$84,$70,$13
	.db	$c0,$82,$70,$07
	.db	$c0,$84,$70,$13
	.db	$c1,$84,$74,0
	.db	$c0,$84,$70,$0a
	.db	$ff
S36
	.db     $c5,$84,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db     $c5,$84,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db     $c5,$84,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db     $c5,$84,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db	$ff
S38
	.db	$c9,$84,$60,$18,$ce,$82
	.db	$c9,$84,$62,$13,$ce,$82
	.db	$c9,$83,$67,$13,$ce,$81
	.db	$c9,$84,$64,$11,$ce,$82
	.db	$c9,$84,$63,$14,$ce,$82
	.db	$c9,$83,$61,$19,$ce,$81

	.db	$c9,$83,$63,$1b,$ce,$81
	.db	$c9,$82,$68,$1b
	.db	$c9,$82,$63,$1b,$ce,$82
	.db	$c9,$82,$64,$18,$ce,$82
	.db	$c9,$88,$61,$14,$ce,$82
	.db	$c9,$82,$61,$14,$ce,$82
	.db	$c9,$82,$61,$16,$ce,$82

	.db	$c9,$84,$60,$18,$ce,$82
	.db	$c9,$84,$62,$13,$ce,$82
	.db	$c9,$83,$67,$13,$ce,$81
	.db	$c9,$84,$64,$11,$ce,$82
	.db	$c9,$84,$63,$14,$ce,$82
	.db	$c9,$83,$61,$19,$ce,$81

	.db	$c9,$83,$60,$1d,$ce,$81
	.db	$c9,$82,$64,$1d
	.db	$c9,$82,$60,$1d,$ce,$82
	.db	$c9,$82,$62,$18,$ce,$82
	.db	$c9,$88,$65,$20,$ce,$82

	.db	$da,$82,$7a,$06,$84,$03,$82,0
	.db	$ff
S39
	.db	$c0,$84,$70,$0c
	.db	$c0,$84,$70,$0c
	.db	$c1,$86,$74,0
	.db	$c0,$84,$70,$0d
	.db	$c0,$82,$70,$01
	.db	$c0,$84,$70,$0d
	.db	$c1,$84,$74,0
	.db	$c0,$82,$70,$0f
	.db	$c2,$82,$72,$08
	.db	$c0,$84,$70,$14
	.db	$c0,$84,$70,$14
	.db	$c1,$86,$74,0
	.db	$c0,$84,$70,$08
	.db	$c0,$82,$70,$14
	.db	$c0,$84,$70,$08
	.db	$c1,$84,$74,0
	.db	$c0,$82,$70,$0a
	.db	$c2,$82,$72,$0b
	.db	$c0,$84,$70,$0c
	.db	$c0,$84,$70,$0c
	.db	$c1,$86,$74,0
	.db	$c0,$84,$70,$0d
	.db	$c0,$82,$70,$01
	.db	$c0,$84,$70,$0d
	.db	$c1,$84,$74,0
	.db	$c2,$82,$72,$0d
	.db	$c2,$82,$72,$0f
	.db	$c0,$84,$70,$11
	.db	$c0,$84,$70,$11
	.db	$c1,$86,$74,0
	.db	$c0,$84,$70,$05
	.db	$c0,$82,$70,$11
	.db	$c0,$84,$70,$05
	.db	$c1,$84,$74,0
	.db	$c2,$82,$72,$11
	.db	$c2,$82,$72,$05
	.db	$ff
S3A
	.db	$c9,$83,$60,$16,$ce,$81
	.db	$c9,$81,$60,$16,$ce,$81
	.db	$c9,$82,$60,$16,$ce,$82
	.db	$c9,$82,$60,$16,$ce,$82
	.db	$c9,$85,$68,$13,$ce,$81
	.db	$c9,$82,$63,$13,$ce,$82
	.db	$c9,$83,$68,$13,$ce,$81
	.db	$c9,$82,$61,$18,$ce,$82

	.db	$c9,$83,$64,$18,$ce,$81
	.db	$c9,$81,$64,$18,$ce,$81
	.db	$c9,$82,$64,$18,$ce,$82
	.db	$c9,$82,$64,$18,$ce,$82
	.db	$c9,$85,$63,$19,$ce,$81
	.db	$c9,$82,$6b,$19,$ce,$82
	.db	$c9,$83,$61,$1e,$ce,$81
	.db	$c9,$82,$65,$1e,$ce,$82

	.db	$c9,$83,$62,$1d,$ce,$81
	.db	$c9,$81,$62,$1d,$ce,$81
	.db	$c9,$85,$67,$1d,$ce,$81
	.db	$c9,$82,$65,$19,$ce,$82
	.db	$ff
S3C
	.db	$c9,$83,$60,$1d,$ce,$81
	.db	$c9,$81,$60,$1d,$ce,$81
	.db	$c9,$85,$64,$1d,$ce,$81
	.db	$c9,$82,$60,$1d,$ce,$82

	.db	$c9,$83,$63,$1b,$ce,$81
	.db	$c9,$81,$63,$19,$ce,$81
	.db	$c9,$88,$63,$19,$ce,$82

	.db	$da,$82,$7a,$00,$84,$03,$06,$82,$03,$84,$00
	.db	$ff
S3D
	.db	$c9,$83,$63,$18,$ce,$81
	.db	$c9,$81,$63,$18,$ce,$81
	.db	$c9,$85,$61,$1d,$ce,$81
	.db	$c9,$82,$64,$21,$ce,$82

	.db	$c9,$83,$68,$1d,$ce,$81
	.db	$c9,$81,$63,$1d,$ce,$81
	.db	$c9,$88,$63,$1d,$ce,$82

	.db	$da,$82,$7a,$07,$84,$05,$82,$03,$02,$01,$84,$00
	.db	$ff
S3B
	.db	$c0,$84,$70,$0a
	.db	$c0,$84,$70,$0a
	.db	$c1,$86,$74,0
	.db	$c0,$84,$70,$0c
	.db	$c0,$82,$70,$00
	.db	$c0,$84,$70,$0c
	.db	$c1,$84,$74,0
	.db	$c0,$82,$70,$0c
	.db	$c2,$82,$72,$0a
	.db	$c0,$84,$70,$08
	.db	$c0,$84,$70,$14
	.db	$c1,$86,$74,0
	.db	$c0,$84,$70,$06
	.db	$c0,$82,$70,$12
	.db	$c0,$84,$70,$06
	.db	$c1,$84,$74,0
	.db	$c0,$82,$70,$08
	.db	$c2,$82,$72,$09
	.db	$c0,$84,$70,$0a
	.db	$c0,$84,$70,$0a
	.db	$c1,$86,$74,0
	.db	$ff
S3E
	.db	$c0,$84,$70,$08
	.db	$c0,$82,$70,$14
	.db	$c0,$84,$70,$08
	.db	$c1,$84,$74,0
	.db	$c0,$82,$70,$03
	.db	$c2,$82,$72,$05
	.db	$c0,$84,$70,$06
	.db	$c0,$84,$70,$06
	.db	$c1,$86,$74,0
	.db	$c0,$84,$70,$06
	.db	$c0,$82,$70,$12
	.db	$c0,$84,$70,$06
	.db	$c1,$84,$74,0
	.db	$c0,$82,$70,$06
	.db	$c2,$82,$72,$08
	.db	$ff
S3F
	.db	$c0,$84,$70,$05
	.db	$c0,$82,$70,$11
	.db	$c0,$84,$70,$05
	.db	$c1,$84,$74,0
	.db	$c0,$82,$70,$11
	.db	$c2,$82,$72,$05
	.db	$c0,$84,$70,$0a
	.db	$c0,$84,$70,$0a
	.db	$c1,$86,$74,0
	.db	$c0,$84,$70,$0a
	.db	$c0,$82,$70,$16
	.db	$c0,$84,$70,$0a
	.db	$c1,$84,$74,0
	.db	$c0,$82,$70,$16
	.db	$c2,$82,$72,$0a
	.db	$ff
S4B
	.db	$de,$82,$79,$0c
	.db	$df,$82,$18
	.db	$df,$84,$0c
	.db	$df,$82,$18,$0c
	.db	$df,$84,$18
	.db	$df,$82,$0c,$18
	.db	$df,$84,$0c
	.db	$df,$82,$18,$0c
	.db	$df,$84,$18

	.db	$df,$82,$0c,$18
	.db	$df,$84,$0c
	.db	$df,$82,$18,$0c
	.db	$df,$84,$18
	.db	$df,$82,$0c,$18
	.db	$df,$84,$0c
	.db	$df,$82,$18,$0c
	.db	$df,$84,$18
	.db	$ff

COMPLETEDA
	.db	$85,$40
	.db	$fe
COMPLETEDB
	.db	$85,$41
	.db	$fe
COMPLETEDC
	.db	$85,$42
	.db	$fe
COMPLETEDD
	.db	$43
	.db	$fe
S40
	.db	$c3,$84,$0c,$c8
	.db	$c3,$84,$13,$c8
	.db	$c3,$84,$1d,$c8
	.db	$c3,$84,$24,$c8,$82
	.db	$c9,$82,$60,$24
	.db	$c9,$92,$61,$24,$ce,$84,$24,$ea
	.db	$ff
S41
	.db	$e4
	.db	$c3,$84,$11,$c8
	.db	$c3,$84,$18,$c8
	.db	$c3,$84,$1f,$c8
	.db	$e2
	.db	$c3,$82,$27
	.db	$c3,$93,$28,$c8,$84,$28,$e4,$e5
	.db	$ff
S42
	.db	$c0,$84,$70,$00
	.db	$c2,$72,$05
	.db	$c0,$70,$07
	.db	$c2,$72,$0c
	.db	$c0,$70,$11
	.db	$c2,$72,$13
	.db	$c0,$86,$70,$18
	.db	$c0,$82,$70,$18
	.db	$c0,$98,$70,$0c,$e8
	.db	$ff
S43
	.db     $c5,$84,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db     $c5,$84,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$82,$31
	.db	$c4,$82,$31
	.db     $c4,$94,$31,$ec
	.db	$ff
VICTORYA
	.db	$85,$44,$44
	.db	$85,$48
	.db	$ff,$00
VICTORYB
	.db	$85,$45,$45
	.db	$85,$49
	.db	$ff,$00
VICTORYC
	.db	$85,$46,$46
	.db	$85,$4a
	.db	$ff,$00
VICTORYD
	.db	$47,$47,$47,$47
	.db	$47,$47,$47,$47
	.db	$47,$47,$47,$47
	.db	$47,$47,$47,$47,$47
	.db	$ff,$00
S44
	.db	$c3,$85,$1f,$c8,$81
	.db	$c3,$85,$18,$c8,$81
	.db	$c3,$82,$24,$c8,$82
	.db	$c3,$82,$24
	.db	$c3,$82,$21
	.db	$c3,$82,$24
	.db	$c3,$82,$21
	.db	$c3,$92,$1f,$c8,$82
	.db	$c3,$82,$1f
	.db	$c3,$82,$21
	.db	$c3,$85,$22,$c8,$81
	.db	$c3,$85,$1b,$c8,$81
	.db	$c3,$82,$21,$c8,$82
	.db	$c3,$82,$21
	.db	$c3,$82,$22
	.db	$c3,$82,$21
	.db	$c3,$82,$1d
	.db	$c3,$86,$1f,$c8,$82
	.db	$c3,$81,$1f,$c8,$81
	.db	$c3,$81,$1f,$c8,$81
	.db	$c3,$8a,$1f,$c8,$82
	.db     $ff
S45
	.db	$cd,$8a,$64,$1c,$ce,$82
	.db	$cd,$8a,$61,$1d,$ce,$82
	.db	$cd,$96,$64,$1c,$ce,$82
	.db	$cd,$8a,$64,$1f,$ce,$82
	.db	$cd,$8a,$64,$21,$ce,$82
	.db	$cd,$86,$66,$24,$ce,$82
	.db	$cd,$82,$66,$24
	.db	$cd,$82,$66,$24
	.db	$cd,$8a,$64,$23,$ce,$82
	.db	$ff
S46
	.db	$c0,$86,$70,$0c
	.db	$c0,$86,$71,$00
	.db	$c0,$86,$70,$05
	.db	$c0,$86,$71,$11
	.db	$c0,$86,$70,$0c
	.db	$c0,$86,$71,$00
	.db	$c0,$86,$70,$0c
	.db	$c0,$86,$71,$00
	.db	$c0,$86,$70,$0f
	.db	$c0,$86,$71,$03
	.db	$c0,$86,$70,$11
	.db	$c0,$86,$71,$05
	.db	$c0,$86,$70,$13
	.db	$c0,$84,$71,$07
	.db	$c0,$82,$70,$13
	.db	$c0,$86,$70,$13
	.db	$c0,$86,$71,$07
	.db	$ff
S47
	.db     $c5,$84,$31
	.db     $c5,$82,$31
	.db     $c7,$84,$78,$5f
	.db     $c5,$82,$31
	.db     $c5,$84,$31
	.db     $c5,$82,$31
	.db     $c7,$84,$78,$5f
	.db     $c5,$82,$31
	.db	$ff
S48
	.db	$c3
	.db	$82,$20,$1b,$14
	.db	$82,$22,$1b,$14
	.db	$82,$24,$1b,$14
	.db	$82,$26,$1b,$14

	.db	$82,$27,$1f,$18
	.db	$82,$26,$1f,$18
	.db	$82,$27,$1f,$18
	.db	$82,$29,$1f,$18

	.db	$82,$26,$1d,$16
	.db	$82,$24,$1d,$16
	.db	$82,$26,$1d,$16
	.db	$82,$27,$1d,$16

	.db	$88,$24,$82,$20,$1b
	.db	$8b,$24,$c8,$81

	.db	$c3
	.db	$82,$20,$18,$11
	.db	$82,$1f,$18,$11
	.db	$82,$20,$18,$11
	.db	$82,$22,$18,$11

	.db	$82,$24,$1b,$14
	.db	$82,$22,$1b,$14
	.db	$82,$24,$1b,$14
	.db	$82,$26,$1b,$14

	.db	$82,$27,$1f,$18
	.db	$82,$26,$1f,$18
	.db	$82,$27,$1f,$18
	.db	$82,$29,$1f,$18

	.db	$88,$2b,$82,$29,$2b
	.db	$83,$2d,$c8,$81
	.db	$c3,$83,$2f,$c8,$81
	.db	$c3,$83,$30,$c8,$81
	.db	$c3,$81,$2f,$86,$30,$c8,$81,$30
	.db	$c3,$81,$2f,$30
	.db	$c3,$82,$2d
	.db	$c3,$8a,$2f,$c8,$82,$2f
	.db	$ff
S49
	.db	$cd,$84,$64,$18,$ce,$82
	.db	$cd,$84,$64,$18,$ce,$82
	.db	$cd,$84,$64,$18,$ce,$82
	.db	$cd,$84,$64,$18,$ce,$82
	.db	$cd,$84,$65,$1b,$ce,$82
	.db	$cd,$84,$65,$1b,$ce,$82
	.db	$cd,$84,$65,$1b,$ce,$82
	.db	$cd,$84,$65,$1b,$ce,$82
	.db	$cd,$84,$64,$1a,$ce,$82
	.db	$cd,$84,$64,$1a,$ce,$82
	.db	$cd,$84,$64,$1a,$ce,$82
	.db	$cd,$84,$64,$1a,$ce,$82
	.db	$cd,$84,$64,$18,$ce,$82
	.db	$cd,$84,$64,$18,$ce,$82
	.db	$cd,$84,$64,$18,$ce,$82
	.db	$cd,$84,$64,$18,$ce,$82

	.db	$cd,$84,$62,$18,$ce,$82
	.db	$cd,$84,$62,$18,$ce,$82
	.db	$cd,$84,$62,$18,$ce,$82
	.db	$cd,$84,$62,$18,$ce,$82
	.db	$cd,$84,$63,$1b,$ce,$82
	.db	$cd,$84,$63,$1b,$ce,$82
	.db	$cd,$84,$63,$1b,$ce,$82
	.db	$cd,$84,$63,$1b,$ce,$82
	.db	$cd,$84,$62,$1f,$ce,$82
	.db	$cd,$84,$62,$1f,$ce,$82
	.db	$cd,$84,$62,$1f,$ce,$82
	.db	$cd,$84,$62,$1f,$ce,$82

	.db	$cd,$84,$63,$22,$ce,$82
	.db	$cd,$84,$63,$22,$ce,$82
	.db	$cd,$84,$63,$24,$ce,$82
	.db	$cd,$84,$63,$24,$ce,$82
	.db	$cd,$84,$68,$26,$ce,$82
	.db	$cd,$84,$68,$26,$ce,$82
	.db	$cd,$8a,$63,$26,$ce,$82
	.db	$ff

S4A
	.db	$c0,$86,$70,$08
	.db	$c0,$86,$71,$08
	.db	$c0,$86,$70,$08
	.db	$c0,$86,$71,$0a
	.db	$c0,$86,$70,$0c
	.db	$c0,$86,$71,$0c
	.db	$c0,$86,$70,$0c
	.db	$c0,$86,$71,$0e
	.db	$c0,$86,$70,$0a
	.db	$c0,$86,$71,$0a
	.db	$c0,$86,$70,$0a
	.db	$c0,$86,$71,$0c
	.db	$c0,$86,$70,$08
	.db	$c0,$86,$71,$08
	.db	$c0,$86,$70,$08
	.db	$c0,$86,$71,$07

	.db	$c0,$86,$70,$05
	.db	$c0,$86,$71,$11
	.db	$c0,$86,$70,$05
	.db	$c0,$86,$71,$07
	.db	$c0,$86,$70,$08
	.db	$c0,$86,$71,$14
	.db	$c0,$86,$70,$08
	.db	$c0,$86,$71,$0a
	.db	$c0,$86,$70,$0c
	.db	$c0,$86,$71,$18
	.db	$c0,$86,$70,$0c
	.db	$c0,$86,$71,$0e
	.db	$c0,$86,$70,$0f
	.db	$c0,$86,$71,$0f
	.db	$c0,$86,$70,$11
	.db	$c0,$86,$71,$11
	.db	$c0,$86,$70,$13
	.db	$c0,$86,$71,$13
	.db	$c0,$86,$70,$13
	.db	$c0,$86,$71,$13
	.db	$ff
LEVEL2A
	.db	$84,$26,$2b,$26,$2b,$26,$2b,$26,$2c

	.db	$84,$31

	.db	$84,$30,$30

	.db	$85,$31

	.db	$91,$2f
	.db	$85,$2f
	.db	$85,$26,$2b,$26,$2c
	.db	$ff,$00
LEVEL2C
	.db	$90,$24,$24,$24,$24
	.db	$90,$25,$25,$25,$25
	.db	$90,$25,$95,$25,$8c,$2a,$89,$25
	.db	$90,$25,$95,$25,$8c,$2a,$89,$2e

	.db	$90,$25,$25,$8c,$2a,$2a
	.db	$89,$25,$25,$8b,$25,$25
	.db	$90,$25,$25,$8c,$2a,$2a
	.db	$89,$25,$25,$8b,$25,$25

	.db	$90,$25,$25,$8c,$2a,$2a
	.db	$89,$25,$25,$8b,$25,$25
	.db	$90,$25,$25,$8c,$2a,$2a
	.db	$89,$25,$25,$8b,$25,$25

	.db	$91,$25,$25,$8d,$2a,$2a
	.db	$8a,$25,$25,$8c,$25,$25
	.db	$91,$25,$25,$8d,$2a,$2a
	.db	$8a,$25,$25,$8c,$25,$25

	.db	$91,$25,$25,$8d,$2a,$2a
	.db	$8a,$25,$25,$8c,$25,$25
	.db	$91,$25,$25,$8d,$2a,$2a
	.db	$8a,$25,$25,$8c,$25,$25

	.db	$91,$25,$96,$25,$8d,$2a,$8a,$25
	.db	$91,$25,$96,$25,$8d,$2a,$8a,$2e
	.db	$ff,$00
LEVEL2D
	.db	$27,$27
	.db	$28,$28
	.db	$29,$29
	.db	$29,$2d

	.db	$29,$29,$29,$29
	.db	$29,$29,$29,$29

	.db	$29,$29,$29,$29
	.db	$29,$29,$29,$29

	.db	$29,$29,$29,$29
	.db	$29,$29,$29,$29

	.db	$29,$29,$29,$29
	.db	$29,$29,$29,$29

	.db	$29,$29
	.db	$29,$2d
	.db	$ff,$00
S24

	.db	$c0,$86,$70,$00
	.db	$c2,$82,$72,$0c
	.db	$c1,$84,$73,0
	.db	$c2,$82,$72,$0c,$e2
	.db	$c1,$82,$73,0
	.db	$c2,$82,$72,$0c,$e4
	.db	$c0,$86,$70,$0a
	.db	$c2,$82,$72,$0c
	.db	$ff
S25
	.db	$c0,$86,$70,$00
	.db	$c2,$82,$72,$0c
	.db	$c1,$84,$74,0
	.db	$c2,$82,$72,$0c,$e2
	.db	$c1,$82,$73,0
	.db	$c2,$82,$72,$0c,$e4
	.db	$c0,$86,$71,$0a
	.db	$c2,$82,$72,$0c
	.db	$ff
S2e
	.db	$c0,$86,$70,$00
	.db	$c2,$82,$72,$0c
	.db	$c1,$84,$74,0
	.db	$c2,$82,$72,$0c,$e2
	.db	$c0,$8a,$70,$00,$e6
	.db	$ff

S2A
	.db	$c0,$86,$70,$00
	.db	$c2,$82,$72,$0c
	.db	$c1,$84,$74,0
	.db	$c2,$82,$72,$0c,$e2
	.db	$c1,$82,$73,0
	.db	$c2,$82,$72,$0c,$e4
	.db	$c0,$86,$71,$0b
	.db	$c2,$82,$72,$0c
	.db	$ff
S26
	.db	$ca,$83,$67,$18,$d9,$81
	.db	$ca,$81,$60,$1b,$d9,$81
	.db	$ca,$83,$67,$18,$d9,$81
	.db	$ca,$81,$60,$1b,$d9,$81
	.db	$ca,$83,$67,$18,$d9,$81
	.db	$ca,$81,$60,$1b,$d9,$81
	.db	$ca,$83,$67,$18,$d9,$81
	.db	$ca,$81,$60,$1b,$d9,$81
	.db	$ca,$83,$67,$18,$d9,$81
	.db	$ca,$82,$60,$1b,$d9,$82

	.db	$ca,$83,$69,$18,$d9,$81
	.db	$ca,$81,$60,$1d,$d9,$81
	.db	$ca,$83,$69,$18,$d9,$81
	.db	$ca,$81,$60,$1d,$d9,$81
	.db	$ca,$83,$69,$18,$d9,$81
	.db	$ca,$81,$60,$1d,$d9,$81
	.db	$ca,$83,$69,$18,$d9,$81
	.db	$ca,$81,$60,$1d,$d9,$81
	.db	$ca,$83,$69,$18,$d9,$81
	.db	$ca,$82,$60,$1d,$d9,$82

	.db	$ca,$83,$65,$16,$d9,$81
	.db	$ca,$81,$60,$18,$d9,$81
	.db	$ca,$83,$65,$16,$d9,$81
	.db	$ca,$81,$60,$18,$d9,$81
	.db	$ca,$83,$65,$16,$d9,$81
	.db	$ca,$81,$60,$18,$d9,$81
	.db	$ca,$83,$65,$16,$d9,$81
	.db	$ca,$81,$60,$18,$d9,$81
	.db	$ca,$83,$65,$16,$d9,$81
	.db	$ca,$82,$60,$18,$d9,$82
	.db	$ca,$83,$66,$15,$d9,$81
	.db	$ca,$81,$60,$18,$d9,$81
	.db	$ca,$83,$66,$15,$d9,$81
	.db	$ca,$81,$60,$18,$d9,$81
	.db	$ca,$83,$66,$15,$d9,$81
	.db	$ff
S2B
	.db	$ca,$81,$60,$18,$d9,$81
	.db	$ca,$83,$66,$15,$d9,$81
	.db	$ca,$81,$60,$18,$d9,$81
	.db	$ca,$83,$66,$15,$d9,$81
	.db	$ca,$82,$60,$18,$d9,$82
	.db	$ff
S2C
	.db	$ca,$90,$6d,$0c
	.db	$ff
S27
	.db     $c5,$88,$31,$31,$31,$31,$31,$31,$31,$31
	.db	$ff
S28
	.db     $c5,$88,$31
	.db     $c7,$78,$5f
	.db     $c5,$31
	.db     $c7,$78,$5f
	.db     $c5,$31
	.db     $c7,$78,$5f
	.db     $c5,$31
	.db     $c7,$78,$5f
	.db	$ff
S29
	.db     $c5,$84,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db     $c5,$84,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db     $c5,$84,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db     $c5,$84,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db	$ff
S2D
	.db     $c5,$84,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db     $c5,$84,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db     $c5,$84,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db     $c4,$90,$31
	.db	$ff
S2F
	.db	$ca,$84,$6c,$00
	.db	$ca,$82,$6e,$18,$d9,$82
	.db	$ca,$82,$6e,$18,$d9,$82
	.db	$ca,$82,$6e,$18,$d9,$82
	.db	$ca,$85,$6e,$18,$d9,$81
	.db	$ca,$82,$6e,$18,$d9,$88
	.db	$ca,$84,$6c,$00
	.db	$ca,$82,$6e,$18,$d9,$82
	.db	$ca,$82,$6e,$18,$d9,$82
	.db	$ca,$82,$6e,$18,$d9,$82
	.db	$ca,$85,$6e,$18,$d9,$81
	.db	$ca,$85,$6f,$18,$d9,$81
	.db	$ca,$82,$70,$18,$d9,$82

	.db	$ca,$84,$6c,$08
	.db	$ca,$82,$71,$18,$d9,$82
	.db	$ca,$82,$71,$18,$d9,$82
	.db	$ca,$82,$71,$18,$d9,$82
	.db	$ca,$85,$71,$18,$d9,$81
	.db	$ca,$82,$71,$18,$d9,$88
	.db	$ca,$84,$6c,$08
	.db	$ca,$82,$71,$18,$d9,$82
	.db	$ca,$82,$71,$18,$d9,$82
	.db	$ca,$82,$71,$18,$d9,$82
	.db	$ca,$85,$71,$18,$d9,$81
	.db	$ca,$85,$72,$18,$d9,$81
	.db	$ca,$82,$73,$18,$d9,$82

	.db	$ca,$84,$6c,$05
	.db	$ca,$82,$74,$18,$d9,$82
	.db	$ca,$82,$74,$18,$d9,$82
	.db	$ca,$82,$74,$18,$d9,$82
	.db	$ca,$85,$74,$18,$d9,$81
	.db	$ca,$82,$74,$18,$d9,$88
	.db	$ca,$84,$6c,$05
	.db	$ca,$82,$74,$18,$d9,$82
	.db	$ca,$82,$74,$18,$d9,$82
	.db	$ca,$82,$74,$18,$d9,$82
	.db	$ca,$85,$74,$18,$d9,$81
	.db	$ca,$85,$6f,$18,$d9,$81
	.db	$ca,$82,$75,$18,$d9,$82

	.db	$ca,$84,$6c,$07
	.db	$ca,$82,$76,$18,$d9,$82
	.db	$ca,$82,$76,$18,$d9,$82
	.db	$ca,$82,$76,$18,$d9,$82
	.db	$ca,$85,$76,$18,$d9,$81
	.db	$ca,$82,$76,$18,$d9,$88
	.db	$ca,$84,$6c,$07
	.db	$ca,$82,$77,$1a,$d9,$82
	.db	$ca,$82,$77,$1a,$d9,$82
	.db	$ca,$82,$77,$1a,$d9,$82
	.db	$ca,$85,$77,$1a,$d9,$81
	.db	$ca,$85,$78,$1d,$d9,$81
	.db	$ca,$82,$78,$1f,$d9,$82
	.db	$ff
S30
	.db	$db,$84,$6c,$00
	.db	$dc,$84,$6e,$18
	.db	$dc,$84,$6e,$18
	.db	$dc,$84,$6e,$18
	.db	$dd,$86,$6e,$18
	.db	$dc,$8a,$6e,$18
	.db	$dc,$84,$6c,$00
	.db	$dc,$84,$6e,$18
	.db	$dc,$84,$6e,$18
	.db	$dc,$84,$6e,$18
	.db	$dd,$86,$6e,$18
	.db	$dd,$86,$6f,$18
	.db	$dc,$84,$70,$18

	.db	$dc,$84,$6c,$08
	.db	$dc,$84,$71,$18
	.db	$dc,$84,$71,$18
	.db	$dc,$84,$71,$18
	.db	$dd,$86,$71,$18
	.db	$dc,$8a,$71,$18
	.db	$dc,$84,$6c,$08
	.db	$dc,$84,$71,$18
	.db	$dc,$84,$71,$18
	.db	$dc,$84,$71,$18
	.db	$dd,$86,$71,$18
	.db	$dd,$86,$72,$18
	.db	$dc,$84,$73,$18

	.db	$dc,$84,$6c,$05
	.db	$dc,$84,$74,$18
	.db	$dc,$84,$74,$18
	.db	$dc,$84,$74,$18
	.db	$dd,$86,$74,$18
	.db	$dc,$8a,$74,$18
	.db	$dc,$84,$6c,$05
	.db	$dc,$84,$74,$18
	.db	$dc,$84,$74,$18
	.db	$dc,$84,$74,$18
	.db	$dd,$86,$74,$18
	.db	$dd,$86,$6f,$18
	.db	$dc,$84,$75,$18

	.db	$dc,$84,$6c,$07
	.db	$dc,$84,$76,$18
	.db	$dc,$84,$76,$18
	.db	$dc,$84,$76,$18
	.db	$dd,$86,$76,$18
	.db	$dc,$8a,$76,$18
	.db	$dc,$84,$6c,$07
	.db	$dc,$84,$77,$1a
	.db	$dc,$84,$77,$1a
	.db	$dc,$84,$77,$1a
	.db	$dd,$86,$77,$1a
	.db	$dd,$86,$78,$1d
	.db	$dc,$84,$78,$1f
	.db	$ff
S31
	.db	$cb,$81,$1a,$87,$1b
	.db	$cc
	.db	$84,$1a
	.db	$8c,$16
	.db	$84,$18
	.db	$81,$12,$97,$13
	.db	$84,$11
	.db	$82,$0f,$e2
	.db	$81,$12,$9b,$11
	.db	$84,$13
	.db	$86,$0c,$e2
	.db	$84,$0c
	.db	$84,$0e
	.db	$84,$0f
	.db	$84,$13
	.db	$84,$18
	.db	$84,$1a
	.db	$82,$1b,$e2
	.db	$81,$1e,$87,$1d
	.db	$84,$1b
	.db	$88,$18
	.db	$84,$1b
	.db	$82,$1f,$e2
	.db	$81,$1e,$8b,$1d
	.db	$84,$1b
	.db	$84,$18
	.db	$84,$1b
	.db	$84,$1d,$e8
	.db	$81,$1e,$87,$1f
	.db	$84,$23,$e4
	.db	$81,$22,$83,$23
	.db	$84,$1d,$e4
	.db	$88,$1f
	.db	$84,$20
	.db	$90,$1f
	.db	$82,$2b
	.db	$82,$1f
	.db	$82,$13
	.db	$82,$07

	.db	$88,$24
	.db	$84,$26
	.db	$98,$27
	.db	$82,$24,$26,$84,$27
	.db	$82,$29,$e2
	.db	$81,$2a,$83,$2b
	.db	$82,$30,$e2
	.db	$81,$2a,$83,$2b
	.db	$81,$2a,$8b,$29
	.db	$84,$27
	.db	$8c,$24
	.db	$84,$26
	.db	$84,$27,$e4
	.db	$84,$13
	.db	$82,$0f,$e2
	.db	$82,$11,$12,$84,$11

	.db	$82,$24,$e2
	.db	$84,$26
	.db	$82,$27,$e2
	.db	$81,$27,$87,$29
	.db	$84,$24
	.db	$81,$2a,$87,$2b
	.db	$84,$24
	.db	$84,$2c
	.db	$84,$2e,$30,$32,$e4
	.db	$33,$e4
	.db	$35,$33
	.db	$81,$35,$36
	.db	$8e,$37
	.db	$82,$35
	.db	$82,$33
	.db	$88,$32
	.db	$82,$30,$e2
	.db	$81,$2e,$87,$2f
	.db	$84,$2b
	.db	$84,$29
	.db	$82,$2c,$e2
	.db	$81,$2a,$83,$2b
	.db	$84,$29
	.db	$82,$27,$26,$22,$1f
	.db	$ff

LEVEL1A
	.db	$8e,$16,$8c,$17
	.db	$8e,$16,$8c,$17
	.db	$8e,$16,$8c,$17

	.db	$82,$1f
	.db	$82,$22
	.db	$82,$22
	.db	$82,$23
	.db	$90,$16,$8e,$17
	.db	$8c,$17,$8b,$16
	.db	$ff,$00
LEVEL1C
	.db	$8e,$18,$18
	.db	$8e,$1a,$8c,$1a
	.db	$8e,$1c,$1c,$1c,$1d,$8c,$1c,$1c,$1c,$1d

	.db	$8e,$1c,$1c,$8c,$1c,$1d
	.db	$8e,$1c,$1c,$8c,$1c,$87,$1d
	.db	$8e,$1c,$1c,$8c,$1c,$1d
	.db	$8e,$1c,$1c,$8c,$1c,$87,$1d

	.db	$8a,$1c,$8c,$1c,$8a,$1c,$87,$1d
	.db	$8a,$1c,$8c,$1c,$8f,$1c,$91,$1d

	.db	$8a,$1c,$8c,$1c,$8a,$1c,$87,$1d
	.db	$8a,$1c,$8c,$1c,$8f,$1c,$91,$1d

	.db	$90,$1c,$1c,$8e,$1c,$1d
	.db	$8d,$1c,$1c,$8d,$1c,$1d
	.db	$8c,$1c,$1c,$8b,$1c,$1d
	.db	$90,$1c,$1c,$84,$1c,$1d

	.db	$90,$1c,$1c,$1c,$1d,$8e,$1c,$1c,$1c,$1d
	.db	$8c,$1c,$1c,$1c,$1d,$8b,$1c,$1c,$1c,$1d
	.db	$ff,$00
LEVEL1D
	.db	$19,$19
	.db	$1b,$1b
	.db	$1e,$1e

	.db	$1e,$1e
	.db	$1e,$1e
	.db	$1e,$1e
	.db	$1e,$1e
	.db	$1e,$1e
	.db	$1e,$1e
	.db	$1e,$1e
	.db	$1e,$1e
	.db	$ff,$00
S16
	.db     $d5
	.db	$81,$13,$18,$82,$1a
	.db     $d6
	.db	$81,$13,$18,$82,$1a
	.db     $d7
	.db	$81,$13,$18,$82,$1a
	.db     $d8
	.db	$81,$13,$18,$82,$1a

	.db     $d5
	.db	$81,$13,$18,$82,$1c
	.db     $d6
	.db	$81,$13,$18,$82,$1c
	.db     $d7
	.db	$81,$13,$18,$82,$1c
	.db     $d8
	.db	$81,$13,$18,$82,$1c

	.db     $d5
	.db	$81,$13,$18,$82,$1d
	.db     $d6
	.db	$81,$13,$18,$82,$1d
	.db     $d7
	.db	$81,$13,$18,$82,$1d
	.db     $d8
	.db	$81,$13,$18,$82,$1d

	.db     $d5
	.db	$81,$13,$18,$82,$1f
	.db     $d6
	.db	$81,$13,$18,$82,$1f
	.db     $d7
	.db	$81,$13,$18,$82,$1f
	.db     $d8
	.db	$81,$13,$18,$82,$1f
	.db	$ff
s17
	.db     $d5
	.db	$81,$13,$18,$82,$1a
	.db     $d6
	.db	$81,$13,$18,$82,$1a
	.db     $d7
	.db	$81,$13,$18,$82,$1a
	.db     $d8
	.db	$81,$13,$18,$82,$1a

	.db     $d5
	.db	$81,$13,$18,$82,$1c
	.db     $d6
	.db	$81,$13,$18,$82,$1c
	.db     $d7
	.db	$81,$13,$18,$82,$1c
	.db     $d8
	.db	$81,$13,$18,$82,$1c

	.db     $d5
	.db	$81,$13,$18,$82,$1e
	.db     $d6
	.db	$81,$13,$18,$82,$1e
	.db     $d7
	.db	$81,$13,$18,$82,$1e
	.db     $d8
	.db	$81,$13,$18,$82,$1e

	.db     $d5
	.db	$81,$13,$18,$82,$1f
	.db     $d6
	.db	$81,$13,$18,$82,$1f
	.db     $d7
	.db	$81,$13,$18,$82,$1f
	.db     $d8
	.db	$81,$13,$18,$82,$1f

	.db	$ff
S18
 	.db	$c1,$84,$73,0,0,0,0,0,0,0,0,0,0,0,0,0,0,$83,0
	.db	$81,0,$82,0,0
	.db	$ff
S19
	.db	$c4,$88,$31
	.db     $c5,$84,$31,$31
	.db	$31,$31,$31,$31
	.db	$31,$31,$31,$31
	.db	$31,$31,$31,$31
	.db	$ff
S1A
	.db	$c1,$82,$73,0
	.db	$c0,$82,$72,$0c
	.db	$c1,$82,$73,0
	.db	$c0,$82,$72,$0c
	.db	$c1,$82,$73,0
	.db	$c0,$82,$72,$0c
	.db	$c1,$82,$73,0
	.db	$c0,$82,$72,$0c
	.db	$c1,$82,$73,0
	.db	$c0,$82,$72,$0c
	.db	$c1,$82,$73,0
	.db	$c0,$82,$72,$0c
	.db	$c1,$82,$73,0
	.db	$c0,$82,$72,$0c
	.db	$c1,$82,$73,0
	.db	$c0,$82,$72,$0c
	.db	$c1,$82,$73,0
	.db	$c0,$82,$72,$0c
	.db	$c1,$82,$73,0
	.db	$c0,$82,$72,$0c
	.db	$c1,$82,$73,0
	.db	$c0,$82,$72,$0c
	.db	$c1,$82,$73,0
	.db	$c0,$82,$72,$0c
	.db	$c1,$82,$73,0
	.db	$c0,$82,$72,$0c
	.db	$c1,$82,$73,0
	.db	$c0,$82,$72,$0c
	.db	$c1,$82,$73,0
	.db	$c0,$81,$72,$0c
	.db	$c0,$81,$70,$0c
	.db	$c1,$82,$73,0
	.db	$c0,$82,$70,$0c
	.db	$ff
S1B
	.db     $c5,$82,$31,$31,$31,$31,$31,$31,$31,$31
	.db	$31,$31,$31,$31,$31,$31,$31,$31
	.db	$31,$31,$31,$31,$31,$31,$31,$31
	.db	$31,$31,$31,$31,$31,$31
	.db	$81,$31,$31
	.db	$c6,$82,$31
	.db	$ff
S1C
	.db	$c0
	.db	$82,$70,$00
	.db	$72,$0c
	.db	$71,$00
	.db	$72,$0c
	.db	$70,$00
	.db	$72,$0c
	.db	$71,$00
	.db	$72,$0c
	.db	$ff
S1D
	.db	$c0
	.db	$82,$70,$00
	.db	$82,$72,$0c
	.db	$82,$71,$00
	.db	$82,$72,$0c
	.db	$82,$70,$00
	.db	$81,$72,$0c
	.db	$81,$70,$0c
	.db	$82,$71,$00
	.db	$82,$70,$0c
	.db	$ff
S1E
	.db     $c5,$82,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db     $c5,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db     $c5,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db     $c5,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db     $c5,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db     $c5,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db     $c5,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db     $c5,$31
	.db     $c6,$31
	.db     $c7,$78,$5f
	.db     $c6,$31
	.db	$ff
S1F
	.db	$ca,$84,$64,$18,$d9,$82
	.db	$ca,$84,$64,$18,$d9,$82
	.db	$ca,$84,$63,$1a,$d9,$82
	.db	$ca,$84,$63,$1c,$d9,$82
	.db	$ca,$83,$65,$1f,$d9,$81
	.db	$ca,$81,$63,$1c,$d9,$81
	.db	$ca,$81,$64,$1d,$d9,$81
	.db	$ca,$84,$65,$1d,$d9,$82
	.db	$ca,$84,$65,$1d,$d9,$82
	.db	$ca,$84,$64,$1d,$d9,$82
	.db	$ca,$84,$63,$1a,$d9,$82
	.db	$ca,$81,$64,$16,$d9,$81
	.db	$ca,$81,$64,$18,$d9,$81
	.db	$ca,$83,$63,$1a,$d9,$81
	.db	$ca,$84,$63,$1c,$d9,$82
	.db	$ca,$84,$64,$18,$d9,$82
	.db	$ca,$84,$65,$13,$d9,$82
	.db	$ca,$84,$63,$10,$d9,$82
	.db	$ca,$83,$63,$10,$d9,$81
	.db	$ca,$83,$64,$11,$d9,$81
	.db	$ca,$84,$65,$11,$d9,$82
	.db	$ca,$84,$65,$11,$d9,$82
	.db	$ca,$8a,$64,$11,$d9,$82
	.db	$ca,$83,$63,$13,$d9,$81
	.db	$ca,$83,$63,$15,$d9,$81

	.db	$ca,$84,$64,$18,$d9,$82
	.db	$ca,$84,$64,$18,$d9,$82
	.db	$ca,$84,$63,$1a,$d9,$82
	.db	$ca,$84,$63,$1c,$d9,$82
	.db	$ca,$83,$65,$1f,$d9,$81
	.db	$ca,$81,$64,$22,$d9,$81
	.db	$ca,$81,$64,$24,$d9,$81
	.db	$ca,$84,$63,$26,$d9,$82
	.db	$ca,$84,$64,$22,$d9,$82
	.db	$ca,$84,$65,$29,$d9,$82
	.db	$ca,$84,$65,$29,$d9,$82
	.db	$ca,$81,$64,$29,$d9,$81
	.db	$ca,$81,$63,$28,$d9,$81
	.db	$ca,$83,$63,$26,$d9,$81
	.db	$ca,$84,$63,$28,$d9,$82
	.db	$ca,$84,$64,$24,$d9,$82
	.db	$ca,$84,$65,$1f,$d9,$82
	.db	$ca,$84,$68,$28,$d9,$82
	.db	$ca,$83,$67,$24,$d9,$81
	.db	$ca,$83,$69,$24,$d9,$81
	.db	$ca,$84,$68,$26,$d9,$82
	.db	$ca,$84,$68,$26,$d9,$82
	.db	$ca,$8a,$69,$24,$d9,$82
	.db	$ca,$86,$68,$21,$d9,$82
	.db	$ff
S22
	.db	$ca,$83,$67,$20,$d9,$81
	.db	$ca,$81,$67,$20,$d9,$81
	.db	$ca,$83,$64,$20,$d9,$81
	.db	$ca,$81,$66,$20,$d9,$81
	.db	$ca,$83,$67,$20,$d9,$81
	.db	$ca,$83,$64,$22,$d9,$81
	.db	$ca,$81,$64,$22,$d9,$81
	.db	$ca,$83,$67,$22,$d9,$81
	.db	$ca,$81,$64,$22,$d9,$81
	.db	$ca,$81,$65,$22,$d9,$81
	.db	$ca,$81,$67,$22,$d9,$81

	.db	$ca,$83,$67,$20,$d9,$81
	.db	$ca,$81,$67,$20,$d9,$81
	.db	$ca,$83,$67,$20,$d9,$81
	.db	$ca,$81,$66,$20,$d9,$81
	.db	$ca,$83,$64,$20,$d9,$81
	.db	$ca,$83,$65,$1f,$d9,$81
	.db	$ca,$81,$62,$22,$d9,$81
	.db	$ca,$84,$64,$20,$d9,$82
	.db	$ca,$81,$64,$20,$d9,$81
	.db	$ca,$81,$66,$20,$d9,$81

	.db	$ca,$83,$67,$20,$d9,$81
	.db	$ca,$81,$67,$20,$d9,$81
	.db	$ca,$83,$64,$20,$d9,$81
	.db	$ca,$81,$66,$20,$d9,$81
	.db	$ca,$83,$67,$20,$d9,$81
	.db	$ca,$83,$64,$22,$d9,$81
	.db	$ca,$81,$64,$22,$d9,$81
	.db	$ca,$83,$67,$22,$d9,$81
	.db	$ca,$81,$67,$22,$d9,$81
	.db	$ca,$81,$69,$22,$d9,$81
	.db	$ca,$81,$6a,$22,$d9,$81

	.db	$ca,$83,$67,$25,$d9,$81
	.db	$ca,$81,$67,$25,$d9,$81
	.db	$ca,$83,$64,$25,$d9,$81
	.db	$ca,$81,$66,$25,$d9,$81
	.db	$ca,$83,$67,$25,$d9,$81
	.db	$ca,$86,$64,$27,$d9,$82
	.db	$ca,$86,$63,$2b,$d9,$82
	.db	$ff
S23
	.db	$ca,$83,$62,$2b,$d9,$81
	.db	$ca,$81,$62,$2b,$d9,$81
	.db	$ca,$82,$64,$29,$d9,$82
	.db	$ca,$82,$64,$29,$d9,$82
	.db	$ca,$83,$65,$28,$d9,$81
	.db	$ca,$82,$65,$28,$d9,$82
	.db	$ca,$81,$65,$28,$d9,$81
	.db	$ca,$82,$67,$26,$d9,$82
	.db	$ca,$82,$67,$26,$d9,$82

	.db	$ca,$83,$62,$29,$d9,$81
	.db	$ca,$81,$62,$29,$d9,$81
	.db	$ca,$82,$63,$28,$d9,$82
	.db	$ca,$82,$63,$28,$d9,$82
	.db	$ca,$83,$65,$26,$d9,$81
	.db	$ca,$82,$65,$26,$d9,$82
	.db	$ca,$81,$65,$26,$d9,$81
	.db	$ca,$82,$67,$24,$d9,$82
	.db	$ca,$82,$67,$24,$d9,$82

	.db	$ca,$83,$67,$24,$d9,$81
	.db	$ca,$81,$65,$26,$d9,$81
	.db	$ca,$88,$65,$26,$d9,$82

	.db	$da,$81,$7a,$0c,$82,$0c,$83,$0c,$09,$06,$82,$03,$00

	.db	$ca,$83,$65,$1a,$d9,$81
	.db	$ca,$81,$60,$13,$d9,$81
	.db	$ca,$83,$65,$1a,$d9,$81
	.db	$ca,$81,$60,$13,$d9,$81
	.db	$ca,$83,$65,$1a,$d9,$81
	.db	$ca,$81,$60,$13,$d9,$81
	.db	$ca,$83,$65,$1a,$d9,$81
	.db	$ca,$81,$60,$13,$d9,$81
	.db	$ca,$83,$65,$1a,$d9,$81

	.db	$ca,$81,$60,$26,$d9,$81
	.db	$ca,$81,$60,$28,$d9,$81

	.db	$ca,$83,$63,$26,$d9,$81
	.db	$ca,$81,$63,$26,$d9,$81
	.db	$ca,$82,$63,$26,$d9,$82
	.db	$ca,$82,$63,$26,$d9,$82
	.db	$ca,$85,$63,$28,$d9,$81
	.db	$ca,$82,$63,$26,$d9,$82
	.db	$ca,$83,$64,$24,$d9,$81
	.db	$ca,$82,$64,$22,$d9,$82

	.db	$ca,$83,$67,$1f,$d9,$81
	.db	$ca,$81,$67,$1f,$d9,$81
	.db	$ca,$82,$67,$1f,$d9,$82
	.db	$ca,$82,$69,$1f,$d9,$82
	.db	$ca,$85,$64,$21,$d9,$81
	.db	$ca,$82,$64,$21,$d9,$82
	.db	$ca,$83,$63,$23,$d9,$81
	.db	$ca,$82,$63,$25,$d9,$82

	.db	$ca,$84,$63,$25,$d9,$82
	.db	$ca,$84,$63,$28,$d9,$82
	.db	$ca,$84,$63,$2b,$d9,$82
	.db	$ca,$84,$63,$2e,$d9,$82
	.db	$ca,$83,$63,$31,$d9,$81
	.db	$ca,$83,$63,$2e,$d9,$81
	.db	$ca,$8c,$65,$2d,$d9,$84

	.db	$da,$81,$7a,$0c,$85,$0c
	.db	$da,$81,$7a,$08,$85,$08
	.db	$da,$81,$7a,$04,$83,$04
	.db	$ff

TITLE1A
	.db	$80,$70,$13,$15

	.db	$80,$01,$02,$07
	.db	$80,$01,$02,$07,$02,$07
	.db	$80,$0b,$0b,$0d
	.db	$80,$01,$02,$07,$02,$07
	.db	$ff,$00
TITLE1B
	.db	$80,$75,$15,$13

	.db	$80,$07,$75,$01,$02
	.db	$8c,$70,$03,$8e,$06
	.db	$8c,$06,$8e,$06
	.db	$8c,$06,$8e,$06
	.db	$8c,$06,$80,$06

	.db	$80,$11,$8c,$11

	.db	$80,$0c,$0c,$0e

	.db	$8c,$03,$8e,$06
	.db	$8c,$06,$8e,$06
	.db	$8c,$06,$8e,$06
	.db	$8c,$06,$80,$06

	.db	$88,$06,$87,$06
	.db	$88,$06,$87,$06
	.db	$85,$06,$88,$06
	.db	$87,$06,$87,$06
	.db	$88,$06,$87,$06
	.db	$88,$06,$87,$06
	.db	$85,$06,$88,$06
	.db	$87,$06,$87,$06
	.db	$ff,$00
TITLE1C
	.db	$80,$12,$12,$12,$12
	.db	$85,$12,$12,$12,$12
	.db	$8a,$12,$12,$12,$12
	.db	$88,$12,$12,$8c,$12,$80,$12

	.db	$8c,$04,$8e,$04
	.db	$8c,$04,$8e,$04
	.db	$8c,$04,$8e,$04
	.db	$8c,$04,$80,$08
	.db	$88,$04,$87,$04
	.db	$88,$04,$87,$04
	.db	$85,$04,$88,$04
	.db	$87,$04,$87,$08

	.db	$8c,$04,$8e,$04
	.db	$8c,$04,$8e,$04
	.db	$8c,$04,$8e,$04
	.db	$8c,$04,$80,$08
	.db	$88,$04,$87,$04
	.db	$88,$04,$87,$04
	.db	$85,$04,$88,$04
	.db	$87,$04,$87,$08
	.db	$88,$04,$87,$04
	.db	$88,$04,$87,$04
	.db	$85,$04,$88,$04
	.db	$87,$04,$87,$08

	.db	$8c,$0a,$0a,$80,$0f

	.db	$8c,$20,$8e,$20
	.db	$8c,$20,$8e,$20
	.db	$8c,$20,$8e,$20
	.db	$8c,$20,$80,$21
	.db	$88,$20,$87,$20
	.db	$88,$20,$87,$20
	.db	$85,$20,$88,$20
	.db	$87,$20,$87,$21
	.db	$88,$20,$87,$20
	.db	$88,$20,$87,$20
	.db	$85,$20,$88,$20
	.db	$87,$20,$87,$21
	.db	$ff,$00
TITLE1D
	.db	$14,$14,$14,$14
	.db	$05,$05,$05,$05

	.db	$05,$05,$05,$09
	.db	$05,$05,$05,$09
	.db	$05,$05,$05,$09
	.db	$05,$05,$05,$09
	.db	$05,$05,$05,$09

	.db	$05,$10,$05,$10
	.db	$05,$09

	.db	$05,$05,$05,$09
	.db	$05,$05,$05,$09
	.db	$05,$05,$05,$09
	.db	$ff,$00

S20
	.db	$c0,$84
	.db	$70,$00
	.db	$72,$0c
	.db	$71,$00
	.db	$72,$0c
	.db	$70,$00
	.db	$72,$0c
	.db	$71,$00
	.db	$72,$0c
	.db	$ff
S21
	.db	$c0,$84
	.db	$70,$00
	.db	$72,$0c
	.db	$71,$00
	.db	$72,$0c
	.db	$70,$00
	.db	$72,$0c
	.db	$71,$00
	.db	$82,$71,$0c,$0c
	.db	$ff

S01
	.db	$c3
	.db	$84,$24
	.db	$82,$26,$e2
	.db	$84,$27
	.db	$82,$24,$e2
	.db	$8c,$2b
	.db	$84,$2a,$e4
	.db	$84,$26,$e4
	.db	$88,$21
	.db	$82,$22
	.db	$82,$21
	.db	$84,$1f
	.db	$82,$1e,$e2
	.db	$84,$1f
	.db	$82,$24,$e2
	.db	$84,$26
	.db	$82,$27,$e2
	.db	$8c,$2b
	.db	$84,$2a,$e4
	.db	$84,$26,$e4
	.db	$88,$2d
	.db	$82,$2e
	.db	$82,$2d
	.db	$84,$2b
	.db	$82,$2a,$e2

	.db	$84,$2b
	.db	$82,$24,$e2
	.db	$84,$27
	.db	$82,$2b,$e2
	.db	$8c,$30
	.db	$84,$2d,$e4
	.db	$84,$2a,$e4
	.db	$88,$26
	.db	$82,$27
	.db	$82,$26
	.db	$84,$24
	.db	$82,$23,$e2

	.db	$84,$24
	.db	$82,$1f,$e2
	.db	$84,$1b
	.db	$82,$18,$e2
	.db	$84,$1f
	.db	$82,$1b,$e2
	.db	$84,$18
	.db	$82,$13,$e2
	.db	$8c,$0c
	.db	$82,$0f,$13
	.db	$84,$18,$e4
	.db	$c9
	.db	$84,$60,$24,$e4
	.db	$ff
S02
	.db	$c9
	.db	$8a,$6d,$24,$e2
	.db	$8a,$61,$20,$e2
	.db	$84,$6e,$20,$e4
	.db	$8a,$67,$1f,$e2
	.db	$8a,$62,$1f,$e2
	.db	$84,$60,$24,$e4
	.db	$8a,$6d,$24,$e2
	.db	$8a,$61,$20,$e2
	.db	$84,$6e,$20,$e4
	.db	$8a,$66,$1f,$e2
	.db	$8a,$61,$1f,$e2
	.db	$84,$64,$23,$e4

	.db	$8a,$65,$20,$e2
	.db	$8a,$61,$20,$e2
	.db	$84,$6e,$20,$e4
	.db	$8a,$60,$1d,$e2
	.db	$8a,$6f,$1d,$e2
	.db	$84,$75,$1d,$e4

	.db	$8a,$68,$1a,$e2
	.db	$8a,$76,$1b,$e2
	.db	$84,$77,$1d,$e4

	.db	$98,$61,$1f
	.db	$ff
S03
	.db	$cf,$82,$0c
	.db	$d0,$82,$18
	.db	$d1,$84,$0c
	.db	$d0,$82,$18,$0c
	.db	$d1,$84,$18
	.db	$d0,$82,$0c,$18
	.db	$d1,$84,$0c
	.db	$d0,$82,$18,$0c
	.db	$d1,$84,$18
	.db	$ff
S06
	.db	$d0,$82,$0c,$18
	.db	$d1,$84,$0c
	.db	$d0,$82,$18,$0c
	.db	$d1,$84,$18
	.db	$d0,$82,$0c,$18
	.db	$d1,$84,$0c
	.db	$d0,$82,$18,$0c
	.db	$d1,$84,$18
	.db	$ff
S04
	.db	$c1,$84,$73,0
	.db	$c0,$84,$72,$0c
	.db	$c1,$84,$74,0
	.db	$c0,$84,$72,$0c
	.db	$c1,$84,$73,0
	.db	$c0,$84,$72,$0c
	.db	$c1,$84,$74,0
	.db	$c0,$84,$72,$0c
	.db	$ff
S08
	.db	$c1,$84,$73,0
	.db	$c0,$84,$72,$0c
	.db	$c1,$84,$74,0
	.db	$c0,$84,$72,$0c
	.db	$c1,$84,$73,0
	.db	$c0,$84,$72,$0c
	.db	$c1,$84,$74,0
	.db	$c0,$82,$71,$0c
	.db	$c0,$82,$71,$0c
	.db	$ff
S05
	.db     $c5,$84,$31
	.db     $c6,$84,$31
	.db     $c7,$84,$78,$5f
	.db     $c6,$84,$31
	.db     $c5,$84,$31
	.db     $c6,$84,$31
	.db     $c7,$84,$78,$5f
	.db     $c6,$84,$31
	.db     $c5,$84,$31
	.db     $c6,$84,$31
	.db     $c7,$84,$78,$5f
	.db     $c6,$84,$31
	.db     $c5,$84,$31
	.db     $c6,$84,$31
	.db     $c7,$84,$78,$5f
	.db     $c6,$84,$31
	.db     $ff
S09
	.db     $c5,$84,$31
	.db     $c6,$84,$31
	.db     $c7,$84,$78,$5f
	.db     $c6,$84,$31
	.db     $c5,$84,$31
	.db     $c6,$84,$31
	.db     $c7,$84,$78,$5f
	.db     $c6,$84,$31
	.db     $c5,$84,$31
	.db     $c6,$84,$31
	.db     $c7,$84,$78,$5f
	.db     $c6,$84,$31
	.db     $c5,$84,$31
	.db     $c6,$84,$31
	.db     $c7,$84,$78,$5f
	.db     $c7,$82,$78,$5f
	.db     $c7,$82,$78,$5f
	.db     $ff
S10
	.db     $c5,$84,$31
	.db     $c6,$84,$31
	.db     $c7,$84,$78,$5f
	.db     $c6,$84,$31
	.db     $c5,$84,$31
	.db     $c6,$84,$31
	.db     $c7,$84,$78,$5f
	.db     $c6,$84,$31
	.db     $c5,$84,$31
	.db     $c6,$84,$31
	.db     $c7,$84,$78,$5f
	.db     $c6,$84,$31
	.db     $c5,$84,$31
	.db     $c6,$84,$31
	.db     $c7,$84,$78,$5f
	.db     $c6,$82,$31
	.db     $c7,$82,$78,$5f
	.db     $ff

S07
	.db	$e8
	.db	$ff
S0A
	.db	$c0,$84,$70,$0c
	.db	$84,$72,$18
	.db	$84,$71,$0c
	.db	$84,$72,$18
	.db	$84,$70,$0c
	.db	$84,$72,$18
	.db	$84,$71,$0c
	.db	$84,$72,$18
	.db	$84,$70,$05
	.db	$84,$72,$11
	.db	$84,$71,$05
	.db	$84,$72,$11
	.db	$84,$70,$05
	.db	$84,$72,$11
	.db	$84,$71,$05
	.db	$84,$72,$11
	.db	$84,$70,$07
	.db	$84,$72,$13
	.db	$84,$71,$07
	.db	$84,$72,$13
	.db	$84,$70,$07
	.db	$84,$72,$13
	.db	$84,$71,$07
	.db	$84,$72,$13
	.db	$84,$70,$05
	.db	$84,$72,$11
	.db	$84,$71,$05
	.db	$84,$72,$11
	.db	$84,$70,$05
	.db	$84,$72,$11
	.db	$84,$71,$05
	.db	$82,$72,$16
	.db	$82,$71,$16
	.db	$ff
S0B
	.db	$d3
	.db	$82,$1f,$e4
	.db	$d4
	.db	$82,$1f,$e4
	.db	$82,$1f,$e4
	.db	$82,$1f,$e4
	.db	$87,$1f,$e1
	.db	$d3
	.db	$82,$20,$e4
	.db	$d4
	.db	$82,$20,$e4
	.db	$82,$20,$e4
	.db	$82,$20,$e4
	.db	$87,$20,$e1
	.db	$d3
	.db	$82,$22,$e4
	.db	$d4
	.db	$82,$22,$e4
	.db	$82,$22,$e4
	.db	$82,$22,$e4
	.db	$87,$22,$e1
	.db	$d3
	.db	$82,$20,$e4
	.db	$d4
	.db	$82,$20,$e4
	.db	$82,$20,$e4
	.db	$82,$20,$e4
	.db	$84,$20
	.db	$84,$1d
	.db	$ff
S0C
	.db	$d3
	.db	$82,$24,$e4
	.db	$d4
	.db	$82,$24,$e4
	.db	$82,$24,$e4
	.db	$82,$24,$e4
	.db	$87,$24,$e1
	.db	$82,$24,$e4
	.db	$82,$24,$e4
	.db	$82,$24,$e4
	.db	$82,$24,$e4
	.db	$87,$24,$e1
	.db	$82,$24,$e4
	.db	$82,$24,$e4
	.db	$82,$24,$e4
	.db	$82,$24,$e4
	.db	$87,$24,$e1
	.db	$82,$24,$e4
	.db	$82,$24,$e4
	.db	$82,$24,$e4
	.db	$82,$24,$e4
	.db	$88,$24
	.db	$ff
S0D
	.db	$d3
	.db	$a0,$1f
	.db	$d4
	.db	$a0,$18
	.db	$a0,$13
	.db	$a0,$0c
	.db	$ff
S0E
	.db	$d3
	.db	$a0,$24
	.db	$a0,$1f
	.db	$a0,$18

	.db	$da,$86,$7a,$12,$84,$10,$82,$0e
	.db	$84,$0c,$0a,$08,$82,$06,$04,$84,$02
	.db	$ff
S0F
	.db	$c0,$84,$70,$0c
	.db	$84,$72,$18
	.db	$84,$71,$0c
	.db	$84,$72,$18
	.db	$84,$70,$0c
	.db	$84,$72,$18
	.db	$84,$71,$0c
	.db	$84,$72,$18
	.db	$84,$70,$0c
	.db	$84,$72,$18
	.db	$84,$71,$0c
	.db	$84,$72,$18
	.db	$84,$70,$0c
	.db	$84,$72,$18
	.db	$84,$71,$0c
	.db	$84,$72,$18
	.db	$84,$70,$00
	.db	$84,$72,$0c
	.db	$84,$71,$00
	.db	$84,$72,$0c
	.db	$84,$70,$00
	.db	$84,$72,$0c
	.db	$84,$71,$00
	.db	$84,$72,$0c
	.db	$84,$70,$00
	.db	$84,$72,$0c
	.db	$84,$71,$00
	.db	$84,$72,$0c
	.db	$84,$70,$00
	.db	$84,$72,$0c
	.db	$84,$71,$00
	.db	$82,$71,$0c
	.db	$82,$71,$0c
	.db	$ff
S11
	.db	$cb,$8b,$1e,$e1
	.db	$cc
	.db	$8b,$1b,$e1
	.db	$85,$1a,$e3
	.db	$81,$19,$8a,$1a,$e1
	.db	$8b,$1b,$e1
	.db	$85,$1f,$e3

	.db	$8b,$1e,$e1
	.db	$8b,$1b,$e1
	.db	$85,$1a,$e3
	.db	$81,$19,$96,$1a,$e1
	.db	$85,$1f,$e3

	.db	$8b,$1d,$e1
	.db	$8b,$1b,$e1
	.db	$85,$1a,$e3
	.db	$81,$17,$8a,$18,$e1
	.db	$8b,$1a,$e1
	.db	$85,$1b,$e3

	.db	$8b,$18,$e1
	.db	$8b,$1a,$e1
	.db	$85,$1b,$e3

	.db	$81,$1e,$9e,$1f,$e1
	.db	$ff
S12
	.db	$c1,$84,$73,0
	.db	$c0,$84,$72,$0c
	.db	$c1,$84,$73,0
	.db	$c0,$84,$72,$0c
	.db	$c1,$84,$73,0
	.db	$c0,$84,$72,$0c
	.db	$c1,$84,$73,0
	.db	$c0,$84,$72,$0c
	.db	$ff
S13
	.db	$c9,$84,$79,$33
	.db	$84,$32
	.db	$84,$2b
	.db	$84,$27
	.db	$84,$26
	.db	$84,$1f
	.db	$84,$1b
	.db	$84,$1a
	.db	$98,$13,$e8
	.db	$84,$13
	.db	$84,$18
	.db	$84,$1a
	.db	$84,$1b
	.db	$84,$1f
	.db	$84,$24
	.db	$84,$26
	.db	$84,$27
	.db	$98,$2b,$e8

	.db	$84,$33
	.db	$84,$32
	.db	$84,$2c
	.db	$84,$27
	.db	$84,$26
	.db	$84,$20
	.db	$84,$1b
	.db	$84,$1a
	.db	$98,$14,$e8

	.db	$84,$14
	.db	$84,$18
	.db	$84,$1a
	.db	$84,$1b
	.db	$84,$20
	.db	$84,$24
	.db	$84,$26
	.db	$84,$27
	.db	$98,$2c,$e8

	.db	$84,$32
	.db	$84,$30
	.db	$84,$29
	.db	$84,$26
	.db	$84,$24
	.db	$84,$1d
	.db	$84,$1a
	.db	$84,$18
	.db	$98,$11,$e8

	.db	$84,$11
	.db	$84,$16
	.db	$84,$18
	.db	$84,$1a
	.db	$84,$1d
	.db	$84,$22
	.db	$84,$24
	.db	$84,$26
	.db	$98,$29,$e8

	.db	$84,$30
	.db	$84,$2e
	.db	$84,$27
	.db	$84,$24
	.db	$84,$22
	.db	$84,$1b
	.db	$84,$18
	.db	$84,$16
	.db	$98,$0f,$e8

	.db	$84,$0f
	.db	$84,$13
	.db	$84,$17
	.db	$84,$1a
	.db	$84,$18
	.db	$84,$1b
	.db	$84,$1f
	.db	$84,$26
	.db	$98,$24
	.db	$ff
S15
	.db	$e8
	.db	$ff
S14
	.db     $c5,$84,$31,$31,$31,$31,$31,$31,$31,$31
	.db     $31,$31,$31,$31,$31,$31,$31
	.db     $c6,$84,$31
	.db     $ff

CLEARAUD	.DB	$00,$FE	;EMPTY SFX
S00	.DB	$E1
SEX	.DB	$FF


DIGIWAVE	.DB	$00,$00,$00,$00,$00,$00,$00,$2f
	.DB	$ff,$ff,$ff,$ff,$ff,$ff,$ff,$d0

;*************************************************************
;*              GAMEBOY AUDIO-DRIVER VARIABLES               *
;*************************************************************

;		SHOW	;	ILLEGAL! ON PURPOSE!



;*************************************************************
;*              GAMEBOY AUDIO-DRIVER VARIABLES               *
;*************************************************************

	.ORG	$c000	; RESERVED FOR DRIVER
                                                ; $FF00-aantal rambytes

VOICTEST1	.DB	$00
STPINDLO1	.DB	$00
STPINDHI1	.DB	$00
SEQINDLO1	.DB	$00
SEQINDHI1	.DB	$00
AUDIONUM1	.DB	$00
STEPNUMB1	.DB	$00
SPDCOUNT1	.DB	$00
SPDCHECK1	.DB	$00
REALPLAY1	.DB	$00
NOTEINIT1	.DB	$00
REALSOUN1	.DB	$00
SFXTRANS1	.DB	$00
LENGCOPY1	.DB	$00
REALLENG1	.DB	$00
REALNOTE1	.DB	$00
LOFRQWRD1	.DB	$00
HIFRQWRD1	.DB	$00
TRANBYTE1	.DB	$00
ARPINDEX1	.DB	$00
ARPNUMBO1	.DB	$00
ARPONOTO1	.DB	$00
GLDSPEED1	.DB	$00
GLDDIREC1	.DB	$00
GLDDELAY1	.DB	$00
DESTNOTE1	.DB	$00
VIBDELAY1	.DB	$00
VIBINDEX1	.DB	$00
AMPLITUD1	.DB	$00
AMPINDEX1	.DB	$00
FX01WORD1	.DB	$00
FX02WORD1	.DB	$00
FX03WORD1	.DB	$00
AMPLSAME1	.DB	$00
PULSVALU1	.DB	$00
PULINDEX1	.DB	$00

VOICTEST2	.DB	$00
STPINDLO2	.DB	$00
STPINDHI2	.DB	$00
SEQINDLO2	.DB	$00
SEQINDHI2	.DB	$00
AUDIONUM2	.DB	$00
STEPNUMB2	.DB	$00
SPDCOUNT2	.DB	$00
SPDCHECK2	.DB	$00
REALPLAY2	.DB	$00
NOTEINIT2	.DB	$00
REALSOUN2	.DB	$00
SFXTRANS2	.DB	$00
LENGCOPY2	.DB	$00
REALLENG2	.DB	$00
REALNOTE2	.DB	$00
LOFRQWRD2	.DB	$00
HIFRQWRD2	.DB	$00
TRANBYTE2	.DB	$00
ARPINDEX2	.DB	$00
ARPNUMBO2	.DB	$00
ARPONOTO2	.DB	$00
GLDSPEED2	.DB	$00
GLDDIREC2	.DB	$00
GLDDELAY2	.DB	$00
DESTNOTE2	.DB	$00
VIBDELAY2	.DB	$00
VIBINDEX2	.DB	$00
AMPLITUD2	.DB	$00
AMPINDEX2	.DB	$00
FX01WORD2	.DB	$00
FX02WORD2	.DB	$00
FX03WORD2	.DB	$00
AMPLSAME2	.DB	$00
PULSVALU2	.DB	$00
PULINDEX2	.DB	$00

VOICTEST3	.DB	$00
STPINDLO3	.DB	$00
STPINDHI3	.DB	$00
SEQINDLO3	.DB	$00
SEQINDHI3	.DB	$00
AUDIONUM3	.DB	$00
STEPNUMB3	.DB	$00
SPDCOUNT3	.DB	$00
SPDCHECK3	.DB	$00
REALPLAY3	.DB	$00
NOTEINIT3	.DB	$00
REALSOUN3	.DB	$00
SFXTRANS3	.DB	$00
LENGCOPY3	.DB	$00
REALLENG3	.DB	$00
REALNOTE3	.DB	$00
LOFRQWRD3	.DB	$00
HIFRQWRD3	.DB	$00
TRANBYTE3	.DB	$00
ARPINDEX3	.DB	$00
ARPNUMBO3	.DB	$00
ARPONOTO3	.DB	$00
GLDSPEED3	.DB	$00
GLDDIREC3	.DB	$00
GLDDELAY3	.DB	$00
DESTNOTE3	.DB	$00
VIBDELAY3	.DB	$00
VIBINDEX3	.DB	$00
AMPLITUD3	.DB	$00
AMPINDEX3	.DB	$00
FX01WORD3	.DB	$00
FX02WORD3	.DB	$00
FX03WORD3	.DB	$00
AMPLSAME3	.DB	$00

VOICTEST4	.DB	$00
STPINDLO4	.DB	$00
STPINDHI4	.DB	$00
SEQINDLO4	.DB	$00
SEQINDHI4	.DB	$00
AUDIONUM4	.DB	$00
STEPNUMB4	.DB	$00
SPDCOUNT4	.DB	$00
SPDCHECK4	.DB	$00
REALPLAY4	.DB	$00
NOTEINIT4	.DB	$00
REALSOUN4	.DB	$00
LENGCOPY4	.DB	$00
REALLENG4	.DB	$00
REALNOTE4	.DB	$00
ARPINDEX4	.DB	$00
ARPNUMBO4	.DB	$00
ARPONOTO4	.DB	$00
AMPLITUD4	.DB	$00
AMPINDEX4	.DB	$00
FX01WORD4	.DB	$00
FX03WORD4	.DB	$00
AMPLSAME4	.DB	$00


;****************************************
;*         END OF PROGRAM
;****************************************
	.ORG	10000h	; zorgt voor opvulling tot 64kB
	.END






